#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(BlendDisplayFilter_attr)
AttributeKey<Float> attrBlendAmt;
AttributeKey<Int> attrBlendType;
AttributeKey<SceneObject*> attrInput1;
AttributeKey<SceneObject*> attrInput2;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
BlendDisplayFilter_attr::attrBlendAmt = sceneClass.declareAttribute<Float>("blendAmt", 0.5, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(BlendDisplayFilter_attr::attrBlendAmt, "comment", "Float between [0,1] determining amount of blend between input1 and input2");
BlendDisplayFilter_attr::attrBlendType = sceneClass.declareAttribute<Int>("blendType", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(BlendDisplayFilter_attr::attrBlendType, 0, "linear");
sceneClass.setEnumValue(BlendDisplayFilter_attr::attrBlendType, 1, "cubic");
sceneClass.setMetadata(BlendDisplayFilter_attr::attrBlendType, "comment", "Method used to blend between input1 and input2.");
BlendDisplayFilter_attr::attrInput1 = sceneClass.declareAttribute<SceneObject*>("input1", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(BlendDisplayFilter_attr::attrInput1, "comment", "First RenderOutput to use in the blend operation");
BlendDisplayFilter_attr::attrInput2 = sceneClass.declareAttribute<SceneObject*>("input2", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(BlendDisplayFilter_attr::attrInput2, "comment", "Second RenderOutput to use in the blend operation");
BlendDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(BlendDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
BlendDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", BlendDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(BlendDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
BlendDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", BlendDisplayFilter_attr::attrMix);
sceneClass.setMetadata(BlendDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(BlendDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(BlendDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace BlendDisplayFilter_attr;
