#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ClampDisplayFilter_attr)
AttributeKey<SceneObject*> attrInput;
AttributeKey<Rgb> attrMin;
AttributeKey<Rgb> attrMax;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
ClampDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ClampDisplayFilter_attr::attrInput, "comment", "RenderOutput to clamp");
ClampDisplayFilter_attr::attrMin = sceneClass.declareAttribute<Rgb>("min", Rgb(0.0, 0.0, 0.0), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ClampDisplayFilter_attr::attrMin, "comment", "Minimum color value");
ClampDisplayFilter_attr::attrMax = sceneClass.declareAttribute<Rgb>("max", Rgb(1.0, 1.0, 1.0), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ClampDisplayFilter_attr::attrMax, "comment", "Maximum color value");
ClampDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ClampDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
ClampDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ClampDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(ClampDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
ClampDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ClampDisplayFilter_attr::attrMix);
sceneClass.setMetadata(ClampDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(ClampDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(ClampDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace ClampDisplayFilter_attr;
