#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ColorCorrectDisplayFilter_attr)
AttributeKey<SceneObject*> attrInput;
AttributeKey<Float> attrExposure;
AttributeKey<Float> attrSaturation;
AttributeKey<Float> attrContrast;
AttributeKey<Float> attrGamma;
AttributeKey<Rgb> attrOffset;
AttributeKey<Rgb> attrMultiply;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
ColorCorrectDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrInput, "comment", "RenderOutput to color correct");
ColorCorrectDisplayFilter_attr::attrExposure = sceneClass.declareAttribute<Float>("exposure", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrExposure, "comment", "Adjusts the exposure, in fstops");
ColorCorrectDisplayFilter_attr::attrSaturation = sceneClass.declareAttribute<Float>("saturation", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrSaturation, "comment", "Desaturates input below 1.0 and adds saturation above 1.0");
ColorCorrectDisplayFilter_attr::attrContrast = sceneClass.declareAttribute<Float>("contrast", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrContrast, "comment", "Negative values decrease contrast, while positive values increase it");
ColorCorrectDisplayFilter_attr::attrGamma = sceneClass.declareAttribute<Float>("gamma", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrGamma, "comment", "Adjusts gamma of input");
ColorCorrectDisplayFilter_attr::attrOffset = sceneClass.declareAttribute<Rgb>("offset", Rgb(0.f,0.f,0.f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrOffset, "comment", "Adds offset color to input");
ColorCorrectDisplayFilter_attr::attrMultiply = sceneClass.declareAttribute<Rgb>("multiply", Rgb(1.f,1.f,1.f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrMultiply, "comment", "Multiplies input using specified color");
ColorCorrectDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
ColorCorrectDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
ColorCorrectDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectDisplayFilter_attr::attrMix);
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(ColorCorrectDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace ColorCorrectDisplayFilter_attr;
