#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ConvolutionDisplayFilter_attr)
AttributeKey<Int> attrKernelType;
AttributeKey<SceneObject*> attrInput;
AttributeKey<Int> attrKernelSize;
AttributeKey<FloatVector> attrCustomKernel;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
ConvolutionDisplayFilter_attr::attrKernelType = sceneClass.declareAttribute<Int>("kernel_type", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ConvolutionDisplayFilter_attr::attrKernelType, 0, "gaussian");
sceneClass.setEnumValue(ConvolutionDisplayFilter_attr::attrKernelType, 1, "box");
sceneClass.setEnumValue(ConvolutionDisplayFilter_attr::attrKernelType, 2, "custom");
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrKernelType, "label", "kernel type");
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrKernelType, "comment", "Kernel to use for convolution.");
ConvolutionDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrInput, "comment", "RenderOutput to convolve");
ConvolutionDisplayFilter_attr::attrKernelSize = sceneClass.declareAttribute<Int>("kernel_size", 5, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrKernelSize, "label", "kernel size");
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrKernelSize, "comment", "Size of kernel in pixels. Size must be odd. If using a custom kernel, this attribute is ignored, and the size of the custom kernel is used instead.");
ConvolutionDisplayFilter_attr::attrCustomKernel = sceneClass.declareAttribute<FloatVector>("custom_kernel", FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrCustomKernel, "label", "custom kernel");
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrCustomKernel, "comment", "A list of kernel values for a custom filter. The number of values provided must be the square of an odd number (e.g. 3x3, 5x5, 7x7).");
ConvolutionDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
ConvolutionDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ConvolutionDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
ConvolutionDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ConvolutionDisplayFilter_attr::attrMix);
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(ConvolutionDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace ConvolutionDisplayFilter_attr;
