#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(DiscretizeDisplayFilter_attr)
AttributeKey<SceneObject*> attrInput;
AttributeKey<Int> attrNumBins;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
DiscretizeDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(DiscretizeDisplayFilter_attr::attrInput, "comment", "RenderOutput to discretize");
DiscretizeDisplayFilter_attr::attrNumBins = sceneClass.declareAttribute<Int>("num_bins", 8, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DiscretizeDisplayFilter_attr::attrNumBins, "comment", "Number of discrete color bins");
DiscretizeDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(DiscretizeDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
DiscretizeDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DiscretizeDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(DiscretizeDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
DiscretizeDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DiscretizeDisplayFilter_attr::attrMix);
sceneClass.setMetadata(DiscretizeDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(DiscretizeDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(DiscretizeDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace DiscretizeDisplayFilter_attr;
