#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(DofDisplayFilter_attr)
AttributeKey<SceneObject*> attrInput;
AttributeKey<SceneObject*> attrDepth;
AttributeKey<Bool> attrUseCameraAttributes;
AttributeKey<Float> attrAperture;
AttributeKey<Float> attrFocalLength;
AttributeKey<Float> attrFocusDistance;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
DofDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(DofDisplayFilter_attr::attrInput, "comment", "RenderOutput to which to apply depth of field");
DofDisplayFilter_attr::attrDepth = sceneClass.declareAttribute<SceneObject*>("depth", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(DofDisplayFilter_attr::attrDepth, "comment", "The 'depth' RenderOutput to sample z-depth values from");
DofDisplayFilter_attr::attrUseCameraAttributes = sceneClass.declareAttribute<Bool>("use_camera_attributes", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DofDisplayFilter_attr::attrUseCameraAttributes, "label", "use camera attributes");
sceneClass.setMetadata(DofDisplayFilter_attr::attrUseCameraAttributes, "comment", "Read dof attributes from the active scene camera");
DofDisplayFilter_attr::attrAperture = sceneClass.declareAttribute<Float>("aperture", 8.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DofDisplayFilter_attr::attrAperture, "comment", "Aperture in millimeters");
DofDisplayFilter_attr::attrFocalLength = sceneClass.declareAttribute<Float>("focal_length", 30.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DofDisplayFilter_attr::attrFocalLength, "label", "focal length");
sceneClass.setMetadata(DofDisplayFilter_attr::attrFocalLength, "comment", "Focal length in millimeters");
DofDisplayFilter_attr::attrFocusDistance = sceneClass.declareAttribute<Float>("focus_distance", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DofDisplayFilter_attr::attrFocusDistance, "label", "focus distance");
sceneClass.setMetadata(DofDisplayFilter_attr::attrFocusDistance, "comment", "Focus distance");
DofDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(DofDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
DofDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DofDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(DofDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
DofDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DofDisplayFilter_attr::attrMix);
sceneClass.setMetadata(DofDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(DofDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(DofDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace DofDisplayFilter_attr;
