#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(HalftoneDisplayFilter_attr)
AttributeKey<SceneObject*> attrInput;
AttributeKey<Int> attrSize;
AttributeKey<Float> attrFilterWidth;
AttributeKey<Bool> attrInvert;
AttributeKey<Bool> attrGrayscale;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
HalftoneDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrInput, "comment", "RenderOutput to be represented in halftone");
HalftoneDisplayFilter_attr::attrSize = sceneClass.declareAttribute<Int>("size", 5, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrSize, "comment", "The size in pixels of the halftone dots");
HalftoneDisplayFilter_attr::attrFilterWidth = sceneClass.declareAttribute<Float>("filter_width", 1.0, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrFilterWidth, "label", "filter width");
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrFilterWidth, "comment", "The width in pixels of the antialiasing");
HalftoneDisplayFilter_attr::attrInvert = sceneClass.declareAttribute<Bool>("invert", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrInvert, "comment", "Whether the dots should be black (normal) or white/color (inverted)");
HalftoneDisplayFilter_attr::attrGrayscale = sceneClass.declareAttribute<Bool>("grayscale", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrGrayscale, "comment", "Ignore color information, render as grayscale");
HalftoneDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
HalftoneDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", HalftoneDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
HalftoneDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", HalftoneDisplayFilter_attr::attrMix);
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(HalftoneDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace HalftoneDisplayFilter_attr;
