#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(RampDisplayFilter_attr)
AttributeKey<FloatVector> attrPositions;
AttributeKey<RgbVector> attrColors;
AttributeKey<Int> attrRampType;
AttributeKey<IntVector> attrInterpolations;
AttributeKey<SceneObject*> attrInput;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
RampDisplayFilter_attr::attrPositions = sceneClass.declareAttribute<FloatVector>("positions", {0.0, 0.25, 0.75, 1.0}, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Ramp Knot", RampDisplayFilter_attr::attrPositions);
sceneClass.setMetadata(RampDisplayFilter_attr::attrPositions, "comment", "List of ramp positions");
sceneClass.setMetadata(RampDisplayFilter_attr::attrPositions, "structure_type", "ramp_color");
sceneClass.setMetadata(RampDisplayFilter_attr::attrPositions, "structure_name", "ramp");
sceneClass.setMetadata(RampDisplayFilter_attr::attrPositions, "structure_path", "positions");
RampDisplayFilter_attr::attrColors = sceneClass.declareAttribute<RgbVector>("colors", {Rgb(0.0), Rgb(0.25), Rgb(0.75), Rgb(1.0)}, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Ramp Knot", RampDisplayFilter_attr::attrColors);
sceneClass.setMetadata(RampDisplayFilter_attr::attrColors, "comment", "List of ramp colors");
sceneClass.setMetadata(RampDisplayFilter_attr::attrColors, "structure_type", "ramp_color");
sceneClass.setMetadata(RampDisplayFilter_attr::attrColors, "structure_name", "ramp");
sceneClass.setMetadata(RampDisplayFilter_attr::attrColors, "structure_path", "values");
RampDisplayFilter_attr::attrRampType = sceneClass.declareAttribute<Int>("ramp_type", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Ramp properties", RampDisplayFilter_attr::attrRampType);
sceneClass.setEnumValue(RampDisplayFilter_attr::attrRampType, 0, "v_ramp");
sceneClass.setEnumValue(RampDisplayFilter_attr::attrRampType, 1, "u_ramp");
sceneClass.setEnumValue(RampDisplayFilter_attr::attrRampType, 2, "diagonal_ramp");
sceneClass.setEnumValue(RampDisplayFilter_attr::attrRampType, 3, "radial_ramp");
sceneClass.setEnumValue(RampDisplayFilter_attr::attrRampType, 4, "circular_ramp");
sceneClass.setEnumValue(RampDisplayFilter_attr::attrRampType, 5, "box_ramp");
sceneClass.setEnumValue(RampDisplayFilter_attr::attrRampType, 6, "uxv_ramp");
sceneClass.setEnumValue(RampDisplayFilter_attr::attrRampType, 7, "four_corner_ramp");
sceneClass.setEnumValue(RampDisplayFilter_attr::attrRampType, 8, "input_ramp");
sceneClass.setMetadata(RampDisplayFilter_attr::attrRampType, "comment", "Type of ramp");
RampDisplayFilter_attr::attrInterpolations = sceneClass.declareAttribute<IntVector>("interpolations", {0, 0, 0, 0}, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Ramp Knot", RampDisplayFilter_attr::attrInterpolations);
sceneClass.setMetadata(RampDisplayFilter_attr::attrInterpolations, "comment", "List of ramp interpolations.");
sceneClass.setMetadata(RampDisplayFilter_attr::attrInterpolations, "structure_type", "ramp_color");
sceneClass.setMetadata(RampDisplayFilter_attr::attrInterpolations, "structure_name", "ramp");
sceneClass.setMetadata(RampDisplayFilter_attr::attrInterpolations, "structure_path", "interpolation_types");
RampDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setGroup("Ramp properties", RampDisplayFilter_attr::attrInput);
sceneClass.setMetadata(RampDisplayFilter_attr::attrInput, "comment", "RenderOutput fed into the ramp");
RampDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(RampDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
RampDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", RampDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(RampDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
RampDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", RampDisplayFilter_attr::attrMix);
sceneClass.setMetadata(RampDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(RampDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(RampDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace RampDisplayFilter_attr;
