#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(RemapDisplayFilter_attr)
AttributeKey<Int> attrRemapMethod;
AttributeKey<SceneObject*> attrInput;
AttributeKey<Float> attrInMin;
AttributeKey<Float> attrInMax;
AttributeKey<Float> attrOutMin;
AttributeKey<Float> attrOutMax;
AttributeKey<Float> attrBias;
AttributeKey<Bool> attrClamp;
AttributeKey<Float> attrClampMin;
AttributeKey<Float> attrClampMax;
AttributeKey<Rgb> attrInMinRGB;
AttributeKey<Rgb> attrInMaxRGB;
AttributeKey<Rgb> attrOutMinRGB;
AttributeKey<Rgb> attrOutMaxRGB;
AttributeKey<Rgb> attrBiasRGB;
AttributeKey<Bool> attrClampRGB;
AttributeKey<Rgb> attrClampMinRGB;
AttributeKey<Rgb> attrClampMaxRGB;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
RemapDisplayFilter_attr::attrRemapMethod = sceneClass.declareAttribute<Int>("remap_method", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(RemapDisplayFilter_attr::attrRemapMethod, 0, "uniform");
sceneClass.setEnumValue(RemapDisplayFilter_attr::attrRemapMethod, 1, "RGB");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrRemapMethod, "label", "remap method");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrRemapMethod, "comment", "Choose whether you are remapping using single values (uniform) or with separate RGB channels");
RemapDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInput, "comment", "RenderOutput to remap");
RemapDisplayFilter_attr::attrInMin = sceneClass.declareAttribute<Float>("input_min", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"input min"});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMin, "label", "input min");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMin, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMin, "comment", "The input float that will be remapped to the 'output min' value");
RemapDisplayFilter_attr::attrInMax = sceneClass.declareAttribute<Float>("input_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"input max"});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMax, "label", "input max");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMax, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMax, "comment", "The input float that will be remapped to the 'output max' value");
RemapDisplayFilter_attr::attrOutMin = sceneClass.declareAttribute<Float>("output_min", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"output min"});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMin, "label", "output min");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMin, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMin, "comment", "The float that 'input min' will be remapped to");
RemapDisplayFilter_attr::attrOutMax = sceneClass.declareAttribute<Float>("output_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"output max"});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMax, "label", "output max");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMax, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMax, "comment", "The value that 'input max' will be remapped to");
RemapDisplayFilter_attr::attrBias = sceneClass.declareAttribute<Float>("midpoint_bias", 0.5f, FLAGS_NONE, INTERFACE_GENERIC, {"midpoint bias"});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrBias, "label", "midpoint bias");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrBias, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrBias, "comment", "Biases the in-between values toward 'output min' or 'output max'. Default = 0.5");
RemapDisplayFilter_attr::attrClamp = sceneClass.declareAttribute<Bool>("clamp", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClamp, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClamp, "comment", "Enables/disables clamping of the output values.  This is useful to prevent out-of-range values when expanding the input values.");
RemapDisplayFilter_attr::attrClampMin = sceneClass.declareAttribute<Float>("clamp_min", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"clamp min"});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMin, "label", "clamp min");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMin, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMin, "comment", "The minimum value output by this map when 'clamp' is enabled");
RemapDisplayFilter_attr::attrClampMax = sceneClass.declareAttribute<Float>("clamp_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"clamp max"});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMax, "label", "clamp max");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMax, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMax, "comment", "The maximum value output by this map when 'clamp' is enabled");
RemapDisplayFilter_attr::attrInMinRGB = sceneClass.declareAttribute<Rgb>("input_min_RGB", Rgb(0.f, 0.f, 0.f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapDisplayFilter_attr::attrInMinRGB);
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMinRGB, "label", "input min RGB");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMinRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMinRGB, "comment", "The input RGB value that will be remapped to the 'output min RGB' value");
RemapDisplayFilter_attr::attrInMaxRGB = sceneClass.declareAttribute<Rgb>("input_max_RGB", Rgb(1.f, 1.f, 1.f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapDisplayFilter_attr::attrInMaxRGB);
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMaxRGB, "label", "input max RGB");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMaxRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInMaxRGB, "comment", "The input RGB value that will be remapped to the 'output max RGB' value");
RemapDisplayFilter_attr::attrOutMinRGB = sceneClass.declareAttribute<Rgb>("output_min_RGB", Rgb(0.f, 0.f, 0.f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapDisplayFilter_attr::attrOutMinRGB);
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMinRGB, "label", "output min RGB");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMinRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMinRGB, "comment", "The RGB value that 'input min RGB' is remapped to");
RemapDisplayFilter_attr::attrOutMaxRGB = sceneClass.declareAttribute<Rgb>("output_max_RGB", Rgb(1.f, 1.f, 1.f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapDisplayFilter_attr::attrOutMaxRGB);
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMaxRGB, "label", "output max RGB");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMaxRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrOutMaxRGB, "comment", "The RGB value that 'input max RGB' is remapped to");
RemapDisplayFilter_attr::attrBiasRGB = sceneClass.declareAttribute<Rgb>("midpoint_bias_RGB", Rgb(0.5f, 0.5f, 0.5f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapDisplayFilter_attr::attrBiasRGB);
sceneClass.setMetadata(RemapDisplayFilter_attr::attrBiasRGB, "label", "midpoint bias RGB");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrBiasRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrBiasRGB, "comment", "Biases the in-between values toward 'output min RGB' or 'output max RGB'. Default = 0.5");
RemapDisplayFilter_attr::attrClampRGB = sceneClass.declareAttribute<Bool>("clamp_RGB", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampRGB, "label", "clamp RGB");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampRGB, "comment", "Enables/disables clamping of the RGB output values.  This useful prevent out-of-range values when expanding the input values.");
RemapDisplayFilter_attr::attrClampMinRGB = sceneClass.declareAttribute<Rgb>("clamp_min_RGB", Rgb(0.f, 0.f, 0.f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapDisplayFilter_attr::attrClampMinRGB);
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMinRGB, "label", "clamp min RGB");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMinRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMinRGB, "comment", "The minimum RGB value output by this map when 'clamp' is enabled");
RemapDisplayFilter_attr::attrClampMaxRGB = sceneClass.declareAttribute<Rgb>("clamp_max_RGB", Rgb(1.f, 1.f, 1.f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapDisplayFilter_attr::attrClampMaxRGB);
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMaxRGB, "label", "clamp max RGB");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMaxRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrClampMaxRGB, "comment", "The maximum RGB value output by this map when 'clamp' is enabled");
RemapDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(RemapDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
RemapDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", RemapDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(RemapDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
RemapDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", RemapDisplayFilter_attr::attrMix);
sceneClass.setMetadata(RemapDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(RemapDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace RemapDisplayFilter_attr;
