#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(RgbToFloatDisplayFilter_attr)
AttributeKey<SceneObject*> attrInput;
AttributeKey<Int> attrMode;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
RgbToFloatDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(RgbToFloatDisplayFilter_attr::attrInput, "comment", "RenderOutput to use in the RgbToFloat operation");
RgbToFloatDisplayFilter_attr::attrMode = sceneClass.declareAttribute<Int>("mode", 5, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(RgbToFloatDisplayFilter_attr::attrMode, 0, "r");
sceneClass.setEnumValue(RgbToFloatDisplayFilter_attr::attrMode, 1, "g");
sceneClass.setEnumValue(RgbToFloatDisplayFilter_attr::attrMode, 2, "b");
sceneClass.setEnumValue(RgbToFloatDisplayFilter_attr::attrMode, 3, "min");
sceneClass.setEnumValue(RgbToFloatDisplayFilter_attr::attrMode, 4, "max");
sceneClass.setEnumValue(RgbToFloatDisplayFilter_attr::attrMode, 5, "average");
sceneClass.setEnumValue(RgbToFloatDisplayFilter_attr::attrMode, 6, "sum");
sceneClass.setEnumValue(RgbToFloatDisplayFilter_attr::attrMode, 7, "luminance");
sceneClass.setMetadata(RgbToFloatDisplayFilter_attr::attrMode, "comment", "The method used to convert RGB Color to float");
RgbToFloatDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(RgbToFloatDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
RgbToFloatDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", RgbToFloatDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(RgbToFloatDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
RgbToFloatDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", RgbToFloatDisplayFilter_attr::attrMix);
sceneClass.setMetadata(RgbToFloatDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(RgbToFloatDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(RgbToFloatDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace RgbToFloatDisplayFilter_attr;
