#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(RgbToHsvDisplayFilter_attr)
AttributeKey<SceneObject*> attrInput;
AttributeKey<Int> attrMode;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
RgbToHsvDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(RgbToHsvDisplayFilter_attr::attrInput, "comment", "RenderOutput to use in the RgbToHsv operation");
RgbToHsvDisplayFilter_attr::attrMode = sceneClass.declareAttribute<Int>("mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(RgbToHsvDisplayFilter_attr::attrMode, 0, "rgb_to_hsv");
sceneClass.setEnumValue(RgbToHsvDisplayFilter_attr::attrMode, 1, "hsv_to_rgb");
sceneClass.setMetadata(RgbToHsvDisplayFilter_attr::attrMode, "comment", "Specifies whether you are converting rgb->hsv or hsv->rgb");
RgbToHsvDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(RgbToHsvDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
RgbToHsvDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", RgbToHsvDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(RgbToHsvDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
RgbToHsvDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", RgbToHsvDisplayFilter_attr::attrMix);
sceneClass.setMetadata(RgbToHsvDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(RgbToHsvDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(RgbToHsvDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace RgbToHsvDisplayFilter_attr;
