#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ShadowDisplayFilter_attr)
AttributeKey<SceneObject*> attrOccluded;
AttributeKey<SceneObject*> attrUnoccluded;
AttributeKey<Float> attrDensity;
AttributeKey<Rgb> attrShadowColor;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
ShadowDisplayFilter_attr::attrOccluded = sceneClass.declareAttribute<SceneObject*>("occluded", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ShadowDisplayFilter_attr::attrOccluded, "comment", "RenderOutput containing the occluded image");
ShadowDisplayFilter_attr::attrUnoccluded = sceneClass.declareAttribute<SceneObject*>("unoccluded", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ShadowDisplayFilter_attr::attrUnoccluded, "comment", "RenderOutput containing the unoccluded image");
ShadowDisplayFilter_attr::attrDensity = sceneClass.declareAttribute<Float>("density", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ShadowDisplayFilter_attr::attrDensity, "comment", "Blend value between occluded and unoccluded images. 1 = completely occluded. 0 = completely unoccluded.");
ShadowDisplayFilter_attr::attrShadowColor = sceneClass.declareAttribute<Rgb>("shadow_color", Rgb(0.0, 0.0, 0.0), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ShadowDisplayFilter_attr::attrShadowColor, "comment", "Color of the shadow");
RDL2_DSO_ATTR_END
using namespace ShadowDisplayFilter_attr;
