#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(TangentSpaceDisplayFilter_attr)
AttributeKey<Bool> attrNormalMapOutput;
AttributeKey<SceneObject*> attrInput;
AttributeKey<SceneObject*> attrNormal;
AttributeKey<SceneObject*> attrdPds;
AttributeKey<SceneObject*> attrMask;
AttributeKey<Bool> attrInvertMask;
AttributeKey<Float> attrMix;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
TangentSpaceDisplayFilter_attr::attrNormalMapOutput = sceneClass.declareAttribute<Bool>("normal_map_output", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(TangentSpaceDisplayFilter_attr::attrNormalMapOutput, "comment", "When on, encodes the output to clamped [0, 1] in the same manner as a normal map");
TangentSpaceDisplayFilter_attr::attrInput = sceneClass.declareAttribute<SceneObject*>("input", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(TangentSpaceDisplayFilter_attr::attrInput, "comment", "RenderOutput to transform into tangent space");
TangentSpaceDisplayFilter_attr::attrNormal = sceneClass.declareAttribute<SceneObject*>("N", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(TangentSpaceDisplayFilter_attr::attrNormal, "comment", "Connect a RenderOutput with State N AOV here. Used to construct tangent space.");
TangentSpaceDisplayFilter_attr::attrdPds = sceneClass.declareAttribute<SceneObject*>("dPds", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(TangentSpaceDisplayFilter_attr::attrdPds, "comment", "Connect a RenderOutput with State dPds AOV here. Used to construct tangent space.");
TangentSpaceDisplayFilter_attr::attrMask = sceneClass.declareAttribute<SceneObject*>("mask", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(TangentSpaceDisplayFilter_attr::attrMask, "comment", "RenderOutput used to mask the output, revealing input1");
TangentSpaceDisplayFilter_attr::attrInvertMask = sceneClass.declareAttribute<Bool>("invert_mask", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", TangentSpaceDisplayFilter_attr::attrInvertMask);
sceneClass.setMetadata(TangentSpaceDisplayFilter_attr::attrInvertMask, "comment", "Invert the value of the mask");
TangentSpaceDisplayFilter_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", TangentSpaceDisplayFilter_attr::attrMix);
sceneClass.setMetadata(TangentSpaceDisplayFilter_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(TangentSpaceDisplayFilter_attr::attrMix, "max", "1.0f");
sceneClass.setMetadata(TangentSpaceDisplayFilter_attr::attrMix, "comment", "Blend [0,1] between input and output");
RDL2_DSO_ATTR_END
using namespace TangentSpaceDisplayFilter_attr;
