#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ToonDisplayFilter_attr)
AttributeKey<SceneObject*> attrInputDiffuse;
AttributeKey<SceneObject*> attrInputGlossy;
AttributeKey<SceneObject*> attrInputAlbedo;
AttributeKey<SceneObject*> attrInputDepth;
AttributeKey<SceneObject*> attrInputNormal;
AttributeKey<Int> attrNumCels;
AttributeKey<Rgb> attrAmbient;
AttributeKey<Float> attrInkDepthThreshold;
AttributeKey<Float> attrInkNormalThreshold;
AttributeKey<Float> attrInkNormalScale;
AttributeKey<Int> attrEdgeDetector;
RDL2_DSO_ATTR_DEFINE(DisplayFilter)
ToonDisplayFilter_attr::attrInputDiffuse = sceneClass.declareAttribute<SceneObject*>("input_diffuse", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInputDiffuse, "label", "input diffuse");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInputDiffuse, "comment", "RenderOutput that represents diffuse reflection LPE");
ToonDisplayFilter_attr::attrInputGlossy = sceneClass.declareAttribute<SceneObject*>("input_glossy", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInputGlossy, "label", "input glossy");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInputGlossy, "comment", "RenderOutput that represents glossy reflection LPE");
ToonDisplayFilter_attr::attrInputAlbedo = sceneClass.declareAttribute<SceneObject*>("input_albedo", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInputAlbedo, "label", "input albedo");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInputAlbedo, "comment", "RenderOutput that represents diffuse albedo material aov");
ToonDisplayFilter_attr::attrInputDepth = sceneClass.declareAttribute<SceneObject*>("input_depth", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInputDepth, "label", "input depth");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInputDepth, "comment", "RenderOutput with 'depth' result");
ToonDisplayFilter_attr::attrInputNormal = sceneClass.declareAttribute<SceneObject*>("input_normal", FLAGS_NONE, INTERFACE_RENDEROUTPUT | INTERFACE_DISPLAYFILTER, {});
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInputNormal, "label", "input normal");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInputNormal, "comment", "RenderOutput with 'normal' result");
ToonDisplayFilter_attr::attrNumCels = sceneClass.declareAttribute<Int>("num_cels", 2, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ToonDisplayFilter_attr::attrNumCels, "label", "num cels");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrNumCels, "comment", "Sets number of toon cels in diffuse shading");
ToonDisplayFilter_attr::attrAmbient = sceneClass.declareAttribute<Rgb>("ambient", Rgb(0.0, 0.0, 0.0), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ToonDisplayFilter_attr::attrAmbient, "comment", "Adds an ambient light to the cel shading");
ToonDisplayFilter_attr::attrInkDepthThreshold = sceneClass.declareAttribute<Float>("ink_depth_threshold", 0.01, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInkDepthThreshold, "label", "ink depth threshold");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInkDepthThreshold, "comment", "The threshold for the depth-based ink outline");
ToonDisplayFilter_attr::attrInkNormalThreshold = sceneClass.declareAttribute<Float>("ink_normal_threshold", 0.01, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInkNormalThreshold, "label", "ink normal threshold");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInkNormalThreshold, "comment", "The threshold for the normal-based ink outline");
ToonDisplayFilter_attr::attrInkNormalScale = sceneClass.declareAttribute<Float>("ink_normal_scale", 0.01, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInkNormalScale, "label", "ink normal scale");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrInkNormalScale, "comment", "Increase for a more pronounced normal-based ink outline");
ToonDisplayFilter_attr::attrEdgeDetector = sceneClass.declareAttribute<Int>("edge_detector", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ToonDisplayFilter_attr::attrEdgeDetector, 0, "None");
sceneClass.setEnumValue(ToonDisplayFilter_attr::attrEdgeDetector, 1, "Sobel");
sceneClass.setEnumValue(ToonDisplayFilter_attr::attrEdgeDetector, 2, "Laplacian");
sceneClass.setEnumValue(ToonDisplayFilter_attr::attrEdgeDetector, 3, "Laplacian of Gaussian");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrEdgeDetector, "label", "edge detector");
sceneClass.setMetadata(ToonDisplayFilter_attr::attrEdgeDetector, "comment", "Type of edge detector to use");
RDL2_DSO_ATTR_END
using namespace ToonDisplayFilter_attr;
