#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(AxisAngleMap_attr)
AttributeKey<Vec3f> attrInputVector;
AttributeKey<Int> attrInputSpace;
AttributeKey<Vec3f> attrRotationAxis;
AttributeKey<Int> attrAxisSpace;
AttributeKey<Float> attrAngle;
AttributeKey<Int> attrOutputSpace;
RDL2_DSO_ATTR_DEFINE(Map)
AxisAngleMap_attr::attrInputVector = sceneClass.declareAttribute<Vec3f>("input_vector", Vec3f(0.0f, 0.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(AxisAngleMap_attr::attrInputVector, "label", "input vector");
sceneClass.setMetadata(AxisAngleMap_attr::attrInputVector, "comment", "input vector to be rotated");
AxisAngleMap_attr::attrInputSpace = sceneClass.declareAttribute<Int>("input_space", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(AxisAngleMap_attr::attrInputSpace, 0, "render");
sceneClass.setEnumValue(AxisAngleMap_attr::attrInputSpace, 1, "camera");
sceneClass.setEnumValue(AxisAngleMap_attr::attrInputSpace, 2, "world");
sceneClass.setEnumValue(AxisAngleMap_attr::attrInputSpace, 3, "screen");
sceneClass.setEnumValue(AxisAngleMap_attr::attrInputSpace, 4, "object");
sceneClass.setMetadata(AxisAngleMap_attr::attrInputSpace, "label", "input space");
sceneClass.setMetadata(AxisAngleMap_attr::attrInputSpace, "comment", "the space to transform from");
AxisAngleMap_attr::attrRotationAxis = sceneClass.declareAttribute<Vec3f>("rotation_axis", Vec3f(0.0f, 1.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(AxisAngleMap_attr::attrRotationAxis, "label", "rotation axis");
sceneClass.setMetadata(AxisAngleMap_attr::attrRotationAxis, "comment", "axis to be rotated around");
AxisAngleMap_attr::attrAxisSpace = sceneClass.declareAttribute<Int>("axis_space", 2, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(AxisAngleMap_attr::attrAxisSpace, 2, "world");
sceneClass.setEnumValue(AxisAngleMap_attr::attrAxisSpace, 4, "object");
sceneClass.setMetadata(AxisAngleMap_attr::attrAxisSpace, "label", "axis space");
sceneClass.setMetadata(AxisAngleMap_attr::attrAxisSpace, "comment", "the space of the axis to rotate about");
AxisAngleMap_attr::attrAngle = sceneClass.declareAttribute<Float>("angle", 0.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(AxisAngleMap_attr::attrAngle, "label", "angle");
sceneClass.setMetadata(AxisAngleMap_attr::attrAngle, "comment", "the angle of rotation in degrees");
AxisAngleMap_attr::attrOutputSpace = sceneClass.declareAttribute<Int>("output_space", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(AxisAngleMap_attr::attrOutputSpace, 0, "render");
sceneClass.setEnumValue(AxisAngleMap_attr::attrOutputSpace, 1, "camera");
sceneClass.setEnumValue(AxisAngleMap_attr::attrOutputSpace, 2, "world");
sceneClass.setEnumValue(AxisAngleMap_attr::attrOutputSpace, 3, "screen");
sceneClass.setEnumValue(AxisAngleMap_attr::attrOutputSpace, 4, "object");
sceneClass.setMetadata(AxisAngleMap_attr::attrOutputSpace, "label", "output space");
sceneClass.setMetadata(AxisAngleMap_attr::attrOutputSpace, "comment", "the space to transform the resulting vector to");
RDL2_DSO_ATTR_END
using namespace AxisAngleMap_attr;
