#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(BlendMap_attr)
AttributeKey<Rgb> attrColorA;
AttributeKey<Rgb> attrColorB;
AttributeKey<Int> attrBlendType;
AttributeKey<Float> attrBlendAmount;
AttributeKey<Float> attrThresholdMin;
AttributeKey<Float> attrThresholdMax;
RDL2_DSO_ATTR_DEFINE(Map)
BlendMap_attr::attrColorA = sceneClass.declareAttribute<Rgb>("color_A", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"color A"});
sceneClass.setMetadata(BlendMap_attr::attrColorA, "label", "color A");
sceneClass.setMetadata(BlendMap_attr::attrColorA, "comment", "The color you get if blend amount is 0");
BlendMap_attr::attrColorB = sceneClass.declareAttribute<Rgb>("color_B", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"color B"});
sceneClass.setMetadata(BlendMap_attr::attrColorB, "label", "color B");
sceneClass.setMetadata(BlendMap_attr::attrColorB, "comment", "The color you get if blend amount is 1");
BlendMap_attr::attrBlendType = sceneClass.declareAttribute<Int>("blend_type", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"blend type"});
sceneClass.setEnumValue(BlendMap_attr::attrBlendType, 0, "linear");
sceneClass.setEnumValue(BlendMap_attr::attrBlendType, 1, "cubic");
sceneClass.setMetadata(BlendMap_attr::attrBlendType, "label", "blend type");
sceneClass.setMetadata(BlendMap_attr::attrBlendType, "comment", "The type of blending algorithm");
BlendMap_attr::attrBlendAmount = sceneClass.declareAttribute<Float>("blend_amount", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"blend amount"});
sceneClass.setMetadata(BlendMap_attr::attrBlendAmount, "label", "blend amount");
sceneClass.setMetadata(BlendMap_attr::attrBlendAmount, "comment", "The amount to blend between color A (0) and color B (1)");
BlendMap_attr::attrThresholdMin = sceneClass.declareAttribute<Float>("threshold_min", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"threshold min"});
sceneClass.setMetadata(BlendMap_attr::attrThresholdMin, "label", "threshold min");
sceneClass.setMetadata(BlendMap_attr::attrThresholdMin, "min", "0.0f");
sceneClass.setMetadata(BlendMap_attr::attrThresholdMin, "max", "1.0f");
sceneClass.setMetadata(BlendMap_attr::attrThresholdMin, "comment", "If the blend amount is less than or equal to this amount, it will choose color A (0)");
BlendMap_attr::attrThresholdMax = sceneClass.declareAttribute<Float>("threshold_max", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"threshold max"});
sceneClass.setMetadata(BlendMap_attr::attrThresholdMax, "label", "threshold max");
sceneClass.setMetadata(BlendMap_attr::attrThresholdMax, "min", "0.0f");
sceneClass.setMetadata(BlendMap_attr::attrThresholdMax, "max", "1.0f");
sceneClass.setMetadata(BlendMap_attr::attrThresholdMax, "comment", "If the blend amount is greater than this amount, it will choose color B (1)");
RDL2_DSO_ATTR_END
using namespace BlendMap_attr;
