#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ClampMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Bool> attrClamp;
AttributeKey<Float> attrClampMin;
AttributeKey<Float> attrClampMax;
RDL2_DSO_ATTR_DEFINE(Map)
ClampMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ClampMap_attr::attrInput, "comment", "the input values to be remapped");
ClampMap_attr::attrClamp = sceneClass.declareAttribute<Bool>("clamp", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ClampMap_attr::attrClamp, "comment", "enables/disables clamping of the output values.  This useful prevent out-of-range values when expanding the input values.");
ClampMap_attr::attrClampMin = sceneClass.declareAttribute<Float>("clamp_min", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ClampMap_attr::attrClampMin, "label", "clamp min");
sceneClass.setMetadata(ClampMap_attr::attrClampMin, "comment", "the minimum value output by this map when 'clamp' is enabled");
sceneClass.setMetadata(ClampMap_attr::attrClampMin, "enable if", "OrderedDict({'clamp': 'true'})");
ClampMap_attr::attrClampMax = sceneClass.declareAttribute<Float>("clamp_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ClampMap_attr::attrClampMax, "label", "clamp max");
sceneClass.setMetadata(ClampMap_attr::attrClampMax, "comment", "the maximum value output by this map when 'clamp' is enabled");
sceneClass.setMetadata(ClampMap_attr::attrClampMax, "enable if", "OrderedDict({'clamp': 'true'})");
RDL2_DSO_ATTR_END
using namespace ClampMap_attr;
