#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ColorCorrectContrastMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Bool> attrOn;
AttributeKey<Float> attrMix;
AttributeKey<Float> attrContrast;
AttributeKey<Bool> attrContrastPerChannel;
AttributeKey<Float> attrContrastR;
AttributeKey<Float> attrContrastG;
AttributeKey<Float> attrContrastB;
RDL2_DSO_ATTR_DEFINE(Map)
ColorCorrectContrastMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrInput, "comment", "bind the input here");
ColorCorrectContrastMap_attr::attrOn = sceneClass.declareAttribute<Bool>("on", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrOn, "comment", "enables/disables all color correct operations");
ColorCorrectContrastMap_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrMix, "comment", "how much of the overall color correct to mix in");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrMix, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrMix, "max", "1.0f");
ColorCorrectContrastMap_attr::attrContrast = sceneClass.declareAttribute<Float>("contrast", 0.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrast, "comment", "negative values reduce the difference in luminance towards grey and positive values increase the difference in luminance");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrast, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_contrast': 'false'})");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrast, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrast, "max", "1.0f");
ColorCorrectContrastMap_attr::attrContrastPerChannel = sceneClass.declareAttribute<Bool>("use_per_channel_contrast", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastPerChannel, "label", "use per channel contrast");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastPerChannel, "comment", "enables separate RGB controls for contrast");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastPerChannel, "enable if", "OrderedDict({'on': 'true'})");
ColorCorrectContrastMap_attr::attrContrastR = sceneClass.declareAttribute<Float>("contrast_r", 0.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastR, "label", "contrast r");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastR, "comment", "negative values reduce the difference in luminance towards grey and positive values increase the difference in luminance for the red channel");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastR, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_contrast': 'true'})");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastR, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastR, "max", "1.0f");
ColorCorrectContrastMap_attr::attrContrastG = sceneClass.declareAttribute<Float>("contrast_g", 0.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastG, "label", "contrast g");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastG, "comment", "negative values reduce the difference in luminance towards grey and positive values increase the difference in luminance for the green channel");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastG, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_contrast': 'true'})");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastG, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastG, "max", "1.0f");
ColorCorrectContrastMap_attr::attrContrastB = sceneClass.declareAttribute<Float>("contrast_b", 0.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastB, "label", "contrast b");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastB, "comment", "negative values reduce the difference in luminance towards grey and positive values increase the difference in luminance for the blue channel");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastB, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_contrast': 'true'})");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastB, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectContrastMap_attr::attrContrastB, "max", "1.0f");
RDL2_DSO_ATTR_END
using namespace ColorCorrectContrastMap_attr;
