#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ColorCorrectGainOffsetMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Bool> attrOn;
AttributeKey<Float> attrMix;
AttributeKey<Float> attrGain;
AttributeKey<Float> attrOffset;
AttributeKey<Bool> attrGainOffsetPerChannel;
AttributeKey<Float> attrGainR;
AttributeKey<Float> attrGainG;
AttributeKey<Float> attrGainB;
AttributeKey<Float> attrOffsetR;
AttributeKey<Float> attrOffsetG;
AttributeKey<Float> attrOffsetB;
RDL2_DSO_ATTR_DEFINE(Map)
ColorCorrectGainOffsetMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrInput, "comment", "bind the input here");
ColorCorrectGainOffsetMap_attr::attrOn = sceneClass.declareAttribute<Bool>("on", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOn, "comment", "enables/disables all color correct operations");
ColorCorrectGainOffsetMap_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrMix, "comment", "how much of the overall color correct to mix in");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrMix, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrMix, "max", "1.0f");
ColorCorrectGainOffsetMap_attr::attrGain = sceneClass.declareAttribute<Float>("gain", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGain, "comment", "multiplies the input channels by the specified values");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGain, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gain_offset': 'false'})");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGain, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGain, "max", "4.0f");
ColorCorrectGainOffsetMap_attr::attrOffset = sceneClass.declareAttribute<Float>("offset", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffset, "comment", "adds the specified values to the input");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffset, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gain_offset': 'false'})");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffset, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffset, "max", "1.0f");
ColorCorrectGainOffsetMap_attr::attrGainOffsetPerChannel = sceneClass.declareAttribute<Bool>("use_per_channel_gain_offset", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainOffsetPerChannel, "label", "use per channel gain offset");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainOffsetPerChannel, "comment", "enables separate RGB controls for gain and offset");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainOffsetPerChannel, "enable if", "OrderedDict({'on': 'true'})");
ColorCorrectGainOffsetMap_attr::attrGainR = sceneClass.declareAttribute<Float>("gain_r", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainR, "label", "gain r");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainR, "comment", "multiplies the red channel by the specified values");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainR, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainR, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainR, "max", "4.0f");
ColorCorrectGainOffsetMap_attr::attrGainG = sceneClass.declareAttribute<Float>("gain_g", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainG, "label", "gain g");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainG, "comment", "multiplies the green channel by the specified values");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainG, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainG, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainG, "max", "4.0f");
ColorCorrectGainOffsetMap_attr::attrGainB = sceneClass.declareAttribute<Float>("gain_b", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainB, "label", "gain b");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainB, "comment", "multiplies the blue channel by the specified values");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainB, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainB, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrGainB, "max", "4.0f");
ColorCorrectGainOffsetMap_attr::attrOffsetR = sceneClass.declareAttribute<Float>("offset_r", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetR, "label", "offset r");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetR, "comment", "adds the specified values to the red channel");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetR, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetR, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetR, "max", "1.0f");
ColorCorrectGainOffsetMap_attr::attrOffsetG = sceneClass.declareAttribute<Float>("offset_g", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetG, "label", "offset g");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetG, "comment", "adds the specified values to the green channel");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetG, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetG, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetG, "max", "1.0f");
ColorCorrectGainOffsetMap_attr::attrOffsetB = sceneClass.declareAttribute<Float>("offset_b", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetB, "label", "offset b");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetB, "comment", "adds the specified values to the blue channel");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetB, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetB, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectGainOffsetMap_attr::attrOffsetB, "max", "1.0f");
RDL2_DSO_ATTR_END
using namespace ColorCorrectGainOffsetMap_attr;
