#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ColorCorrectGammaMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Bool> attrOn;
AttributeKey<Float> attrMix;
AttributeKey<Float> attrGamma;
AttributeKey<Bool> attrGammaPerChannel;
AttributeKey<Float> attrGammaR;
AttributeKey<Float> attrGammaG;
AttributeKey<Float> attrGammaB;
RDL2_DSO_ATTR_DEFINE(Map)
ColorCorrectGammaMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrInput, "comment", "bind the input here");
ColorCorrectGammaMap_attr::attrOn = sceneClass.declareAttribute<Bool>("on", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrOn, "comment", "enables/disables all color correct operations");
ColorCorrectGammaMap_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrMix, "comment", "how much of the overall color correct to mix in");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrMix, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrMix, "max", "1.0f");
ColorCorrectGammaMap_attr::attrGamma = sceneClass.declareAttribute<Float>("gamma", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGamma, "comment", "raises the input to the specified exponents");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGamma, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gamma': 'false'})");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGamma, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGamma, "max", "4.0f");
ColorCorrectGammaMap_attr::attrGammaPerChannel = sceneClass.declareAttribute<Bool>("use_per_channel_gamma", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaPerChannel, "label", "use per channel gamma");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaPerChannel, "comment", "enables separate RGB controls for gamma");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaPerChannel, "enable if", "OrderedDict({'on': 'true'})");
ColorCorrectGammaMap_attr::attrGammaR = sceneClass.declareAttribute<Float>("gamma_r", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaR, "label", "gamma r");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaR, "comment", "raises the red channel to the specified exponents");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaR, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gamma': 'true'})");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaR, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaR, "max", "4.0f");
ColorCorrectGammaMap_attr::attrGammaG = sceneClass.declareAttribute<Float>("gamma_g", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaG, "label", "gamma g");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaG, "comment", "raises the green channel to the specified exponents");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaG, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gamma': 'true'})");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaG, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaG, "max", "4.0f");
ColorCorrectGammaMap_attr::attrGammaB = sceneClass.declareAttribute<Float>("gamma_b", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaB, "label", "gamma b");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaB, "comment", "raises the blue channel to the specified exponents");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaB, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_gamma': 'true'})");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaB, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectGammaMap_attr::attrGammaB, "max", "4.0f");
RDL2_DSO_ATTR_END
using namespace ColorCorrectGammaMap_attr;
