#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ColorCorrectHsvMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Bool> attrOn;
AttributeKey<Float> attrHueShift;
AttributeKey<Float> attrSaturationFactor;
AttributeKey<Float> attrSaturationContrast;
AttributeKey<Float> attrSaturationShift;
AttributeKey<Float> attrValueFactor;
AttributeKey<Float> attrValueContrast;
AttributeKey<Float> attrValueShift;
AttributeKey<Bool> attrClamp;
RDL2_DSO_ATTR_DEFINE(Map)
ColorCorrectHsvMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrInput, "comment", "input color");
ColorCorrectHsvMap_attr::attrOn = sceneClass.declareAttribute<Bool>("on", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrOn, "comment", "all attributes on/off");
ColorCorrectHsvMap_attr::attrHueShift = sceneClass.declareAttribute<Float>("hue_shift", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"hue shift"});
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrHueShift, "label", "hue shift");
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrHueShift, "comment", "shifts the hue of the input (360 rolls over back to 0)");
ColorCorrectHsvMap_attr::attrSaturationFactor = sceneClass.declareAttribute<Float>("saturation_factor", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"saturation factor"});
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrSaturationFactor, "label", "saturation factor");
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrSaturationFactor, "comment", "multiplies the saturation of the input");
ColorCorrectHsvMap_attr::attrSaturationContrast = sceneClass.declareAttribute<Float>("saturation_contrast", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"saturation contrast"});
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrSaturationContrast, "label", "saturation contrast");
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrSaturationContrast, "comment", "modifies the contrast of the input's saturation (-1, 1)");
ColorCorrectHsvMap_attr::attrSaturationShift = sceneClass.declareAttribute<Float>("saturation_shift", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"saturation shift"});
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrSaturationShift, "label", "saturation shift");
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrSaturationShift, "comment", "shifts the saturation of the input (-1, 1)");
ColorCorrectHsvMap_attr::attrValueFactor = sceneClass.declareAttribute<Float>("value_factor", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"value factor"});
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrValueFactor, "label", "value factor");
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrValueFactor, "comment", "multiplies the value of the input");
ColorCorrectHsvMap_attr::attrValueContrast = sceneClass.declareAttribute<Float>("value_contrast", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"value contrast"});
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrValueContrast, "label", "value contrast");
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrValueContrast, "comment", "modifies the contrast of the input's value (-1, 1)");
ColorCorrectHsvMap_attr::attrValueShift = sceneClass.declareAttribute<Float>("value_shift", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"value shift"});
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrValueShift, "label", "value shift");
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrValueShift, "comment", "shifts the value of the input (-1, 1)");
ColorCorrectHsvMap_attr::attrClamp = sceneClass.declareAttribute<Bool>("clamp", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectHsvMap_attr::attrClamp, "comment", "clamps output to [0,1] range");
RDL2_DSO_ATTR_END
using namespace ColorCorrectHsvMap_attr;
