#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ColorCorrectHueShiftMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Bool> attrOn;
AttributeKey<Float> attrMix;
AttributeKey<Float> attrHueShift;
RDL2_DSO_ATTR_DEFINE(Map)
ColorCorrectHueShiftMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrInput, "comment", "bind the input here");
ColorCorrectHueShiftMap_attr::attrOn = sceneClass.declareAttribute<Bool>("on", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrOn, "comment", "enables/disables all color correct operations");
ColorCorrectHueShiftMap_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrMix, "comment", "how much of the overall color correct to mix in");
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrMix, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrMix, "max", "1.0f");
ColorCorrectHueShiftMap_attr::attrHueShift = sceneClass.declareAttribute<Float>("hue_shift", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrHueShift, "label", "hue shift");
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrHueShift, "comment", "shifts the hue of the input (spectrum range is 0-1)");
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrHueShift, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrHueShift, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectHueShiftMap_attr::attrHueShift, "max", "1.0f");
RDL2_DSO_ATTR_END
using namespace ColorCorrectHueShiftMap_attr;
