#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ColorCorrectMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Bool> attrOn;
AttributeKey<Float> attrMix;
AttributeKey<Bool> attrClamp;
AttributeKey<Float> attrClampMin;
AttributeKey<Float> attrClampMax;
AttributeKey<Bool> attrHueShiftEnabled;
AttributeKey<Float> attrHueShift;
AttributeKey<Bool> attrSaturationEnabled;
AttributeKey<Float> attrSaturation;
AttributeKey<Bool> attrContrastEnabled;
AttributeKey<Float> attrContrast;
AttributeKey<Bool> attrGammaEnabled;
AttributeKey<Float> attrGamma;
AttributeKey<Bool> attrGainOffsetEnabled;
AttributeKey<Float> attrGain;
AttributeKey<Float> attrOffset;
AttributeKey<Bool> attrTMIControlEnabled;
AttributeKey<Rgb> attrTMI;
AttributeKey<Bool> attrSaturationPerChannel;
AttributeKey<Float> attrSaturationR;
AttributeKey<Float> attrSaturationG;
AttributeKey<Float> attrSaturationB;
AttributeKey<Bool> attrContrastPerChannel;
AttributeKey<Float> attrContrastR;
AttributeKey<Float> attrContrastG;
AttributeKey<Float> attrContrastB;
AttributeKey<Bool> attrGammaPerChannel;
AttributeKey<Float> attrGammaR;
AttributeKey<Float> attrGammaG;
AttributeKey<Float> attrGammaB;
AttributeKey<Bool> attrGainOffsetPerChannel;
AttributeKey<Float> attrGainR;
AttributeKey<Float> attrGainG;
AttributeKey<Float> attrGainB;
AttributeKey<Float> attrOffsetR;
AttributeKey<Float> attrOffsetG;
AttributeKey<Float> attrOffsetB;
RDL2_DSO_ATTR_DEFINE(Map)
ColorCorrectMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrInput, "comment", "bind the input here");
ColorCorrectMap_attr::attrOn = sceneClass.declareAttribute<Bool>("on", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrOn, "comment", "enables/disables all color correct operations");
ColorCorrectMap_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrMix, "comment", "how much of the overall color correct to mix in");
sceneClass.setMetadata(ColorCorrectMap_attr::attrMix, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrMix, "max", "1.0f");
ColorCorrectMap_attr::attrClamp = sceneClass.declareAttribute<Bool>("clamp", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrClamp, "comment", "enables/disables clamping of the output values.");
ColorCorrectMap_attr::attrClampMin = sceneClass.declareAttribute<Float>("clamp_min", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrClampMin, "label", "clamp min");
sceneClass.setMetadata(ColorCorrectMap_attr::attrClampMin, "comment", "the minimum value output by this map when 'clamp' is enabled");
sceneClass.setMetadata(ColorCorrectMap_attr::attrClampMin, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrClampMin, "max", "1.0f");
ColorCorrectMap_attr::attrClampMax = sceneClass.declareAttribute<Float>("clamp_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrClampMax, "label", "clamp max");
sceneClass.setMetadata(ColorCorrectMap_attr::attrClampMax, "comment", "the maximum value output by this map when 'clamp' is enabled");
sceneClass.setMetadata(ColorCorrectMap_attr::attrClampMax, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrClampMax, "max", "1.0f");
ColorCorrectMap_attr::attrHueShiftEnabled = sceneClass.declareAttribute<Bool>("hue_shift_enabled", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrHueShiftEnabled, "label", "hue shift enabled");
sceneClass.setMetadata(ColorCorrectMap_attr::attrHueShiftEnabled, "comment", "enables the hue_shift parameter");
sceneClass.setMetadata(ColorCorrectMap_attr::attrHueShiftEnabled, "enable if", "OrderedDict({'on': 'true'})");
ColorCorrectMap_attr::attrHueShift = sceneClass.declareAttribute<Float>("hue_shift", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrHueShift, "label", "hue shift");
sceneClass.setMetadata(ColorCorrectMap_attr::attrHueShift, "comment", "shifts the hue of the input (spectrum range is 0-1)");
sceneClass.setMetadata(ColorCorrectMap_attr::attrHueShift, "enable if", "OrderedDict({'on': 'true', 'hue_shift_enabled': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrHueShift, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrHueShift, "max", "1.0f");
ColorCorrectMap_attr::attrSaturationEnabled = sceneClass.declareAttribute<Bool>("saturation_enabled", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationEnabled, "label", "saturation enabled");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationEnabled, "comment", "enables the saturation parameter");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationEnabled, "enable if", "OrderedDict({'on': 'true'})");
ColorCorrectMap_attr::attrSaturation = sceneClass.declareAttribute<Float>("saturation", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturation, "comment", "desaturates the input below 1.0 and adds saturation above 1.0");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturation, "enable if", "OrderedDict({'on': 'true', 'saturation_enabled': 'true', 'use_per_channel_saturation': 'false'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturation, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturation, "max", "4.0f");
ColorCorrectMap_attr::attrContrastEnabled = sceneClass.declareAttribute<Bool>("contrast_enabled", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastEnabled, "label", "contrast enabled");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastEnabled, "comment", "enables the contrast parameter");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastEnabled, "enable if", "OrderedDict({'on': 'true'})");
ColorCorrectMap_attr::attrContrast = sceneClass.declareAttribute<Float>("contrast", 0.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrast, "comment", "negative values reduce the difference in luminance towards grey and positive values increase the difference in luminance");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrast, "enable if", "OrderedDict({'on': 'true', 'contrast_enabled': 'true', 'use_per_channel_contrast': 'false'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrast, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrast, "max", "1.0f");
ColorCorrectMap_attr::attrGammaEnabled = sceneClass.declareAttribute<Bool>("gamma_enabled", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaEnabled, "label", "gamma enabled");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaEnabled, "comment", "enables the gamma parameter");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaEnabled, "enable if", "OrderedDict({'on': 'true'})");
ColorCorrectMap_attr::attrGamma = sceneClass.declareAttribute<Float>("gamma", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrGamma, "comment", "raises the input to the specified exponents");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGamma, "enable if", "OrderedDict({'on': 'true', 'gamma_enabled': 'true', 'use_per_channel_gamma': 'false'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGamma, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGamma, "max", "4.0f");
ColorCorrectMap_attr::attrGainOffsetEnabled = sceneClass.declareAttribute<Bool>("gain_offset_enabled", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainOffsetEnabled, "label", "gain offset enabled");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainOffsetEnabled, "comment", "enables the gain and offset parameters");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainOffsetEnabled, "enable if", "OrderedDict({'on': 'true'})");
ColorCorrectMap_attr::attrGain = sceneClass.declareAttribute<Float>("gain", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrGain, "comment", "multiplies the input channels by the specified values");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGain, "enable if", "OrderedDict({'on': 'true', 'gain_offset_enabled': 'true', 'use_per_channel_gain_offset': 'false'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGain, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGain, "max", "4.0f");
ColorCorrectMap_attr::attrOffset = sceneClass.declareAttribute<Float>("offset", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffset, "comment", "adds the specified values to the input");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffset, "enable if", "OrderedDict({'on': 'true', 'gain_offset_enabled': 'true', 'use_per_channel_gain_offset': 'false'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffset, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffset, "max", "1.0f");
ColorCorrectMap_attr::attrTMIControlEnabled = sceneClass.declareAttribute<Bool>("TMI_enabled", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrTMIControlEnabled, "label", "TMI enabled");
sceneClass.setMetadata(ColorCorrectMap_attr::attrTMIControlEnabled, "comment", "enables the TMI parameters");
sceneClass.setMetadata(ColorCorrectMap_attr::attrTMIControlEnabled, "enable if", "OrderedDict({'on': 'true'})");
ColorCorrectMap_attr::attrTMI = sceneClass.declareAttribute<Rgb>("TMI", Rgb(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectMap_attr::attrTMI, "display", "tmi");
sceneClass.setMetadata(ColorCorrectMap_attr::attrTMI, "comment", "T = Temperature where positive values push towards blue and negative towards red.   M = Magenta where positive values push towards magenta and negative towards green.  I = Intensity where negative values remove and positive values add energy ");
sceneClass.setMetadata(ColorCorrectMap_attr::attrTMI, "enable if", "OrderedDict({'on': 'true', 'TMI_enabled': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrTMI, "min", "-2.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrTMI, "max", "2.0f");
ColorCorrectMap_attr::attrSaturationPerChannel = sceneClass.declareAttribute<Bool>("use_per_channel_saturation", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrSaturationPerChannel);
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationPerChannel, "label", "use per channel saturation");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationPerChannel, "comment", "enables separate RGB controls for saturation");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationPerChannel, "enable if", "OrderedDict({'on': 'true', 'saturation_enabled': 'true'})");
ColorCorrectMap_attr::attrSaturationR = sceneClass.declareAttribute<Float>("saturation_r", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrSaturationR);
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationR, "label", "saturation r");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationR, "comment", "desaturates the red channel input below 1.0 and adds saturation above 1.0");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationR, "enable if", "OrderedDict({'on': 'true', 'saturation_enabled': 'true', 'use_per_channel_saturation': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationR, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationR, "max", "4.0f");
ColorCorrectMap_attr::attrSaturationG = sceneClass.declareAttribute<Float>("saturation_g", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrSaturationG);
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationG, "label", "saturation g");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationG, "comment", "desaturates the green channel input below 1.0 and adds saturation above 1.0");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationG, "enable if", "OrderedDict({'on': 'true', 'saturation_enabled': 'true', 'use_per_channel_saturation': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationG, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationG, "max", "4.0f");
ColorCorrectMap_attr::attrSaturationB = sceneClass.declareAttribute<Float>("saturation_b", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrSaturationB);
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationB, "label", "saturation b");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationB, "comment", "desaturates the blue channel input below 1.0 and adds saturation above 1.0");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationB, "enable if", "OrderedDict({'on': 'true', 'saturation_enabled': 'true', 'use_per_channel_saturation': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationB, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrSaturationB, "max", "4.0f");
ColorCorrectMap_attr::attrContrastPerChannel = sceneClass.declareAttribute<Bool>("use_per_channel_contrast", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrContrastPerChannel);
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastPerChannel, "label", "use per channel contrast");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastPerChannel, "comment", "enables separate RGB controls for contrast");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastPerChannel, "enable if", "OrderedDict({'on': 'true', 'contrast_enabled': 'true'})");
ColorCorrectMap_attr::attrContrastR = sceneClass.declareAttribute<Float>("contrast_r", 0.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrContrastR);
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastR, "label", "contrast r");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastR, "comment", "negative values reduce the difference in luminance towards grey and positive values increase the difference in luminance for the red channel");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastR, "enable if", "OrderedDict({'on': 'true', 'contrast_enabled': 'true', 'use_per_channel_contrast': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastR, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastR, "max", "1.0f");
ColorCorrectMap_attr::attrContrastG = sceneClass.declareAttribute<Float>("contrast_g", 0.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrContrastG);
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastG, "label", "contrast g");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastG, "comment", "negative values reduce the difference in luminance towards grey and positive values increase the difference in luminance for the green channel");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastG, "enable if", "OrderedDict({'on': 'true', 'contrast_enabled': 'true', 'use_per_channel_contrast': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastG, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastG, "max", "1.0f");
ColorCorrectMap_attr::attrContrastB = sceneClass.declareAttribute<Float>("contrast_b", 0.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrContrastB);
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastB, "label", "contrast b");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastB, "comment", "negative values reduce the difference in luminance towards grey and positive values increase the difference in luminance for the blue channel");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastB, "enable if", "OrderedDict({'on': 'true', 'contrast_enabled': 'true', 'use_per_channel_contrast': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastB, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrContrastB, "max", "1.0f");
ColorCorrectMap_attr::attrGammaPerChannel = sceneClass.declareAttribute<Bool>("use_per_channel_gamma", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrGammaPerChannel);
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaPerChannel, "label", "use per channel gamma");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaPerChannel, "comment", "enables separate RGB controls for gamma");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaPerChannel, "enable if", "OrderedDict({'on': 'true', 'gamma_enabled': 'true'})");
ColorCorrectMap_attr::attrGammaR = sceneClass.declareAttribute<Float>("gamma_r", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrGammaR);
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaR, "label", "gamma r");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaR, "comment", "raises the red channel to the specified exponents");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaR, "enable if", "OrderedDict({'on': 'true', 'gamma_enabled': 'true', 'use_per_channel_gamma': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaR, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaR, "max", "4.0f");
ColorCorrectMap_attr::attrGammaG = sceneClass.declareAttribute<Float>("gamma_g", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrGammaG);
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaG, "label", "gamma g");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaG, "comment", "raises the green channel to the specified exponents");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaG, "enable if", "OrderedDict({'on': 'true', 'gamma_enabled': 'true', 'use_per_channel_gamma': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaG, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaG, "max", "4.0f");
ColorCorrectMap_attr::attrGammaB = sceneClass.declareAttribute<Float>("gamma_b", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrGammaB);
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaB, "label", "gamma b");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaB, "comment", "raises the blue channel to the specified exponents");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaB, "enable if", "OrderedDict({'on': 'true', 'gamma_enabled': 'true', 'use_per_channel_gamma': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaB, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGammaB, "max", "4.0f");
ColorCorrectMap_attr::attrGainOffsetPerChannel = sceneClass.declareAttribute<Bool>("use_per_channel_gain_offset", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrGainOffsetPerChannel);
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainOffsetPerChannel, "label", "use per channel gain offset");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainOffsetPerChannel, "comment", "enables separate RGB controls for gain and offset");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainOffsetPerChannel, "enable if", "OrderedDict({'on': 'true', 'gain_offset_enabled': 'true'})");
ColorCorrectMap_attr::attrGainR = sceneClass.declareAttribute<Float>("gain_r", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrGainR);
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainR, "label", "gain r");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainR, "comment", "multiplies the red channel by the specified values");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainR, "enable if", "OrderedDict({'on': 'true', 'gain_offset_enabled': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainR, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainR, "max", "4.0f");
ColorCorrectMap_attr::attrGainG = sceneClass.declareAttribute<Float>("gain_g", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrGainG);
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainG, "label", "gain g");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainG, "comment", "multiplies the green channel by the specified values");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainG, "enable if", "OrderedDict({'on': 'true', 'gain_offset_enabled': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainG, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainG, "max", "4.0f");
ColorCorrectMap_attr::attrGainB = sceneClass.declareAttribute<Float>("gain_b", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrGainB);
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainB, "label", "gain b");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainB, "comment", "multiplies the blue channel by the specified values");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainB, "enable if", "OrderedDict({'on': 'true', 'gain_offset_enabled': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainB, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrGainB, "max", "4.0f");
ColorCorrectMap_attr::attrOffsetR = sceneClass.declareAttribute<Float>("offset_r", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrOffsetR);
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetR, "label", "offset r");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetR, "comment", "adds the specified values to the red channel");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetR, "enable if", "OrderedDict({'on': 'true', 'gain_offset_enabled': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetR, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetR, "max", "1.0f");
ColorCorrectMap_attr::attrOffsetG = sceneClass.declareAttribute<Float>("offset_g", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrOffsetG);
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetG, "label", "offset g");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetG, "comment", "adds the specified values to the green channel");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetG, "enable if", "OrderedDict({'on': 'true', 'gain_offset_enabled': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetG, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetG, "max", "1.0f");
ColorCorrectMap_attr::attrOffsetB = sceneClass.declareAttribute<Float>("offset_b", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", ColorCorrectMap_attr::attrOffsetB);
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetB, "label", "offset b");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetB, "comment", "adds the specified values to the blue channel");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetB, "enable if", "OrderedDict({'on': 'true', 'gain_offset_enabled': 'true', 'use_per_channel_gain_offset': 'true'})");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetB, "min", "-1.0f");
sceneClass.setMetadata(ColorCorrectMap_attr::attrOffsetB, "max", "1.0f");
RDL2_DSO_ATTR_END
using namespace ColorCorrectMap_attr;
