#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ColorCorrectSaturationMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Bool> attrOn;
AttributeKey<Float> attrMix;
AttributeKey<Float> attrSaturation;
AttributeKey<Bool> attrSaturationPerChannel;
AttributeKey<Float> attrSaturationR;
AttributeKey<Float> attrSaturationG;
AttributeKey<Float> attrSaturationB;
RDL2_DSO_ATTR_DEFINE(Map)
ColorCorrectSaturationMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrInput, "comment", "bind the input here");
ColorCorrectSaturationMap_attr::attrOn = sceneClass.declareAttribute<Bool>("on", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrOn, "comment", "enables/disables all color correct operations");
ColorCorrectSaturationMap_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrMix, "comment", "how much of the overall color correct to mix in");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrMix, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrMix, "max", "1.0f");
ColorCorrectSaturationMap_attr::attrSaturation = sceneClass.declareAttribute<Float>("saturation", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturation, "comment", "desaturates the input below 1.0 and adds saturation above 1.0");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturation, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_saturation': 'false'})");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturation, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturation, "max", "4.0f");
ColorCorrectSaturationMap_attr::attrSaturationPerChannel = sceneClass.declareAttribute<Bool>("use_per_channel_saturation", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationPerChannel, "label", "use per channel saturation");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationPerChannel, "comment", "enables separate RGB controls for saturation");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationPerChannel, "enable if", "OrderedDict({'on': 'true'})");
ColorCorrectSaturationMap_attr::attrSaturationR = sceneClass.declareAttribute<Float>("saturation_r", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationR, "label", "saturation r");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationR, "comment", "desaturates the red channel input below 1.0 and adds saturation above 1.0");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationR, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_saturation': 'true'})");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationR, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationR, "max", "4.0f");
ColorCorrectSaturationMap_attr::attrSaturationG = sceneClass.declareAttribute<Float>("saturation_g", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationG, "label", "saturation g");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationG, "comment", "desaturates the green channel input below 1.0 and adds saturation above 1.0");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationG, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_saturation': 'true'})");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationG, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationG, "max", "4.0f");
ColorCorrectSaturationMap_attr::attrSaturationB = sceneClass.declareAttribute<Float>("saturation_b", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationB, "label", "saturation b");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationB, "comment", "desaturates the blue channel input below 1.0 and adds saturation above 1.0");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationB, "enable if", "OrderedDict({'on': 'true', 'use_per_channel_saturation': 'true'})");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationB, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectSaturationMap_attr::attrSaturationB, "max", "4.0f");
RDL2_DSO_ATTR_END
using namespace ColorCorrectSaturationMap_attr;
