#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ColorCorrectTMIMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Bool> attrOn;
AttributeKey<Float> attrMix;
AttributeKey<Rgb> attrTMI;
RDL2_DSO_ATTR_DEFINE(Map)
ColorCorrectTMIMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrInput, "comment", "bind the input here");
ColorCorrectTMIMap_attr::attrOn = sceneClass.declareAttribute<Bool>("on", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrOn, "comment", "enables/disables all color correct operations");
ColorCorrectTMIMap_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrMix, "comment", "how much of the overall color correct to mix in");
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrMix, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrMix, "max", "1.0f");
ColorCorrectTMIMap_attr::attrTMI = sceneClass.declareAttribute<Rgb>("TMI", Rgb(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrTMI, "display", "tmi");
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrTMI, "comment", "T = Temperature where positive values push towards blue and negative towards red.   M = Magenta where positive values push towards magenta and negative towards green.  I = Intensity where negative values remove and positive values add energy ");
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrTMI, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrTMI, "min", "-2.0f");
sceneClass.setMetadata(ColorCorrectTMIMap_attr::attrTMI, "max", "2.0f");
RDL2_DSO_ATTR_END
using namespace ColorCorrectTMIMap_attr;
