#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(CurvatureMap_attr)
AttributeKey<Bool> attrInvert;
AttributeKey<Float> attrPower;
AttributeKey<Float> attrScale;
AttributeKey<Int> attrMode;
RDL2_DSO_ATTR_DEFINE(Map)
CurvatureMap_attr::attrInvert = sceneClass.declareAttribute<Bool>("invert", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(CurvatureMap_attr::attrInvert, "comment", "Flips the value of the curvature.");
CurvatureMap_attr::attrPower = sceneClass.declareAttribute<Float>("power", 0.5f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(CurvatureMap_attr::attrPower, "comment", "Raises the value of the curvature to the given power.");
CurvatureMap_attr::attrScale = sceneClass.declareAttribute<Float>("scale", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(CurvatureMap_attr::attrScale, "comment", "Multiplies the value of the curvature. Results are still clamped between 0 and 1.");
CurvatureMap_attr::attrMode = sceneClass.declareAttribute<Int>("mode", 3, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(CurvatureMap_attr::attrMode, 0, "convex");
sceneClass.setEnumValue(CurvatureMap_attr::attrMode, 1, "concave");
sceneClass.setEnumValue(CurvatureMap_attr::attrMode, 2, "composite");
sceneClass.setEnumValue(CurvatureMap_attr::attrMode, 3, "all");
sceneClass.setMetadata(CurvatureMap_attr::attrMode, "comment", "The composite mode outputs the composite of convex curvature and concave curvature as grayscale ((concave - convex) * 0.5) + 0.5. The all mode outputs the convex curvature in the red channel, concave curvature in the green channel, and composite of both curvatures in the blue channel.");
RDL2_DSO_ATTR_END
using namespace CurvatureMap_attr;
