#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(DeformationMap_attr)
AttributeKey<Int> attrOutputMode;
AttributeKey<Bool> attrUseWarningColor;
AttributeKey<Rgb> attrWarningColor;
RDL2_DSO_ATTR_DEFINE(Map)
DeformationMap_attr::attrOutputMode = sceneClass.declareAttribute<Int>("output_mode", 3, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(DeformationMap_attr::attrOutputMode, 0, "RGB");
sceneClass.setEnumValue(DeformationMap_attr::attrOutputMode, 1, "deformation_S");
sceneClass.setEnumValue(DeformationMap_attr::attrOutputMode, 2, "deformation_T");
sceneClass.setEnumValue(DeformationMap_attr::attrOutputMode, 3, "deformation_avg");
sceneClass.setMetadata(DeformationMap_attr::attrOutputMode, "comment", "Controls output: \n		    RGB - R = deformation along S, G = deformation along T, B = average deformation from ref space \n		    deformation_S - deformation along S \n		    deformation_T - deformation along T \n		    deformation_avg - average deformation from ref space");
DeformationMap_attr::attrUseWarningColor = sceneClass.declareAttribute<Bool>("use_warning_color", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DeformationMap_attr::attrUseWarningColor, "comment", "If derivatives are missing or zero output the warning color erroring out");
DeformationMap_attr::attrWarningColor = sceneClass.declareAttribute<Rgb>("warning_color", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DeformationMap_attr::attrWarningColor, "comment", "Warning color to output when derivatives are missing or zero");
sceneClass.setMetadata(DeformationMap_attr::attrWarningColor, "enable if", "OrderedDict({'use_warning_color': 'true'})");
RDL2_DSO_ATTR_END
using namespace DeformationMap_attr;
