#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(DirectionalMap_attr)
AttributeKey<Int> attrPrimeDirection;
AttributeKey<Int> attrPolarity;
AttributeKey<Rgb> attrColorA;
AttributeKey<Rgb> attrColorB;
AttributeKey<SceneObject*> attrObject;
AttributeKey<Int> attrObjectAxis;
AttributeKey<Vec3f> attrCustomDirection;
AttributeKey<Bool> attrUseReferenceSpace;
AttributeKey<SceneObject*> attrInputNormal;
AttributeKey<Float> attrInputNormalDial;
AttributeKey<Int> attrClamping;
AttributeKey<Float> attrBias;
AttributeKey<Bool> attrUseSmoothstep;
AttributeKey<Float> attrSmoothStart;
AttributeKey<Float> attrSmoothEnd;
AttributeKey<Int> attrFalloffType;
RDL2_DSO_ATTR_DEFINE(Map)
DirectionalMap_attr::attrPrimeDirection = sceneClass.declareAttribute<Int>("prime_direction", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(DirectionalMap_attr::attrPrimeDirection, 0, "observer direction");
sceneClass.setEnumValue(DirectionalMap_attr::attrPrimeDirection, 1, "custom direction");
sceneClass.setEnumValue(DirectionalMap_attr::attrPrimeDirection, 2, "axis of object");
sceneClass.setEnumValue(DirectionalMap_attr::attrPrimeDirection, 3, "look-at object");
sceneClass.setMetadata(DirectionalMap_attr::attrPrimeDirection, "label", "prime direction");
sceneClass.setMetadata(DirectionalMap_attr::attrPrimeDirection, "comment", "which source is used for the prime direction");
DirectionalMap_attr::attrPolarity = sceneClass.declareAttribute<Int>("polarity", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(DirectionalMap_attr::attrPolarity, 0, "perpendicular");
sceneClass.setEnumValue(DirectionalMap_attr::attrPolarity, 1, "parallel");
sceneClass.setMetadata(DirectionalMap_attr::attrPolarity, "comment", "determines which directions are given color A and which are given color B. Switching this effectively swaps the colors");
DirectionalMap_attr::attrColorA = sceneClass.declareAttribute<Rgb>("color_a", Rgb(0,0,0), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DirectionalMap_attr::attrColorA, "label", "color A");
sceneClass.setMetadata(DirectionalMap_attr::attrColorA, "comment", "the color of the effect when the difference angle is greatest");
DirectionalMap_attr::attrColorB = sceneClass.declareAttribute<Rgb>("color_b", Rgb(1,1,1), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DirectionalMap_attr::attrColorB, "label", "color B");
sceneClass.setMetadata(DirectionalMap_attr::attrColorB, "comment", "the color of the effect when the difference angle is smallest");
DirectionalMap_attr::attrObject = sceneClass.declareAttribute<SceneObject*>("object", FLAGS_NONE, INTERFACE_NODE, {});
sceneClass.setMetadata(DirectionalMap_attr::attrObject, "comment", "the object to use when 'prime direction' is set to 'axis of object' or 'look-at object'");
sceneClass.setMetadata(DirectionalMap_attr::attrObject, "enable if", "OrderedDict({'prime_direction': '3'})");
DirectionalMap_attr::attrObjectAxis = sceneClass.declareAttribute<Int>("object_axis", 1, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(DirectionalMap_attr::attrObjectAxis, 0, "+X axis");
sceneClass.setEnumValue(DirectionalMap_attr::attrObjectAxis, 1, "-X axis");
sceneClass.setEnumValue(DirectionalMap_attr::attrObjectAxis, 2, "+Y axis");
sceneClass.setEnumValue(DirectionalMap_attr::attrObjectAxis, 3, "-Y axis");
sceneClass.setEnumValue(DirectionalMap_attr::attrObjectAxis, 4, "+Z axis");
sceneClass.setEnumValue(DirectionalMap_attr::attrObjectAxis, 5, "-Z axis");
sceneClass.setMetadata(DirectionalMap_attr::attrObjectAxis, "label", "object axis");
sceneClass.setMetadata(DirectionalMap_attr::attrObjectAxis, "comment", "which axis to use when 'prime direction' is set to 'axis of object'");
sceneClass.setMetadata(DirectionalMap_attr::attrObjectAxis, "enable if", "OrderedDict({'prime_direction': '2'})");
DirectionalMap_attr::attrCustomDirection = sceneClass.declareAttribute<Vec3f>("custom_direction", Vec3f(0.0f, 1.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DirectionalMap_attr::attrCustomDirection, "label", "custom direction");
sceneClass.setMetadata(DirectionalMap_attr::attrCustomDirection, "comment", "specifies a custom direction in world space as the prime direction");
sceneClass.setMetadata(DirectionalMap_attr::attrCustomDirection, "enable if", "OrderedDict({'prime_direction': '1'})");
DirectionalMap_attr::attrUseReferenceSpace = sceneClass.declareAttribute<Bool>("use_reference_space", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DirectionalMap_attr::attrUseReferenceSpace, "label", "use reference space");
sceneClass.setMetadata(DirectionalMap_attr::attrUseReferenceSpace, "comment", "use reference space position and normals");
DirectionalMap_attr::attrInputNormal = sceneClass.declareAttribute<SceneObject*>("input_normal", FLAGS_NONE, INTERFACE_NORMALMAP, {});
sceneClass.setGroup("Normal", DirectionalMap_attr::attrInputNormal);
sceneClass.setMetadata(DirectionalMap_attr::attrInputNormal, "label", "input normal");
sceneClass.setMetadata(DirectionalMap_attr::attrInputNormal, "comment", "specifies an alternate shading normal when bound. The binding multiplier is ignored");
DirectionalMap_attr::attrInputNormalDial = sceneClass.declareAttribute<Float>("input_normal_dial", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Normal", DirectionalMap_attr::attrInputNormalDial);
sceneClass.setMetadata(DirectionalMap_attr::attrInputNormalDial, "label", "input normal dial");
sceneClass.setMetadata(DirectionalMap_attr::attrInputNormalDial, "comment", "controls the amount of influence of the alternate normal");
DirectionalMap_attr::attrClamping = sceneClass.declareAttribute<Int>("clamping_behavior", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", DirectionalMap_attr::attrClamping);
sceneClass.setEnumValue(DirectionalMap_attr::attrClamping, 0, "clamp");
sceneClass.setEnumValue(DirectionalMap_attr::attrClamping, 1, "absolute");
sceneClass.setMetadata(DirectionalMap_attr::attrClamping, "label", "clamping behavior");
sceneClass.setMetadata(DirectionalMap_attr::attrClamping, "comment", "determines how surfaces facing opposite the prime direction are handled");
DirectionalMap_attr::attrBias = sceneClass.declareAttribute<Float>("bias", 0.5, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", DirectionalMap_attr::attrBias);
sceneClass.setMetadata(DirectionalMap_attr::attrBias, "comment", "controls the rate at which the effect increases as the shading normal approaches the prime direction");
DirectionalMap_attr::attrUseSmoothstep = sceneClass.declareAttribute<Bool>("use_smoothstep", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", DirectionalMap_attr::attrUseSmoothstep);
sceneClass.setMetadata(DirectionalMap_attr::attrUseSmoothstep, "label", "use smoothstep");
sceneClass.setMetadata(DirectionalMap_attr::attrUseSmoothstep, "comment", "apply smoothstep function to result");
DirectionalMap_attr::attrSmoothStart = sceneClass.declareAttribute<Float>("smoothstep_start", 0.45, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", DirectionalMap_attr::attrSmoothStart);
sceneClass.setMetadata(DirectionalMap_attr::attrSmoothStart, "label", "smoothstep start");
sceneClass.setMetadata(DirectionalMap_attr::attrSmoothStart, "comment", "the value at which the effect is considered 100% off");
sceneClass.setMetadata(DirectionalMap_attr::attrSmoothStart, "enable if", "OrderedDict({'use_smoothstep': 'true'})");
DirectionalMap_attr::attrSmoothEnd = sceneClass.declareAttribute<Float>("smoothstep_end", 0.55, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", DirectionalMap_attr::attrSmoothEnd);
sceneClass.setMetadata(DirectionalMap_attr::attrSmoothEnd, "label", "smoothstep end");
sceneClass.setMetadata(DirectionalMap_attr::attrSmoothEnd, "comment", "the value at which the effect is considered 100% on");
sceneClass.setMetadata(DirectionalMap_attr::attrSmoothEnd, "enable if", "OrderedDict({'use_smoothstep': 'true'})");
DirectionalMap_attr::attrFalloffType = sceneClass.declareAttribute<Int>("falloff_type", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", DirectionalMap_attr::attrFalloffType);
sceneClass.setEnumValue(DirectionalMap_attr::attrFalloffType, 0, "cosine");
sceneClass.setEnumValue(DirectionalMap_attr::attrFalloffType, 1, "linear");
sceneClass.setMetadata(DirectionalMap_attr::attrFalloffType, "label", "falloff type");
sceneClass.setMetadata(DirectionalMap_attr::attrFalloffType, "comment", "determines how the effect falls off as the difference angle increases");
RDL2_DSO_ATTR_END
using namespace DirectionalMap_attr;
