#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(GradientMap_attr)
AttributeKey<Rgb> attrColorA;
AttributeKey<Rgb> attrColorB;
AttributeKey<Vec3f> attrStart;
AttributeKey<Vec3f> attrEnd;
AttributeKey<Int> attrFalloffType;
AttributeKey<Float> attrFalloffExponent;
AttributeKey<Float> attrFalloffStart;
AttributeKey<Float> attrFalloffEnd;
AttributeKey<Float> attrFalloffEndIntensity;
AttributeKey<Float> attrFalloffBias;
AttributeKey<Int> attrSpace;
AttributeKey<SceneObject*> attrObject;
AttributeKey<Bool> attrSymmetric;
AttributeKey<Float> attrSymmetricCenter;
RDL2_DSO_ATTR_DEFINE(Map)
GradientMap_attr::attrColorA = sceneClass.declareAttribute<Rgb>("color_A", Rgb(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"color A"});
sceneClass.setGroup("Gradient properties", GradientMap_attr::attrColorA);
sceneClass.setMetadata(GradientMap_attr::attrColorA, "label", "color A");
sceneClass.setMetadata(GradientMap_attr::attrColorA, "comment", "Start color");
GradientMap_attr::attrColorB = sceneClass.declareAttribute<Rgb>("color_B", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"color B"});
sceneClass.setGroup("Gradient properties", GradientMap_attr::attrColorB);
sceneClass.setMetadata(GradientMap_attr::attrColorB, "label", "color B");
sceneClass.setMetadata(GradientMap_attr::attrColorB, "comment", "End color");
GradientMap_attr::attrStart = sceneClass.declareAttribute<Vec3f>("start", Vec3f(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Gradient properties", GradientMap_attr::attrStart);
sceneClass.setMetadata(GradientMap_attr::attrStart, "comment", "Start position in the chosen space");
GradientMap_attr::attrEnd = sceneClass.declareAttribute<Vec3f>("end", Vec3f(0.0f, 1.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Gradient properties", GradientMap_attr::attrEnd);
sceneClass.setMetadata(GradientMap_attr::attrEnd, "comment", "End position in the chosen space");
GradientMap_attr::attrFalloffType = sceneClass.declareAttribute<Int>("falloff_type", 1, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"falloff type"});
sceneClass.setGroup("Falloff properties", GradientMap_attr::attrFalloffType);
sceneClass.setEnumValue(GradientMap_attr::attrFalloffType, 0, "none");
sceneClass.setEnumValue(GradientMap_attr::attrFalloffType, 1, "natural");
sceneClass.setEnumValue(GradientMap_attr::attrFalloffType, 2, "linear");
sceneClass.setEnumValue(GradientMap_attr::attrFalloffType, 3, "squared");
sceneClass.setEnumValue(GradientMap_attr::attrFalloffType, 4, "gaussian");
sceneClass.setEnumValue(GradientMap_attr::attrFalloffType, 5, "ease out");
sceneClass.setMetadata(GradientMap_attr::attrFalloffType, "label", "falloff type");
sceneClass.setMetadata(GradientMap_attr::attrFalloffType, "comment", "Falloff blend mode");
GradientMap_attr::attrFalloffExponent = sceneClass.declareAttribute<Float>("falloff_exponent", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"falloff exponent"});
sceneClass.setGroup("Falloff properties", GradientMap_attr::attrFalloffExponent);
sceneClass.setMetadata(GradientMap_attr::attrFalloffExponent, "label", "falloff exponent");
sceneClass.setMetadata(GradientMap_attr::attrFalloffExponent, "comment", "Adjusts rate of blending");
GradientMap_attr::attrFalloffStart = sceneClass.declareAttribute<Float>("falloff_start", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"falloff start"});
sceneClass.setGroup("Falloff properties", GradientMap_attr::attrFalloffStart);
sceneClass.setMetadata(GradientMap_attr::attrFalloffStart, "label", "falloff start");
sceneClass.setMetadata(GradientMap_attr::attrFalloffStart, "comment", "Shifts where the falloff starts");
GradientMap_attr::attrFalloffEnd = sceneClass.declareAttribute<Float>("falloff_end", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"falloff end"});
sceneClass.setGroup("Falloff properties", GradientMap_attr::attrFalloffEnd);
sceneClass.setMetadata(GradientMap_attr::attrFalloffEnd, "label", "falloff end");
sceneClass.setMetadata(GradientMap_attr::attrFalloffEnd, "comment", "Shifts where the falloff ends");
GradientMap_attr::attrFalloffEndIntensity = sceneClass.declareAttribute<Float>("falloff_end_intensity", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"falloff end intensity"});
sceneClass.setGroup("Falloff properties", GradientMap_attr::attrFalloffEndIntensity);
sceneClass.setMetadata(GradientMap_attr::attrFalloffEndIntensity, "label", "falloff end intensity");
sceneClass.setMetadata(GradientMap_attr::attrFalloffEndIntensity, "comment", "Adjust the intensity of the end color");
GradientMap_attr::attrFalloffBias = sceneClass.declareAttribute<Float>("falloff_bias", 0.5f, FLAGS_NONE, INTERFACE_GENERIC, {"falloff bias"});
sceneClass.setGroup("Falloff properties", GradientMap_attr::attrFalloffBias);
sceneClass.setMetadata(GradientMap_attr::attrFalloffBias, "label", "falloff bias");
sceneClass.setMetadata(GradientMap_attr::attrFalloffBias, "comment", "Compresses the blending towards the start or end color");
GradientMap_attr::attrSpace = sceneClass.declareAttribute<Int>("space", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Gradient properties", GradientMap_attr::attrSpace);
sceneClass.setEnumValue(GradientMap_attr::attrSpace, 0, "render");
sceneClass.setEnumValue(GradientMap_attr::attrSpace, 1, "camera");
sceneClass.setEnumValue(GradientMap_attr::attrSpace, 2, "world");
sceneClass.setEnumValue(GradientMap_attr::attrSpace, 3, "screen");
sceneClass.setEnumValue(GradientMap_attr::attrSpace, 4, "object");
sceneClass.setEnumValue(GradientMap_attr::attrSpace, 5, "reference");
sceneClass.setEnumValue(GradientMap_attr::attrSpace, 6, "texture");
sceneClass.setMetadata(GradientMap_attr::attrSpace, "comment", "The transformation space in which to perform the blending");
GradientMap_attr::attrObject = sceneClass.declareAttribute<SceneObject*>("object", FLAGS_NONE, INTERFACE_GEOMETRY, {});
sceneClass.setGroup("Gradient properties", GradientMap_attr::attrObject);
sceneClass.setMetadata(GradientMap_attr::attrObject, "comment", "Use the provided object's transformation space (only used if object space is also specified)");
GradientMap_attr::attrSymmetric = sceneClass.declareAttribute<Bool>("symmetric", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Additional properties", GradientMap_attr::attrSymmetric);
sceneClass.setMetadata(GradientMap_attr::attrSymmetric, "comment", "Color A blends into Color B and then back into Color A from the start to the end point");
GradientMap_attr::attrSymmetricCenter = sceneClass.declareAttribute<Float>("symmetric_center", 0.5f, FLAGS_NONE, INTERFACE_GENERIC, {"symmetric center"});
sceneClass.setGroup("Additional properties", GradientMap_attr::attrSymmetricCenter);
sceneClass.setMetadata(GradientMap_attr::attrSymmetricCenter, "label", "symmetric center");
sceneClass.setMetadata(GradientMap_attr::attrSymmetricCenter, "comment", "Shifts the center of the symmetric falloff");
RDL2_DSO_ATTR_END
using namespace GradientMap_attr;
