#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(HairMap_attr)
AttributeKey<Rgb> attrBaseHairColor;
AttributeKey<Rgb> attrTipHairColor;
AttributeKey<Float> attrLengthWiseBias;
AttributeKey<Float> attrLengthWiseGain;
AttributeKey<Rgb> attrHairColumnUvColor;
RDL2_DSO_ATTR_DEFINE(Map)
HairMap_attr::attrBaseHairColor = sceneClass.declareAttribute<Rgb>("base_color", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"base color"});
sceneClass.setMetadata(HairMap_attr::attrBaseHairColor, "label", "base color");
sceneClass.setMetadata(HairMap_attr::attrBaseHairColor, "comment", "Color at each hair's base");
HairMap_attr::attrTipHairColor = sceneClass.declareAttribute<Rgb>("tip_color", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"tip color"});
sceneClass.setMetadata(HairMap_attr::attrTipHairColor, "label", "tip color");
sceneClass.setMetadata(HairMap_attr::attrTipHairColor, "comment", "Color at each hair's tip");
HairMap_attr::attrLengthWiseBias = sceneClass.declareAttribute<Float>("bias", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(HairMap_attr::attrLengthWiseBias, "comment", "Modulates the shape of blending between base and tip color. < 0.5 pushes the center of the blend towards the base, and > 0.5 towards the tip.");
HairMap_attr::attrLengthWiseGain = sceneClass.declareAttribute<Float>("gain", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(HairMap_attr::attrLengthWiseGain, "comment", "Modulates the shape of blending between base and tip color. < 0.5 is higher contrast in the middle of the blend. > 0.5 is higher contrast at the start and end, and lower contrast in the middle.");
HairMap_attr::attrHairColumnUvColor = sceneClass.declareAttribute<Rgb>("column_uv_color", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"column uv color"});
sceneClass.setMetadata(HairMap_attr::attrHairColumnUvColor, "label", "column uv color");
sceneClass.setMetadata(HairMap_attr::attrHairColumnUvColor, "comment", "Bound image map must have a HairColumnUvMap bound to its input texture coordinates.");
RDL2_DSO_ATTR_END
using namespace HairMap_attr;
