#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(LODMap_attr)
AttributeKey<Int> attrLODType;
AttributeKey<Float> attrStart;
AttributeKey<Float> attrStop;
AttributeKey<Rgb> attrNearValue;
AttributeKey<Rgb> attrFarValue;
RDL2_DSO_ATTR_DEFINE(Map)
LODMap_attr::attrLODType = sceneClass.declareAttribute<Int>("mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(LODMap_attr::attrLODType, 0, "feature width");
sceneClass.setEnumValue(LODMap_attr::attrLODType, 1, "camera distance");
sceneClass.setMetadata(LODMap_attr::attrLODType, "comment", "Use feature_width for LOD based on average, world-space feature-width visible in a pixel, correctly changing with resolution. Use camera_distance for LOD based on distance from render cam.");
LODMap_attr::attrStart = sceneClass.declareAttribute<Float>("start", 0.01f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(LODMap_attr::attrStart, "comment", "feature_width/camera_distance at which to start blending near_value->far_value");
LODMap_attr::attrStop = sceneClass.declareAttribute<Float>("stop", 0.1f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(LODMap_attr::attrStop, "comment", "feature_width/camera_distance at which to stop blending near_value->far_value");
LODMap_attr::attrNearValue = sceneClass.declareAttribute<Rgb>("near_value", Rgb(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"near value"});
sceneClass.setMetadata(LODMap_attr::attrNearValue, "label", "near value");
sceneClass.setMetadata(LODMap_attr::attrNearValue, "comment", "value output when feature_width/camera_distance is less than or equal to start");
LODMap_attr::attrFarValue = sceneClass.declareAttribute<Rgb>("far_value", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"far value"});
sceneClass.setMetadata(LODMap_attr::attrFarValue, "label", "far value");
sceneClass.setMetadata(LODMap_attr::attrFarValue, "comment", "value output when feature_width/camera_distance is more than or equal to stop");
RDL2_DSO_ATTR_END
using namespace LODMap_attr;
