#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(MultiChannelToFloatMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Int> attrMode;
AttributeKey<Float> attrTolerance;
RDL2_DSO_ATTR_DEFINE(Map)
MultiChannelToFloatMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
MultiChannelToFloatMap_attr::attrMode = sceneClass.declareAttribute<Int>("mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(MultiChannelToFloatMap_attr::attrMode, 0, "Red");
sceneClass.setEnumValue(MultiChannelToFloatMap_attr::attrMode, 1, "Green");
sceneClass.setEnumValue(MultiChannelToFloatMap_attr::attrMode, 2, "Blue");
sceneClass.setEnumValue(MultiChannelToFloatMap_attr::attrMode, 3, "Cyan");
sceneClass.setEnumValue(MultiChannelToFloatMap_attr::attrMode, 4, "Magenta");
sceneClass.setEnumValue(MultiChannelToFloatMap_attr::attrMode, 5, "Yellow");
sceneClass.setEnumValue(MultiChannelToFloatMap_attr::attrMode, 6, "White");
sceneClass.setMetadata(MultiChannelToFloatMap_attr::attrMode, "comment", "Specifies which color channels including combination channels (Cyan, Magenta, Yellow, and White) to convert to float.");
MultiChannelToFloatMap_attr::attrTolerance = sceneClass.declareAttribute<Float>("tolerance", 0.2, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(MultiChannelToFloatMap_attr::attrTolerance, "min", "0.0");
sceneClass.setMetadata(MultiChannelToFloatMap_attr::attrTolerance, "max", "1.0");
sceneClass.setMetadata(MultiChannelToFloatMap_attr::attrTolerance, "comment", "Low tolerance values will tend to produce harsher edges near overlapping colors, while high tolerance values may result in cross-color bleeding.");
RDL2_DSO_ATTR_END
using namespace MultiChannelToFloatMap_attr;
