#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(NoiseMap_v2_attr)
AttributeKey<Int> attrSeed;
AttributeKey<Float> attrFrequencyMultiplier;
AttributeKey<Float> attrAmplitude;
AttributeKey<Float> attrMaxLevel;
AttributeKey<Float> attrLacunarity;
AttributeKey<Float> attrPersistence;
AttributeKey<Float> attrDistortion;
AttributeKey<Int> attrDistortionNoiseType;
AttributeKey<Bool> attrColor;
AttributeKey<Rgb> attrColorA;
AttributeKey<Rgb> attrColorB;
AttributeKey<Int> attrNoiseType;
AttributeKey<Float> attrFlowAngle;
AttributeKey<Float> attrAdvectionRate;
AttributeKey<Bool> attrUse4D;
AttributeKey<Float> attrTime;
AttributeKey<Float> attrBias;
AttributeKey<Float> attrGain;
AttributeKey<Bool> attrInvert;
AttributeKey<Bool> attrUseSmoothstep;
AttributeKey<Vec2f> attrSmoothstep;
AttributeKey<Int> attrSpace;
AttributeKey<Vec3f> attrInputTextureCoordinate;
AttributeKey<SceneObject*> attrObject;
AttributeKey<SceneObject*> attrCamera;
AttributeKey<Vec3f> attrTranslation;
AttributeKey<Vec3f> attrRotation;
AttributeKey<Vec3f> attrScale;
AttributeKey<Int> attrRotationOrder;
AttributeKey<Int> attrTransformationOrder;
RDL2_DSO_ATTR_DEFINE(Map)
NoiseMap_v2_attr::attrSeed = sceneClass.declareAttribute<Int>("seed", 0, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(NoiseMap_v2_attr::attrSeed, "comment", "The seed for the random number generator");
NoiseMap_v2_attr::attrFrequencyMultiplier = sceneClass.declareAttribute<Float>("frequency_multiplier", 1.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"frequency multiplier"});
sceneClass.setMetadata(NoiseMap_v2_attr::attrFrequencyMultiplier, "label", "frequency multiplier");
sceneClass.setMetadata(NoiseMap_v2_attr::attrFrequencyMultiplier, "comment", "Scalar multiplier for the frequency vector");
NoiseMap_v2_attr::attrAmplitude = sceneClass.declareAttribute<Float>("amplitude", 1.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(NoiseMap_v2_attr::attrAmplitude, "comment", "Intensity of the noise");
NoiseMap_v2_attr::attrMaxLevel = sceneClass.declareAttribute<Float>("max_level", 1.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"max level"});
sceneClass.setMetadata(NoiseMap_v2_attr::attrMaxLevel, "label", "max level");
sceneClass.setMetadata(NoiseMap_v2_attr::attrMaxLevel, "comment", "Number of octaves of noise to add together for the final result");
NoiseMap_v2_attr::attrLacunarity = sceneClass.declareAttribute<Float>("lacunarity", 2.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(NoiseMap_v2_attr::attrLacunarity, "comment", "Multiplier on the noise frequency per level");
NoiseMap_v2_attr::attrPersistence = sceneClass.declareAttribute<Float>("persistence", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(NoiseMap_v2_attr::attrPersistence, "comment", "Multiplier on the noise amplitude per level");
NoiseMap_v2_attr::attrDistortion = sceneClass.declareAttribute<Float>("distortion", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(NoiseMap_v2_attr::attrDistortion, "comment", "Warp input coordinate space with single noise level before looking up noise");
NoiseMap_v2_attr::attrDistortionNoiseType = sceneClass.declareAttribute<Int>("distortion_noise_type", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"distortion noise type"});
sceneClass.setEnumValue(NoiseMap_v2_attr::attrDistortionNoiseType, 0, "perlin classic");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrDistortionNoiseType, 1, "perlin simplex");
sceneClass.setMetadata(NoiseMap_v2_attr::attrDistortionNoiseType, "label", "distortion noise type");
sceneClass.setMetadata(NoiseMap_v2_attr::attrDistortionNoiseType, "comment", "Type of noise to use for distortion.");
NoiseMap_v2_attr::attrColor = sceneClass.declareAttribute<Bool>("color", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(NoiseMap_v2_attr::attrColor, "comment", "Outputs RGB noise");
NoiseMap_v2_attr::attrColorA = sceneClass.declareAttribute<Rgb>("color_A", Rgb(0.f, 0.f, 0.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"color A"});
sceneClass.setMetadata(NoiseMap_v2_attr::attrColorA, "label", "color A");
sceneClass.setMetadata(NoiseMap_v2_attr::attrColorA, "comment", "The color value at 0 noise");
sceneClass.setMetadata(NoiseMap_v2_attr::attrColorA, "enable if", "OrderedDict({'color': 'false'})");
NoiseMap_v2_attr::attrColorB = sceneClass.declareAttribute<Rgb>("color_B", Rgb(1.f, 1.f, 1.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"color B"});
sceneClass.setMetadata(NoiseMap_v2_attr::attrColorB, "label", "color B");
sceneClass.setMetadata(NoiseMap_v2_attr::attrColorB, "comment", "The color value at 1 noise");
sceneClass.setMetadata(NoiseMap_v2_attr::attrColorB, "enable if", "OrderedDict({'color': 'false'})");
NoiseMap_v2_attr::attrNoiseType = sceneClass.declareAttribute<Int>("noise_type", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"noise type"});
sceneClass.setEnumValue(NoiseMap_v2_attr::attrNoiseType, 0, "perlin classic");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrNoiseType, 1, "perlin simplex");
sceneClass.setMetadata(NoiseMap_v2_attr::attrNoiseType, "label", "noise type");
sceneClass.setMetadata(NoiseMap_v2_attr::attrNoiseType, "comment", "Type of noise to use. Simplex grid activates Flow Noise Angle and Advection");
NoiseMap_v2_attr::attrFlowAngle = sceneClass.declareAttribute<Float>("flow_angle", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"flow angle"});
sceneClass.setGroup("Flow Noise", NoiseMap_v2_attr::attrFlowAngle);
sceneClass.setMetadata(NoiseMap_v2_attr::attrFlowAngle, "label", "flow angle");
sceneClass.setMetadata(NoiseMap_v2_attr::attrFlowAngle, "comment", "Angle of rotation for flow noise");
sceneClass.setMetadata(NoiseMap_v2_attr::attrFlowAngle, "enable if", "OrderedDict({'noise_type': 'perlin simplex'})");
NoiseMap_v2_attr::attrAdvectionRate = sceneClass.declareAttribute<Float>("flow_advection_rate", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"flow advection rate"});
sceneClass.setGroup("Flow Noise", NoiseMap_v2_attr::attrAdvectionRate);
sceneClass.setMetadata(NoiseMap_v2_attr::attrAdvectionRate, "label", "flow advection rate");
sceneClass.setMetadata(NoiseMap_v2_attr::attrAdvectionRate, "comment", "Rate of advection for flow noise");
sceneClass.setMetadata(NoiseMap_v2_attr::attrAdvectionRate, "enable if", "OrderedDict({'noise_type': 'perlin simplex'})");
NoiseMap_v2_attr::attrUse4D = sceneClass.declareAttribute<Bool>("use_4D_noise", false, FLAGS_NONE, INTERFACE_GENERIC, {"use 4D noise"});
sceneClass.setGroup("4D", NoiseMap_v2_attr::attrUse4D);
sceneClass.setMetadata(NoiseMap_v2_attr::attrUse4D, "label", "use 4D noise");
sceneClass.setMetadata(NoiseMap_v2_attr::attrUse4D, "comment", "If on, 4-dimensional noise is used instead of 3-dimensional");
NoiseMap_v2_attr::attrTime = sceneClass.declareAttribute<Float>("time", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("4D", NoiseMap_v2_attr::attrTime);
sceneClass.setMetadata(NoiseMap_v2_attr::attrTime, "comment", "If use 4D noise is on, this is the value for the 4th dimension");
sceneClass.setMetadata(NoiseMap_v2_attr::attrTime, "enable if", "OrderedDict({'use_4D_noise': 'true'})");
NoiseMap_v2_attr::attrBias = sceneClass.declareAttribute<Float>("bias", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", NoiseMap_v2_attr::attrBias);
sceneClass.setMetadata(NoiseMap_v2_attr::attrBias, "comment", "Bias the noise towards 0 or 1");
NoiseMap_v2_attr::attrGain = sceneClass.declareAttribute<Float>("gain", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", NoiseMap_v2_attr::attrGain);
sceneClass.setMetadata(NoiseMap_v2_attr::attrGain, "comment", "Apply gain to the noise");
NoiseMap_v2_attr::attrInvert = sceneClass.declareAttribute<Bool>("invert", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", NoiseMap_v2_attr::attrInvert);
sceneClass.setMetadata(NoiseMap_v2_attr::attrInvert, "comment", "Invert the final pattern");
NoiseMap_v2_attr::attrUseSmoothstep = sceneClass.declareAttribute<Bool>("use_smoothstep", false, FLAGS_NONE, INTERFACE_GENERIC, {"use smoothstep"});
sceneClass.setGroup("Adjustment", NoiseMap_v2_attr::attrUseSmoothstep);
sceneClass.setMetadata(NoiseMap_v2_attr::attrUseSmoothstep, "label", "use smoothstep");
sceneClass.setMetadata(NoiseMap_v2_attr::attrUseSmoothstep, "comment", "Put the noise value through a smoothstep function defined by min/max");
NoiseMap_v2_attr::attrSmoothstep = sceneClass.declareAttribute<Vec2f>("smoothstep", Vec2f(0.f, 1.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", NoiseMap_v2_attr::attrSmoothstep);
sceneClass.setMetadata(NoiseMap_v2_attr::attrSmoothstep, "comment", "min/max values between which the smoothstep will interpolate");
NoiseMap_v2_attr::attrSpace = sceneClass.declareAttribute<Int>("space", 4, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Space", NoiseMap_v2_attr::attrSpace);
sceneClass.setEnumValue(NoiseMap_v2_attr::attrSpace, 0, "render");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrSpace, 1, "camera");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrSpace, 2, "world");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrSpace, 3, "screen");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrSpace, 4, "object");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrSpace, 5, "reference");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrSpace, 6, "texture");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrSpace, 7, "input texture coordinates");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrSpace, 8, "hair_surface_uv");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrSpace, 9, "hair_closest_surface_uv");
sceneClass.setMetadata(NoiseMap_v2_attr::attrSpace, "comment", "The space to calculate the noise in");
NoiseMap_v2_attr::attrInputTextureCoordinate = sceneClass.declareAttribute<Vec3f>("input_texture_coordinates", Vec3f(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"input texture coordinates"});
sceneClass.setGroup("Space", NoiseMap_v2_attr::attrInputTextureCoordinate);
sceneClass.setMetadata(NoiseMap_v2_attr::attrInputTextureCoordinate, "label", "input texture coordinates");
sceneClass.setMetadata(NoiseMap_v2_attr::attrInputTextureCoordinate, "enable if", "OrderedDict({'space': 'input texture coordinates'})");
sceneClass.setMetadata(NoiseMap_v2_attr::attrInputTextureCoordinate, "comment", "User specified UVs");
NoiseMap_v2_attr::attrObject = sceneClass.declareAttribute<SceneObject*>("object_space", FLAGS_NONE, INTERFACE_GEOMETRY, {"object space"});
sceneClass.setGroup("Space", NoiseMap_v2_attr::attrObject);
sceneClass.setMetadata(NoiseMap_v2_attr::attrObject, "label", "object space");
sceneClass.setMetadata(NoiseMap_v2_attr::attrObject, "comment", "Directly connect object to use that object's space");
sceneClass.setMetadata(NoiseMap_v2_attr::attrObject, "enable if", "OrderedDict({'space': 'object'})");
NoiseMap_v2_attr::attrCamera = sceneClass.declareAttribute<SceneObject*>("camera", FLAGS_NONE, INTERFACE_CAMERA, {});
sceneClass.setGroup("Space", NoiseMap_v2_attr::attrCamera);
sceneClass.setMetadata(NoiseMap_v2_attr::attrCamera, "comment", "camera used to define camera and screen space");
NoiseMap_v2_attr::attrTranslation = sceneClass.declareAttribute<Vec3f>("translation", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Transform", NoiseMap_v2_attr::attrTranslation);
sceneClass.setMetadata(NoiseMap_v2_attr::attrTranslation, "comment", "Translation of the noise in space");
NoiseMap_v2_attr::attrRotation = sceneClass.declareAttribute<Vec3f>("rotation", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Transform", NoiseMap_v2_attr::attrRotation);
sceneClass.setMetadata(NoiseMap_v2_attr::attrRotation, "comment", "Rotates the noise in space based on the specified rotation order");
NoiseMap_v2_attr::attrScale = sceneClass.declareAttribute<Vec3f>("scale", 1.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Transform", NoiseMap_v2_attr::attrScale);
sceneClass.setMetadata(NoiseMap_v2_attr::attrScale, "comment", "Vector to scale the noise non-proportionally");
NoiseMap_v2_attr::attrRotationOrder = sceneClass.declareAttribute<Int>("rotation_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"rotation order"});
sceneClass.setGroup("Transform", NoiseMap_v2_attr::attrRotationOrder);
sceneClass.setEnumValue(NoiseMap_v2_attr::attrRotationOrder, 0, "xyz");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrRotationOrder, 1, "xzy");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrRotationOrder, 2, "yxz");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrRotationOrder, 3, "yzx");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrRotationOrder, 4, "zxy");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrRotationOrder, 5, "zyx");
sceneClass.setMetadata(NoiseMap_v2_attr::attrRotationOrder, "label", "rotation order");
sceneClass.setMetadata(NoiseMap_v2_attr::attrRotationOrder, "comment", "Order in which to apply the euler rotations");
NoiseMap_v2_attr::attrTransformationOrder = sceneClass.declareAttribute<Int>("transformation_order", 4, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"transformation order"});
sceneClass.setGroup("Transform", NoiseMap_v2_attr::attrTransformationOrder);
sceneClass.setEnumValue(NoiseMap_v2_attr::attrTransformationOrder, 0, "srt");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrTransformationOrder, 1, "str");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrTransformationOrder, 2, "rst");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrTransformationOrder, 3, "rts");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrTransformationOrder, 4, "tsr");
sceneClass.setEnumValue(NoiseMap_v2_attr::attrTransformationOrder, 5, "trs");
sceneClass.setMetadata(NoiseMap_v2_attr::attrTransformationOrder, "label", "transformation order");
sceneClass.setMetadata(NoiseMap_v2_attr::attrTransformationOrder, "comment", "Order in which to apply the translation, rotation, and frequency");
RDL2_DSO_ATTR_END
using namespace NoiseMap_v2_attr;
