#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(NoiseWorleyMap_v2_attr)
AttributeKey<Int> attrSeed;
AttributeKey<Float> attrFrequency;
AttributeKey<Float> attrJitter;
AttributeKey<Float> attrMaxLevel;
AttributeKey<Rgb> attrColorA;
AttributeKey<Rgb> attrColorB;
AttributeKey<Int> attrOutputMode;
AttributeKey<Int> attrDistanceMethod;
AttributeKey<Float> attrMinkowskiNumber;
AttributeKey<Int> attrSpace;
AttributeKey<Vec3f> attrInputTextureCoordinate;
AttributeKey<SceneObject*> attrObject;
AttributeKey<SceneObject*> attrCamera;
AttributeKey<Float> attrPointSize;
AttributeKey<Vec2f> attrRemap;
AttributeKey<Bool> attrUseSmoothstep;
AttributeKey<Vec2f> attrSmoothstep;
AttributeKey<Float> attrBias;
AttributeKey<Float> attrGain;
AttributeKey<Bool> attrInvert;
AttributeKey<Vec3f> attrTranslation;
AttributeKey<Vec3f> attrScale;
AttributeKey<Vec3f> attrRotation;
AttributeKey<Int> attrRotationOrder;
AttributeKey<Int> attrTransformationOrder;
AttributeKey<Float> attrF1;
AttributeKey<Float> attrF2;
AttributeKey<Float> attrF3;
AttributeKey<Float> attrF4;
AttributeKey<Int> attrCellId;
RDL2_DSO_ATTR_DEFINE(Map)
NoiseWorleyMap_v2_attr::attrSeed = sceneClass.declareAttribute<Int>("seed", 0, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrSeed, "comment", "The seed for the random number generator");
NoiseWorleyMap_v2_attr::attrFrequency = sceneClass.declareAttribute<Float>("frequency", 1.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrFrequency, "comment", "Scalar multiplier for the frequency vector");
NoiseWorleyMap_v2_attr::attrJitter = sceneClass.declareAttribute<Float>("jitter", 1.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrJitter, "comment", "Controls the distortion of the cells");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrJitter, "min", "0.0f");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrJitter, "max", "1.0f");
NoiseWorleyMap_v2_attr::attrMaxLevel = sceneClass.declareAttribute<Float>("max_level", 1.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrMaxLevel, "label", "max level");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrMaxLevel, "comment", "Number of octaves of noise to add together for the final result");
NoiseWorleyMap_v2_attr::attrColorA = sceneClass.declareAttribute<Rgb>("color_A", Rgb(0.f, 0.f, 0.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"color A"});
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrColorA, "label", "color A");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrColorA, "comment", "The interpolated color value at distance equals zero");
NoiseWorleyMap_v2_attr::attrColorB = sceneClass.declareAttribute<Rgb>("color_B", Rgb(1.f, 1.f, 1.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"color B"});
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrColorB, "label", "color B");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrColorB, "comment", "The interpolated color value at distance equals one");
NoiseWorleyMap_v2_attr::attrOutputMode = sceneClass.declareAttribute<Int>("output_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"output mode"});
sceneClass.setGroup("Output", NoiseWorleyMap_v2_attr::attrOutputMode);
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrOutputMode, 0, "distance");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrOutputMode, 1, "gradient");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrOutputMode, 2, "cell id");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrOutputMode, 3, "cell edges");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrOutputMode, 4, "points");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrOutputMode, "label", "output mode");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrOutputMode, "comment", "Method by which the shader outputs a color.  Distance uses F1..F4 interpolated between color A and color B, gradient outputs the gradient of the noise, and cell ID outputs a random color for each cell");
NoiseWorleyMap_v2_attr::attrDistanceMethod = sceneClass.declareAttribute<Int>("distance_method", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"distance method"});
sceneClass.setGroup("Output", NoiseWorleyMap_v2_attr::attrDistanceMethod);
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrDistanceMethod, 0, "linear");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrDistanceMethod, 1, "linear squared");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrDistanceMethod, 2, "manhattan");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrDistanceMethod, 3, "chebyshev");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrDistanceMethod, 4, "quadratic");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrDistanceMethod, 5, "minkowski");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrDistanceMethod, "label", "distance method");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrDistanceMethod, "enable if", "OrderedDict({'output_mode': 'distance'})");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrDistanceMethod, "comment", "Metric for calculating distance to feature points which controls the shape of the falloff when output mode is distance");
NoiseWorleyMap_v2_attr::attrMinkowskiNumber = sceneClass.declareAttribute<Float>("minkowski_number", 3.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"minkowski number"});
sceneClass.setGroup("Output", NoiseWorleyMap_v2_attr::attrMinkowskiNumber);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrMinkowskiNumber, "label", "minkowski number");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrMinkowskiNumber, "enable if", "OrderedDict({'distance_method': 'minkowski'})");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrMinkowskiNumber, "comment", "Exponent on distances when distance method is set to Minkowski");
NoiseWorleyMap_v2_attr::attrSpace = sceneClass.declareAttribute<Int>("space", 2, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Space", NoiseWorleyMap_v2_attr::attrSpace);
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrSpace, 0, "render");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrSpace, 1, "camera");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrSpace, 2, "world");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrSpace, 3, "screen");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrSpace, 4, "object");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrSpace, 5, "reference");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrSpace, 6, "texture");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrSpace, 7, "input texture coordinates");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrSpace, 8, "hair_surface_uv");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrSpace, 9, "hair_closest_surface_uv");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrSpace, "comment", "The space to calculate the noise in");
NoiseWorleyMap_v2_attr::attrInputTextureCoordinate = sceneClass.declareAttribute<Vec3f>("input_texture_coordinates", Vec3f(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"input texture coordinates"});
sceneClass.setGroup("Space", NoiseWorleyMap_v2_attr::attrInputTextureCoordinate);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrInputTextureCoordinate, "label", "input texture coordinates");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrInputTextureCoordinate, "enable if", "OrderedDict({'space': 'texture'})");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrInputTextureCoordinate, "comment", "User specified UVs");
NoiseWorleyMap_v2_attr::attrObject = sceneClass.declareAttribute<SceneObject*>("object_space", FLAGS_NONE, INTERFACE_GEOMETRY, {"object space"});
sceneClass.setGroup("Space", NoiseWorleyMap_v2_attr::attrObject);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrObject, "label", "object space");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrObject, "comment", "Directly connect object to use that object's space.");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrObject, "enable if", "OrderedDict({'space': 'object'})");
NoiseWorleyMap_v2_attr::attrCamera = sceneClass.declareAttribute<SceneObject*>("camera", FLAGS_NONE, INTERFACE_CAMERA, {});
sceneClass.setGroup("Space", NoiseWorleyMap_v2_attr::attrCamera);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrCamera, "comment", "Camera used to define camera and screen space");
NoiseWorleyMap_v2_attr::attrPointSize = sceneClass.declareAttribute<Float>("point_size", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", NoiseWorleyMap_v2_attr::attrPointSize);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrPointSize, "label", "point size");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrPointSize, "comment", "For points output mode, relative radius of points");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrPointSize, "disable when", "{ output_mode != points }");
NoiseWorleyMap_v2_attr::attrRemap = sceneClass.declareAttribute<Vec2f>("remap", Vec2f(0.f, 1.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", NoiseWorleyMap_v2_attr::attrRemap);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrRemap, "comment", "Allows mapping the distances from the specified min/max range into the 0..1 range");
NoiseWorleyMap_v2_attr::attrUseSmoothstep = sceneClass.declareAttribute<Bool>("use_smoothstep", false, FLAGS_NONE, INTERFACE_GENERIC, {"use smoothstep"});
sceneClass.setGroup("Adjustment", NoiseWorleyMap_v2_attr::attrUseSmoothstep);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrUseSmoothstep, "label", "use smoothstep");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrUseSmoothstep, "comment", "Put the noise value through a smoothstep function defined by min/max");
NoiseWorleyMap_v2_attr::attrSmoothstep = sceneClass.declareAttribute<Vec2f>("smoothstep", Vec2f(0.f, 1.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", NoiseWorleyMap_v2_attr::attrSmoothstep);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrSmoothstep, "comment", "min/max values between which the smoothstep will interpolate");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrSmoothstep, "enable if", "OrderedDict({'use_smoothstep': 'true'})");
NoiseWorleyMap_v2_attr::attrBias = sceneClass.declareAttribute<Float>("bias", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", NoiseWorleyMap_v2_attr::attrBias);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrBias, "comment", "Bias of interpolation from color A to color B");
NoiseWorleyMap_v2_attr::attrGain = sceneClass.declareAttribute<Float>("gain", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", NoiseWorleyMap_v2_attr::attrGain);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrGain, "comment", "Gain of interpolation from color A to color B");
NoiseWorleyMap_v2_attr::attrInvert = sceneClass.declareAttribute<Bool>("invert", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Adjustment", NoiseWorleyMap_v2_attr::attrInvert);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrInvert, "comment", "Invert the final pattern");
NoiseWorleyMap_v2_attr::attrTranslation = sceneClass.declareAttribute<Vec3f>("translation", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Transform", NoiseWorleyMap_v2_attr::attrTranslation);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrTranslation, "comment", "Translation of the noise in space");
NoiseWorleyMap_v2_attr::attrScale = sceneClass.declareAttribute<Vec3f>("scale", 1.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Transform", NoiseWorleyMap_v2_attr::attrScale);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrScale, "comment", "Vector to scale the noise non-proportionally");
NoiseWorleyMap_v2_attr::attrRotation = sceneClass.declareAttribute<Vec3f>("rotation", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Transform", NoiseWorleyMap_v2_attr::attrRotation);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrRotation, "comment", "Rotates the noise in space based on the specified rotation order");
NoiseWorleyMap_v2_attr::attrRotationOrder = sceneClass.declareAttribute<Int>("rotation_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"rotation order"});
sceneClass.setGroup("Transform", NoiseWorleyMap_v2_attr::attrRotationOrder);
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrRotationOrder, 0, "xyz");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrRotationOrder, 1, "xzy");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrRotationOrder, 2, "yxz");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrRotationOrder, 3, "yzx");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrRotationOrder, 4, "zxy");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrRotationOrder, 5, "zyx");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrRotationOrder, "label", "rotation order");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrRotationOrder, "comment", "Order in which to apply the euler rotations");
NoiseWorleyMap_v2_attr::attrTransformationOrder = sceneClass.declareAttribute<Int>("transformation_order", 4, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"transformation order"});
sceneClass.setGroup("Transform", NoiseWorleyMap_v2_attr::attrTransformationOrder);
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrTransformationOrder, 0, "srt");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrTransformationOrder, 1, "str");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrTransformationOrder, 2, "rst");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrTransformationOrder, 3, "rts");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrTransformationOrder, 4, "tsr");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrTransformationOrder, 5, "trs");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrTransformationOrder, "label", "transformation order");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrTransformationOrder, "comment", "Order in which to apply the translation, rotation, and frequency");
NoiseWorleyMap_v2_attr::attrF1 = sceneClass.declareAttribute<Float>("F1", 1.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", NoiseWorleyMap_v2_attr::attrF1);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrF1, "comment", "Influence of F1 (the closest feature point)");
NoiseWorleyMap_v2_attr::attrF2 = sceneClass.declareAttribute<Float>("F2", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", NoiseWorleyMap_v2_attr::attrF2);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrF2, "comment", "Influence of F2 (the second closest feature point)");
NoiseWorleyMap_v2_attr::attrF3 = sceneClass.declareAttribute<Float>("F3", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", NoiseWorleyMap_v2_attr::attrF3);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrF3, "comment", "Influence of F3 (the third closest feature point)");
NoiseWorleyMap_v2_attr::attrF4 = sceneClass.declareAttribute<Float>("F4", 0.f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", NoiseWorleyMap_v2_attr::attrF4);
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrF4, "comment", "Influence of F4 (the fourth closest feature point)");
NoiseWorleyMap_v2_attr::attrCellId = sceneClass.declareAttribute<Int>("cell_id", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"cell id"});
sceneClass.setGroup("Advanced", NoiseWorleyMap_v2_attr::attrCellId);
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrCellId, 0, "f1");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrCellId, 1, "f2");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrCellId, 2, "f3");
sceneClass.setEnumValue(NoiseWorleyMap_v2_attr::attrCellId, 3, "f4");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrCellId, "label", "cell id");
sceneClass.setMetadata(NoiseWorleyMap_v2_attr::attrCellId, "comment", "Which of the distances determines the cell id");
RDL2_DSO_ATTR_END
using namespace NoiseWorleyMap_v2_attr;
