#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(OpMap_attr)
AttributeKey<Int> attrOperation;
AttributeKey<Rgb> attrOp1;
AttributeKey<Rgb> attrOp2;
AttributeKey<Float> attrOp1Factor;
AttributeKey<Float> attrOp2Factor;
AttributeKey<Bool> attrClamp;
AttributeKey<Float> attrTolerance;
RDL2_DSO_ATTR_DEFINE(Map)
OpMap_attr::attrOperation = sceneClass.declareAttribute<Int>("operation", FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(OpMap_attr::attrOperation, 0, "add");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 1, "subtract");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 2, "multiply");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 3, "divide");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 4, "maximum");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 5, "minimum");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 6, "power");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 7, "cross");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 8, "dot");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 9, "invert op1");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 10, "normalize op1");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 11, "op1");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 12, "op2");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 13, "overlay");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 14, "screen");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 15, "abs");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 16, "ceil");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 17, "floor");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 18, "modulo");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 19, "fraction");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 20, "length");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 21, "sine");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 22, "cosine");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 23, "round");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 24, "acos");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 25, "less_than");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 26, "less_than_or_equal");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 27, "greater_than");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 28, "greater_than_or_equal");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 29, "equal");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 30, "not equal");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 31, "and");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 32, "or");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 33, "not");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 34, "xor");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 35, "bit_shift_left");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 36, "bit_shift_right");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 37, "bitwise_and");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 38, "bitwise_or");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 39, "vector_equal");
sceneClass.setEnumValue(OpMap_attr::attrOperation, 40, "vector_not_equal");
sceneClass.setMetadata(OpMap_attr::attrOperation, "comment", "Operation");
OpMap_attr::attrOp1 = sceneClass.declareAttribute<Rgb>("op1", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(OpMap_attr::attrOp1, "comment", "First operand");
OpMap_attr::attrOp2 = sceneClass.declareAttribute<Rgb>("op2", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(OpMap_attr::attrOp2, "comment", "Second operand");
OpMap_attr::attrOp1Factor = sceneClass.declareAttribute<Float>("op1_factor", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"op1 factor"});
sceneClass.setMetadata(OpMap_attr::attrOp1Factor, "label", "op1 factor");
sceneClass.setMetadata(OpMap_attr::attrOp1Factor, "comment", "Scalar multiplier on op1");
OpMap_attr::attrOp2Factor = sceneClass.declareAttribute<Float>("op2_factor", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"op2 factor"});
sceneClass.setMetadata(OpMap_attr::attrOp2Factor, "label", "op2 factor");
sceneClass.setMetadata(OpMap_attr::attrOp2Factor, "comment", "Scalar multiplier on op2");
OpMap_attr::attrClamp = sceneClass.declareAttribute<Bool>("clamp", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(OpMap_attr::attrClamp, "comment", "Whether to clamp result to 0 - 1");
OpMap_attr::attrTolerance = sceneClass.declareAttribute<Float>("tolerance", 0.001f, FLAGS_NONE, INTERFACE_GENERIC, {"epsilon"});
sceneClass.setMetadata(OpMap_attr::attrTolerance, "label", "tolerance");
sceneClass.setMetadata(OpMap_attr::attrTolerance, "disable when", "{ operation != 29 && operation != 30 && operation < 39 }");
sceneClass.setMetadata(OpMap_attr::attrTolerance, "comment", "Epsilon. Sets range for almost-equals checking of values");
RDL2_DSO_ATTR_END
using namespace OpMap_attr;
