#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ProjectCameraMap_attr)
AttributeKey<SceneObject*> attrProjector;
AttributeKey<Bool> attrProjectOnBackFaces;
AttributeKey<Bool> attrBlackOutsideProjection;
AttributeKey<Bool> attrUseReferenceSpace;
AttributeKey<Bool> attrUseCustomWindowCoordinates;
AttributeKey<Float> attrWindowXMin;
AttributeKey<Float> attrWindowXMax;
AttributeKey<Float> attrWindowYMin;
AttributeKey<Float> attrWindowYMax;
RDL2_DSO_ATTR_DEFINE(Map)
ProjectCameraMap_attr::attrProjector = sceneClass.declareAttribute<SceneObject*>("projector", FLAGS_NONE, INTERFACE_CAMERA, {});
ProjectCameraMap_attr::attrProjectOnBackFaces = sceneClass.declareAttribute<Bool>("project_on_back_faces", false, FLAGS_NONE, INTERFACE_GENERIC, {"project on back faces"});
sceneClass.setMetadata(ProjectCameraMap_attr::attrProjectOnBackFaces, "label", "project on back faces");
sceneClass.setMetadata(ProjectCameraMap_attr::attrProjectOnBackFaces, "comment", "Toggles whether camera projections appear on back faces.");
ProjectCameraMap_attr::attrBlackOutsideProjection = sceneClass.declareAttribute<Bool>("black_outside_projection", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraMap_attr::attrBlackOutsideProjection, "label", "black outside projection");
sceneClass.setMetadata(ProjectCameraMap_attr::attrBlackOutsideProjection, "comment", "Toggles whether projections appear outside the 0-1 uv range of the projector");
ProjectCameraMap_attr::attrUseReferenceSpace = sceneClass.declareAttribute<Bool>("use_reference_space", false, FLAGS_NONE, INTERFACE_GENERIC, {"use reference space"});
sceneClass.setMetadata(ProjectCameraMap_attr::attrUseReferenceSpace, "label", "use reference space");
sceneClass.setMetadata(ProjectCameraMap_attr::attrUseReferenceSpace, "comment", "use reference space");
ProjectCameraMap_attr::attrUseCustomWindowCoordinates = sceneClass.declareAttribute<Bool>("use_custom_window_coordinates", false, FLAGS_NONE, INTERFACE_GENERIC, {"use custom window coordinates"});
sceneClass.setMetadata(ProjectCameraMap_attr::attrUseCustomWindowCoordinates, "label", "use custom window coordinates");
sceneClass.setMetadata(ProjectCameraMap_attr::attrUseCustomWindowCoordinates, "comment", "used to apply non-uniform scaling to projection");
ProjectCameraMap_attr::attrWindowXMin = sceneClass.declareAttribute<Float>("window_x_min", -1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"window x min"});
sceneClass.setMetadata(ProjectCameraMap_attr::attrWindowXMin, "label", "window x min");
sceneClass.setMetadata(ProjectCameraMap_attr::attrWindowXMin, "comment", "minimum projected x coordinate");
ProjectCameraMap_attr::attrWindowXMax = sceneClass.declareAttribute<Float>("window_x_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"window x max"});
sceneClass.setMetadata(ProjectCameraMap_attr::attrWindowXMax, "label", "window x max");
sceneClass.setMetadata(ProjectCameraMap_attr::attrWindowXMax, "comment", "maximum projected x coordinate");
ProjectCameraMap_attr::attrWindowYMin = sceneClass.declareAttribute<Float>("window_y_min", -1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"window y min"});
sceneClass.setMetadata(ProjectCameraMap_attr::attrWindowYMin, "label", "window y min");
sceneClass.setMetadata(ProjectCameraMap_attr::attrWindowYMin, "comment", "minimum projected y coordinate");
ProjectCameraMap_attr::attrWindowYMax = sceneClass.declareAttribute<Float>("window_y_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"window y max"});
sceneClass.setMetadata(ProjectCameraMap_attr::attrWindowYMax, "label", "window y max");
sceneClass.setMetadata(ProjectCameraMap_attr::attrWindowYMax, "comment", "maximum projected y coordinate");
RDL2_DSO_ATTR_END
using namespace ProjectCameraMap_attr;
