#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ProjectCameraMap_v2_attr)
AttributeKey<SceneObject*> attrProjector;
AttributeKey<Bool> attrProjectOnBackFaces;
AttributeKey<Bool> attrBlackOutsideProjection;
AttributeKey<Bool> attrUseReferenceSpace;
AttributeKey<String> attrTexture;
AttributeKey<Bool> attrAlphaOnly;
AttributeKey<Bool> attrUnpremultiply;
AttributeKey<Int> attrAspectRatioSource;
AttributeKey<Float> attrCustomAspectRatio;
AttributeKey<Int> attrGamma;
RDL2_DSO_ATTR_DEFINE(Map)
ProjectCameraMap_v2_attr::attrProjector = sceneClass.declareAttribute<SceneObject*>("projector", FLAGS_NONE, INTERFACE_CAMERA, {});
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrProjector, "comment", "The camera to project from");
ProjectCameraMap_v2_attr::attrProjectOnBackFaces = sceneClass.declareAttribute<Bool>("project_on_back_faces", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrProjectOnBackFaces, "label", "project on back faces");
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrProjectOnBackFaces, "comment", "Toggles whether camera projections appear on back faces.");
ProjectCameraMap_v2_attr::attrBlackOutsideProjection = sceneClass.declareAttribute<Bool>("black_outside_projection", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrBlackOutsideProjection, "label", "black outside projection");
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrBlackOutsideProjection, "comment", "Toggles whether projections appear outside the 0-1 uv range of the projector");
ProjectCameraMap_v2_attr::attrUseReferenceSpace = sceneClass.declareAttribute<Bool>("use_reference_space", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrUseReferenceSpace, "label", "use reference space");
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrUseReferenceSpace, "comment", "Use reference space");
ProjectCameraMap_v2_attr::attrTexture = sceneClass.declareAttribute<String>("texture", FLAGS_FILENAME, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrTexture, "comment", "Filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
ProjectCameraMap_v2_attr::attrAlphaOnly = sceneClass.declareAttribute<Bool>("alpha_only", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrAlphaOnly, "label", "alpha only");
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrAlphaOnly, "comment", "When enabled, the alpha channel is returned instead of RGB");
ProjectCameraMap_v2_attr::attrUnpremultiply = sceneClass.declareAttribute<Bool>("unpremultiply", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrUnpremultiply, "comment", "When enabled, the rgb channels are divided by the alpha channel (where non-zero)");
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrUnpremultiply, "enable if", "OrderedDict({'alpha_only': 'true'})");
ProjectCameraMap_v2_attr::attrAspectRatioSource = sceneClass.declareAttribute<Int>("aspect_ratio_source", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectCameraMap_v2_attr::attrAspectRatioSource, 0, "from texture");
sceneClass.setEnumValue(ProjectCameraMap_v2_attr::attrAspectRatioSource, 1, "custom");
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrAspectRatioSource, "label", "aspect ratio source");
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrAspectRatioSource, "comment", "Whether to use the image and pixel aspect ratio of the texture being projected, or a custom aspect ratio");
ProjectCameraMap_v2_attr::attrCustomAspectRatio = sceneClass.declareAttribute<Float>("custom_aspect_ratio", 1.f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrCustomAspectRatio, "label", "custom aspect ratio");
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrCustomAspectRatio, "comment", "Custom aspect ratio for the projected texture");
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrCustomAspectRatio, "enable if", "OrderedDict({'aspect_ratio_source': '1'})");
ProjectCameraMap_v2_attr::attrGamma = sceneClass.declareAttribute<Int>("gamma", 2, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectCameraMap_v2_attr::attrGamma, 0, "off");
sceneClass.setEnumValue(ProjectCameraMap_v2_attr::attrGamma, 1, "on");
sceneClass.setEnumValue(ProjectCameraMap_v2_attr::attrGamma, 2, "auto");
sceneClass.setMetadata(ProjectCameraMap_v2_attr::attrGamma, "comment", "Controls application of gamma to images (off -0, on - 1, auto - 2).   Auto will apply gamma decoding to 8-bit images");
RDL2_DSO_ATTR_END
using namespace ProjectCameraMap_v2_attr;
