#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ProjectCylindricalMap_attr)
AttributeKey<Bool> attrUseReferenceSpace;
AttributeKey<Bool> attrProjectInward;
AttributeKey<Bool> attrProjectOutward;
AttributeKey<Bool> attrBlackOutsideProjection;
AttributeKey<Int> attrProjectionMode;
AttributeKey<SceneObject*> attrProjector;
AttributeKey<Mat4d> attrProjectionMatrix;
AttributeKey<Int> attrTRSOrder;
AttributeKey<Int> attrRotationOrder;
AttributeKey<Vec3d> attrTranslate;
AttributeKey<Vec3d> attrRotate;
AttributeKey<Vec3d> attrScale;
RDL2_DSO_ATTR_DEFINE(Map)
ProjectCylindricalMap_attr::attrUseReferenceSpace = sceneClass.declareAttribute<Bool>("use_reference_space", false, FLAGS_NONE, INTERFACE_GENERIC, {"use reference space"});
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrUseReferenceSpace, "label", "use reference space");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrUseReferenceSpace, "comment", "Use reference space");
ProjectCylindricalMap_attr::attrProjectInward = sceneClass.declareAttribute<Bool>("project_on_inward_surfaces", true, FLAGS_NONE, INTERFACE_GENERIC, {"project on inward surfaces"});
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrProjectInward, "display_name", "project on inward surfaces");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrProjectInward, "comment", "Enables projection on surfaces with inward facing normals");
ProjectCylindricalMap_attr::attrProjectOutward = sceneClass.declareAttribute<Bool>("project_on_outward_surfaces", true, FLAGS_NONE, INTERFACE_GENERIC, {"project on outward surfaces"});
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrProjectOutward, "display_name", "project on outward surfaces");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrProjectOutward, "comment", "Enables projection on surfaces with outward facing normals");
ProjectCylindricalMap_attr::attrBlackOutsideProjection = sceneClass.declareAttribute<Bool>("black_outside_projection", true, FLAGS_NONE, INTERFACE_GENERIC, {"black outside projection"});
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrBlackOutsideProjection, "label", "black outside projection");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrBlackOutsideProjection, "comment", "Toggles whether projections appear outside the 0-1 uv range of the projector");
ProjectCylindricalMap_attr::attrProjectionMode = sceneClass.declareAttribute<Int>("projection_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrProjectionMode, 0, "projector");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrProjectionMode, 1, "projection_matrix");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrProjectionMode, 2, "TRS");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrProjectionMode, "comment", "Source parameters to use for projection transform");
ProjectCylindricalMap_attr::attrProjector = sceneClass.declareAttribute<SceneObject*>("projector", FLAGS_NONE, INTERFACE_NODE, {});
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrProjector, "enable if", "OrderedDict({'projection_mode': 'projector'})");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrProjector, "comment", "The object whose transform to use for projection when 'projection_mode' is set to 'projector'");
ProjectCylindricalMap_attr::attrProjectionMatrix = sceneClass.declareAttribute<Mat4d>("projection_matrix", Mat4d(1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrProjectionMatrix, "label", "projection matrix");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrProjectionMatrix, "enable if", "OrderedDict({'projection_mode': 'projection_matrix'})");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrProjectionMatrix, "comment", "The transform to use for projection when 'projection_mode' is set to 'projection_matrix'");
ProjectCylindricalMap_attr::attrTRSOrder = sceneClass.declareAttribute<Int>("TRS_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrTRSOrder, 0, "Scale Rot Trans");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrTRSOrder, 1, "Scale Trans Rot");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrTRSOrder, 2, "Rot Scale Trans");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrTRSOrder, 3, "Rot Trans Scale");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrTRSOrder, 4, "Trans Scale Rot");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrTRSOrder, 5, "Trans Rot Scale");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrTRSOrder, "label", "TRS order");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrTRSOrder, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrTRSOrder, "comment", "Order in which to apply transformations when 'projection_mode' is set to 'TRS'");
ProjectCylindricalMap_attr::attrRotationOrder = sceneClass.declareAttribute<Int>("rotation_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrRotationOrder, 0, "xyz");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrRotationOrder, 1, "xzy");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrRotationOrder, 2, "yxz");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrRotationOrder, 3, "yzx");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrRotationOrder, 4, "zxy");
sceneClass.setEnumValue(ProjectCylindricalMap_attr::attrRotationOrder, 5, "zyx");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrRotationOrder, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrRotationOrder, "comment", "Order in which to apply rotation transformations when 'projection_mode' is set to 'TRS'");
ProjectCylindricalMap_attr::attrTranslate = sceneClass.declareAttribute<Vec3d>("translate", Vec3d(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrTranslate, "label", "translate");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrTranslate, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrTranslate, "comment", "Translation of the projection transform when 'projection_mode' is set to 'TRS'");
ProjectCylindricalMap_attr::attrRotate = sceneClass.declareAttribute<Vec3d>("rotate", Vec3d(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrRotate, "label", "rotate");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrRotate, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrRotate, "comment", "Rotation of the projection transform when 'projection_mode' is set to 'TRS'");
ProjectCylindricalMap_attr::attrScale = sceneClass.declareAttribute<Vec3d>("scale", Vec3d(1.0f, 1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrScale, "label", "scale");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrScale, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectCylindricalMap_attr::attrScale, "comment", "Scale of the projection transform when 'projection_mode' is set to 'TRS'");
RDL2_DSO_ATTR_END
using namespace ProjectCylindricalMap_attr;
