#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ProjectPlanarMap_attr)
AttributeKey<Bool> attrProjectOnBackFaces;
AttributeKey<Bool> attrBlackOutsideProjection;
AttributeKey<Bool> attrUseReferenceSpace;
AttributeKey<Int> attrProjectionMode;
AttributeKey<SceneObject*> attrProjector;
AttributeKey<Mat4d> attrProjectionMatrix;
AttributeKey<Int> attrTRSOrder;
AttributeKey<Int> attrRotationOrder;
AttributeKey<Vec3d> attrTranslate;
AttributeKey<Vec3d> attrRotate;
AttributeKey<Vec3d> attrScale;
RDL2_DSO_ATTR_DEFINE(Map)
ProjectPlanarMap_attr::attrProjectOnBackFaces = sceneClass.declareAttribute<Bool>("project_on_back_faces", true, FLAGS_NONE, INTERFACE_GENERIC, {"project on back faces"});
sceneClass.setMetadata(ProjectPlanarMap_attr::attrProjectOnBackFaces, "label", "project on back faces");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrProjectOnBackFaces, "comment", "Toggles whether projections appear on back faces relative to projector");
ProjectPlanarMap_attr::attrBlackOutsideProjection = sceneClass.declareAttribute<Bool>("black_outside_projection", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectPlanarMap_attr::attrBlackOutsideProjection, "label", "black outside projection");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrBlackOutsideProjection, "comment", "Toggles whether projections appear outside the 0-1 uv range of the projector");
ProjectPlanarMap_attr::attrUseReferenceSpace = sceneClass.declareAttribute<Bool>("use_reference_space", false, FLAGS_NONE, INTERFACE_GENERIC, {"use reference space"});
sceneClass.setMetadata(ProjectPlanarMap_attr::attrUseReferenceSpace, "label", "use reference space");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrUseReferenceSpace, "comment", "Use reference space");
ProjectPlanarMap_attr::attrProjectionMode = sceneClass.declareAttribute<Int>("projection_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrProjectionMode, 0, "projector");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrProjectionMode, 1, "projection_matrix");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrProjectionMode, 2, "TRS");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrProjectionMode, "comment", "Source parameters to use for projection transform");
ProjectPlanarMap_attr::attrProjector = sceneClass.declareAttribute<SceneObject*>("projector", FLAGS_NONE, INTERFACE_NODE, {});
sceneClass.setMetadata(ProjectPlanarMap_attr::attrProjector, "enable if", "OrderedDict({'projection_mode': 'projector'})");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrProjector, "comment", "The object whose transform to use for projection when 'projection_mode' is set to 'projector'");
ProjectPlanarMap_attr::attrProjectionMatrix = sceneClass.declareAttribute<Mat4d>("projection_matrix", Mat4d(1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectPlanarMap_attr::attrProjectionMatrix, "label", "projection matrix");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrProjectionMatrix, "enable if", "OrderedDict({'projection_mode': 'projection_matrix'})");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrProjectionMatrix, "comment", "The transform to use for projection when 'projection_mode' is set to 'projection_matrix'");
ProjectPlanarMap_attr::attrTRSOrder = sceneClass.declareAttribute<Int>("TRS_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrTRSOrder, 0, "Scale Rot Trans");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrTRSOrder, 1, "Scale Trans Rot");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrTRSOrder, 2, "Rot Scale Trans");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrTRSOrder, 3, "Rot Trans Scale");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrTRSOrder, 4, "Trans Scale Rot");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrTRSOrder, 5, "Trans Rot Scale");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrTRSOrder, "label", "TRS order");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrTRSOrder, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrTRSOrder, "comment", "Order in which to apply transformations when 'projection_mode' is set to 'TRS'");
ProjectPlanarMap_attr::attrRotationOrder = sceneClass.declareAttribute<Int>("rotation_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrRotationOrder, 0, "xyz");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrRotationOrder, 1, "xzy");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrRotationOrder, 2, "yxz");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrRotationOrder, 3, "yzx");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrRotationOrder, 4, "zxy");
sceneClass.setEnumValue(ProjectPlanarMap_attr::attrRotationOrder, 5, "zyx");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrRotationOrder, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrRotationOrder, "comment", "Order in which to apply rotation transformations when 'projection_mode' is set to 'TRS'");
ProjectPlanarMap_attr::attrTranslate = sceneClass.declareAttribute<Vec3d>("translate", Vec3d(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectPlanarMap_attr::attrTranslate, "label", "translate");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrTranslate, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrTranslate, "comment", "Translation of the projection transform when 'projection_mode' is set to 'TRS'");
ProjectPlanarMap_attr::attrRotate = sceneClass.declareAttribute<Vec3d>("rotate", Vec3d(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectPlanarMap_attr::attrRotate, "label", "rotate");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrRotate, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrRotate, "comment", "Rotation of the projection transform when 'projection_mode' is set to 'TRS'");
ProjectPlanarMap_attr::attrScale = sceneClass.declareAttribute<Vec3d>("scale", Vec3d(1.0f, 1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectPlanarMap_attr::attrScale, "label", "scale");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrScale, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectPlanarMap_attr::attrScale, "comment", "Scale of the projection transform when 'projection_mode' is set to 'TRS'");
RDL2_DSO_ATTR_END
using namespace ProjectPlanarMap_attr;
