#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ProjectTriplanarMap_attr)
AttributeKey<Bool> attrUseReferenceSpace;
AttributeKey<Int> attrGamma;
AttributeKey<Int> attrDebugMode;
AttributeKey<Int> attrNumTextures;
AttributeKey<Float> attrTransitionWidth;
AttributeKey<Int> attrRandomSeed;
AttributeKey<Bool> attrRandomRot;
AttributeKey<Bool> attrRandomFlip;
AttributeKey<Bool> attrRandomOffset;
AttributeKey<Bool> attrPXActive;
AttributeKey<String> attrPXTexture;
AttributeKey<Bool> attrPYActive;
AttributeKey<String> attrPYTexture;
AttributeKey<Bool> attrPZActive;
AttributeKey<String> attrPZTexture;
AttributeKey<Bool> attrNXActive;
AttributeKey<String> attrNXTexture;
AttributeKey<Bool> attrNYActive;
AttributeKey<String> attrNYTexture;
AttributeKey<Bool> attrNZActive;
AttributeKey<String> attrNZTexture;
AttributeKey<Vec2f> attrPXScale;
AttributeKey<Vec2f> attrPXOffset;
AttributeKey<Bool> attrPXInvS;
AttributeKey<Bool> attrPXInvT;
AttributeKey<Bool> attrPXSwapST;
AttributeKey<float> attrPXRot;
AttributeKey<Vec2f> attrPXRotCntr;
AttributeKey<Bool> attrPXWrap;
AttributeKey<Vec2f> attrPYScale;
AttributeKey<Vec2f> attrPYOffset;
AttributeKey<Bool> attrPYInvS;
AttributeKey<Bool> attrPYInvT;
AttributeKey<Bool> attrPYSwapST;
AttributeKey<float> attrPYRot;
AttributeKey<Vec2f> attrPYRotCntr;
AttributeKey<Bool> attrPYWrap;
AttributeKey<Vec2f> attrPZScale;
AttributeKey<Vec2f> attrPZOffset;
AttributeKey<Bool> attrPZInvS;
AttributeKey<Bool> attrPZInvT;
AttributeKey<Bool> attrPZSwapST;
AttributeKey<float> attrPZRot;
AttributeKey<Vec2f> attrPZRotCntr;
AttributeKey<Bool> attrPZWrap;
AttributeKey<Vec2f> attrNXScale;
AttributeKey<Vec2f> attrNXOffset;
AttributeKey<Bool> attrNXInvS;
AttributeKey<Bool> attrNXInvT;
AttributeKey<Bool> attrNXSwapST;
AttributeKey<float> attrNXRot;
AttributeKey<Vec2f> attrNXRotCntr;
AttributeKey<Bool> attrNXWrap;
AttributeKey<Vec2f> attrNYScale;
AttributeKey<Vec2f> attrNYOffset;
AttributeKey<Bool> attrNYInvS;
AttributeKey<Bool> attrNYInvT;
AttributeKey<Bool> attrNYSwapST;
AttributeKey<float> attrNYRot;
AttributeKey<Vec2f> attrNYRotCntr;
AttributeKey<Bool> attrNYWrap;
AttributeKey<Vec2f> attrNZScale;
AttributeKey<Vec2f> attrNZOffset;
AttributeKey<Bool> attrNZInvS;
AttributeKey<Bool> attrNZInvT;
AttributeKey<Bool> attrNZSwapST;
AttributeKey<float> attrNZRot;
AttributeKey<Vec2f> attrNZRotCntr;
AttributeKey<Bool> attrNZWrap;
AttributeKey<Int> attrProjectionMode;
AttributeKey<SceneObject*> attrProjector;
AttributeKey<Mat4d> attrProjectionMatrix;
AttributeKey<Int> attrTRSOrder;
AttributeKey<Int> attrRotationOrder;
AttributeKey<Vec3d> attrTranslate;
AttributeKey<Vec3d> attrRotate;
AttributeKey<Vec3d> attrScale;
RDL2_DSO_ATTR_DEFINE(Map)
ProjectTriplanarMap_attr::attrUseReferenceSpace = sceneClass.declareAttribute<Bool>("use_reference_space", false, FLAGS_NONE, INTERFACE_GENERIC, {"use reference space"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrUseReferenceSpace, "label", "use reference space");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrUseReferenceSpace, "comment", "Project onto reference positions ('ref_P') and normals ('ref_N')");
ProjectTriplanarMap_attr::attrGamma = sceneClass.declareAttribute<Int>("gamma", 2, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrGamma, 0, "off");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrGamma, 1, "on");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrGamma, 2, "auto");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrGamma, "comment", "Controls application of gamma to images (off -0, on - 1, auto - 2).   Auto will apply gamma decoding to 8-bit images");
ProjectTriplanarMap_attr::attrDebugMode = sceneClass.declareAttribute<Int>("debug_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrDebugMode, 0, "none");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrDebugMode, 1, "dSdx/dSdy");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrDebugMode, 2, "dTdx/dTdy");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrDebugMode, "comment", "for testing");
ProjectTriplanarMap_attr::attrNumTextures = sceneClass.declareAttribute<Int>("number_of_textures", 3, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"number of textures"});
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrNumTextures, 1, "one");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrNumTextures, 3, "three");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrNumTextures, 6, "six");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNumTextures, "label", "number of textures");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNumTextures, "comment", "Controls the number of active textures.   If set to 'one', only the 'pos x' texture settings will be used for all sides.   If set to 'three' the pos x, pos y, and pos z settings will be used for their respective negative sides.   If set to 'six', each side has independent controls and texture.");
ProjectTriplanarMap_attr::attrTransitionWidth = sceneClass.declareAttribute<Float>("transition_width", 0.5, FLAGS_NONE, INTERFACE_GENERIC, {"transition width"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrTransitionWidth, "label", "transition width");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrTransitionWidth, "comment", "Controls blending of per-axis projections.   Valid range is 0.0 (no blending) to 1.0 (max blending)");
ProjectTriplanarMap_attr::attrRandomSeed = sceneClass.declareAttribute<Int>("random_seed", 8241, FLAGS_NONE, INTERFACE_GENERIC, {"random seed"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRandomSeed, "label", "random seed");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRandomSeed, "comment", "Seed for randomizing orientation, offset, and flip");
ProjectTriplanarMap_attr::attrRandomRot = sceneClass.declareAttribute<Bool>("randomize_rotation", false, FLAGS_NONE, INTERFACE_GENERIC, {"randomize rotation"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRandomRot, "label", "randomize rotation");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRandomRot, "comment", "Random 2d rotation of each active texture");
ProjectTriplanarMap_attr::attrRandomFlip = sceneClass.declareAttribute<Bool>("randomize_flip", false, FLAGS_NONE, INTERFACE_GENERIC, {"randomize flip"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRandomFlip, "label", "randomize flip");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRandomFlip, "comment", "Random flipping in S or T for each active texture");
ProjectTriplanarMap_attr::attrRandomOffset = sceneClass.declareAttribute<Bool>("randomize_offset", false, FLAGS_NONE, INTERFACE_GENERIC, {"randomize offset"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRandomOffset, "label", "randomize offset");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRandomOffset, "comment", "Random offset in S or T for each active texture");
ProjectTriplanarMap_attr::attrPXActive = sceneClass.declareAttribute<Bool>("positive_x_active", true, FLAGS_NONE, INTERFACE_GENERIC, {"positive x active"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXActive, "label", "positive x active");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXActive, "comment", "Turns this direction on/off.  Output is black if off.");
ProjectTriplanarMap_attr::attrPXTexture = sceneClass.declareAttribute<String>("positive_x_texture", FLAGS_FILENAME, INTERFACE_GENERIC, {"positive x texture"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXTexture, "label", "positive x texture");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXTexture, "enable if", "OrderedDict({'positive_x_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXTexture, "comment", "Filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
ProjectTriplanarMap_attr::attrPYActive = sceneClass.declareAttribute<Bool>("positive_y_active", true, FLAGS_NONE, INTERFACE_GENERIC, {"positive y active"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYActive, "label", "positive y active");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYActive, "comment", "Turns this direction on/off.  Output is black if off.");
ProjectTriplanarMap_attr::attrPYTexture = sceneClass.declareAttribute<String>("positive_y_texture", FLAGS_FILENAME, INTERFACE_GENERIC, {"positive y texture"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYTexture, "label", "positive y texture");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYTexture, "enable if", "OrderedDict({'positive_y_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYTexture, "comment", "Filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
ProjectTriplanarMap_attr::attrPZActive = sceneClass.declareAttribute<Bool>("positive_z_active", true, FLAGS_NONE, INTERFACE_GENERIC, {"positive z active"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZActive, "label", "positive z active");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZActive, "comment", "Turns this direction on/off.  Output is black if off.");
ProjectTriplanarMap_attr::attrPZTexture = sceneClass.declareAttribute<String>("positive_z_texture", FLAGS_FILENAME, INTERFACE_GENERIC, {"positive z texture"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZTexture, "label", "positive z texture");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZTexture, "enable if", "OrderedDict({'positive_z_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZTexture, "comment", "Filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
ProjectTriplanarMap_attr::attrNXActive = sceneClass.declareAttribute<Bool>("negative_x_active", true, FLAGS_NONE, INTERFACE_GENERIC, {"negative x active"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXActive, "label", "negative x active");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXActive, "comment", "Turns this direction on/off.  Output is black if off.");
ProjectTriplanarMap_attr::attrNXTexture = sceneClass.declareAttribute<String>("negative_x_texture", FLAGS_FILENAME, INTERFACE_GENERIC, {"negative x texture"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXTexture, "label", "negative x texture");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXTexture, "enable if", "OrderedDict({'negative_x_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXTexture, "comment", "Filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
ProjectTriplanarMap_attr::attrNYActive = sceneClass.declareAttribute<Bool>("negative_y_active", true, FLAGS_NONE, INTERFACE_GENERIC, {"negative y active"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYActive, "label", "negative y active");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYActive, "comment", "Turns this direction on/off.  Output is black if off.");
ProjectTriplanarMap_attr::attrNYTexture = sceneClass.declareAttribute<String>("negative_y_texture", FLAGS_FILENAME, INTERFACE_GENERIC, {"negative y texture"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYTexture, "label", "negative y texture");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYTexture, "enable if", "OrderedDict({'negative_y_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYTexture, "comment", "Filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
ProjectTriplanarMap_attr::attrNZActive = sceneClass.declareAttribute<Bool>("negative_z_active", true, FLAGS_NONE, INTERFACE_GENERIC, {"negative z active"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZActive, "label", "negative z active");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZActive, "comment", "Turns this direction on/off.  Output is black if off.");
ProjectTriplanarMap_attr::attrNZTexture = sceneClass.declareAttribute<String>("negative_z_texture", FLAGS_FILENAME, INTERFACE_GENERIC, {"negative z texture"});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZTexture, "label", "negative z texture");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZTexture, "enable if", "OrderedDict({'negative_z_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZTexture, "comment", "Filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
ProjectTriplanarMap_attr::attrPXScale = sceneClass.declareAttribute<Vec2f>("positive_x_scale", Vec2f(1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"positive x scale"});
sceneClass.setGroup("Positive X Modifiers", ProjectTriplanarMap_attr::attrPXScale);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXScale, "label", "positive x scale");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXScale, "enable if", "OrderedDict({'positive_x_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXScale, "comment", "2D scale");
ProjectTriplanarMap_attr::attrPXOffset = sceneClass.declareAttribute<Vec2f>("positive_x_offset", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"positive x offset"});
sceneClass.setGroup("Positive X Modifiers", ProjectTriplanarMap_attr::attrPXOffset);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXOffset, "label", "positive x offset");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXOffset, "enable if", "OrderedDict({'positive_x_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXOffset, "comment", "2D offset");
ProjectTriplanarMap_attr::attrPXInvS = sceneClass.declareAttribute<Bool>("positive_x_invert_s", false, FLAGS_NONE, INTERFACE_GENERIC, {"positive x invert s"});
sceneClass.setGroup("Positive X Modifiers", ProjectTriplanarMap_attr::attrPXInvS);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXInvS, "label", "positive x invert s");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXInvS, "enable if", "OrderedDict({'positive_x_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXInvS, "comment", "Flip in the s direction (horizontal)");
ProjectTriplanarMap_attr::attrPXInvT = sceneClass.declareAttribute<Bool>("positive_x_invert_t", false, FLAGS_NONE, INTERFACE_GENERIC, {"positive x invert t"});
sceneClass.setGroup("Positive X Modifiers", ProjectTriplanarMap_attr::attrPXInvT);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXInvT, "label", "positive x invert t");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXInvT, "enable if", "OrderedDict({'positive_x_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXInvT, "comment", "Flip in the t direction (vertical)");
ProjectTriplanarMap_attr::attrPXSwapST = sceneClass.declareAttribute<Bool>("positive_x_swap_st", false, FLAGS_NONE, INTERFACE_GENERIC, {"positive x swap st"});
sceneClass.setGroup("Positive X Modifiers", ProjectTriplanarMap_attr::attrPXSwapST);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXSwapST, "label", "positive x swap st");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXSwapST, "enable if", "OrderedDict({'positive_x_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXSwapST, "comment", "Swap the s and t directions.   Same as a 90 degree rotation");
ProjectTriplanarMap_attr::attrPXRot = sceneClass.declareAttribute<float>("positive_x_rotation", 0, FLAGS_NONE, INTERFACE_GENERIC, {"positive x rotation"});
sceneClass.setGroup("Positive X Modifiers", ProjectTriplanarMap_attr::attrPXRot);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXRot, "label", "positive x rotation");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXRot, "enable if", "OrderedDict({'positive_x_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXRot, "comment", "2D rotation amount");
ProjectTriplanarMap_attr::attrPXRotCntr = sceneClass.declareAttribute<Vec2f>("positive_x_rotation_center", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"positive x rotation center"});
sceneClass.setGroup("Positive X Modifiers", ProjectTriplanarMap_attr::attrPXRotCntr);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXRotCntr, "label", "positive x rotation center");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXRotCntr, "enable if", "OrderedDict({'positive_x_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXRotCntr, "comment", "2D rotation center");
ProjectTriplanarMap_attr::attrPXWrap = sceneClass.declareAttribute<Bool>("positive_x_wrap_around", true, FLAGS_NONE, INTERFACE_GENERIC, {"positive x wrap around"});
sceneClass.setGroup("Positive X Modifiers", ProjectTriplanarMap_attr::attrPXWrap);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXWrap, "label", "positive x wrap around");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXWrap, "enable if", "OrderedDict({'positive_x_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPXWrap, "comment", "Controls whether to repeat (true) or clamp (false) the texture");
ProjectTriplanarMap_attr::attrPYScale = sceneClass.declareAttribute<Vec2f>("positive_y_scale", Vec2f(1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"positive y scale"});
sceneClass.setGroup("Positive Y Modifiers", ProjectTriplanarMap_attr::attrPYScale);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYScale, "label", "positive y scale");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYScale, "enable if", "OrderedDict({'positive_y_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYScale, "comment", "2D scale");
ProjectTriplanarMap_attr::attrPYOffset = sceneClass.declareAttribute<Vec2f>("positive_y_offset", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"positive y offset"});
sceneClass.setGroup("Positive Y Modifiers", ProjectTriplanarMap_attr::attrPYOffset);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYOffset, "label", "positive y offset");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYOffset, "enable if", "OrderedDict({'positive_y_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYOffset, "comment", "2D offset");
ProjectTriplanarMap_attr::attrPYInvS = sceneClass.declareAttribute<Bool>("positive_y_invert_s", false, FLAGS_NONE, INTERFACE_GENERIC, {"positive y invert s"});
sceneClass.setGroup("Positive Y Modifiers", ProjectTriplanarMap_attr::attrPYInvS);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYInvS, "label", "positive y invert s");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYInvS, "enable if", "OrderedDict({'positive_y_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYInvS, "comment", "Flip in the s direction (horizontal)");
ProjectTriplanarMap_attr::attrPYInvT = sceneClass.declareAttribute<Bool>("positive_y_invert_t", false, FLAGS_NONE, INTERFACE_GENERIC, {"positive y invert t"});
sceneClass.setGroup("Positive Y Modifiers", ProjectTriplanarMap_attr::attrPYInvT);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYInvT, "label", "positive y invert t");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYInvT, "enable if", "OrderedDict({'positive_y_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYInvT, "comment", "Flip in the t direction (vertical)");
ProjectTriplanarMap_attr::attrPYSwapST = sceneClass.declareAttribute<Bool>("positive_y_swap_st", false, FLAGS_NONE, INTERFACE_GENERIC, {"positive y swap st"});
sceneClass.setGroup("Positive Y Modifiers", ProjectTriplanarMap_attr::attrPYSwapST);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYSwapST, "label", "positive y swap st");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYSwapST, "enable if", "OrderedDict({'positive_y_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYSwapST, "comment", "Swap the s and t directions.   Same as a 90 degree rotation");
ProjectTriplanarMap_attr::attrPYRot = sceneClass.declareAttribute<float>("positive_y_rotation", 0, FLAGS_NONE, INTERFACE_GENERIC, {"positive y rotation"});
sceneClass.setGroup("Positive Y Modifiers", ProjectTriplanarMap_attr::attrPYRot);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYRot, "label", "positive y rotation");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYRot, "enable if", "OrderedDict({'positive_y_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYRot, "comment", "2D rotation amount");
ProjectTriplanarMap_attr::attrPYRotCntr = sceneClass.declareAttribute<Vec2f>("positive_y_rotation_center", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"positive y rotation center"});
sceneClass.setGroup("Positive Y Modifiers", ProjectTriplanarMap_attr::attrPYRotCntr);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYRotCntr, "label", "positive y rotation center");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYRotCntr, "enable if", "OrderedDict({'positive_y_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYRotCntr, "comment", "2D rotation center");
ProjectTriplanarMap_attr::attrPYWrap = sceneClass.declareAttribute<Bool>("positive_y_wrap_around", true, FLAGS_NONE, INTERFACE_GENERIC, {"positive y wrap around"});
sceneClass.setGroup("Positive Y Modifiers", ProjectTriplanarMap_attr::attrPYWrap);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYWrap, "label", "positive y wrap around");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYWrap, "enable if", "OrderedDict({'positive_y_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPYWrap, "comment", "Controls whether to repeat (true) or clamp (false) the texture");
ProjectTriplanarMap_attr::attrPZScale = sceneClass.declareAttribute<Vec2f>("positive_z_scale", Vec2f(1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"positive z scale"});
sceneClass.setGroup("Positive Z Modifiers", ProjectTriplanarMap_attr::attrPZScale);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZScale, "label", "positive z scale");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZScale, "enable if", "OrderedDict({'positive_z_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZScale, "comment", "2D scale");
ProjectTriplanarMap_attr::attrPZOffset = sceneClass.declareAttribute<Vec2f>("positive_z_offset", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"positive z offset"});
sceneClass.setGroup("Positive Z Modifiers", ProjectTriplanarMap_attr::attrPZOffset);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZOffset, "label", "positive z offset");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZOffset, "enable if", "OrderedDict({'positive_z_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZOffset, "comment", "2D offset");
ProjectTriplanarMap_attr::attrPZInvS = sceneClass.declareAttribute<Bool>("positive_z_invert_s", false, FLAGS_NONE, INTERFACE_GENERIC, {"positive z invert s"});
sceneClass.setGroup("Positive Z Modifiers", ProjectTriplanarMap_attr::attrPZInvS);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZInvS, "label", "positive z invert s");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZInvS, "enable if", "OrderedDict({'positive_z_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZInvS, "comment", "Flip in the s direction (horizontal)");
ProjectTriplanarMap_attr::attrPZInvT = sceneClass.declareAttribute<Bool>("positive_z_invert_t", false, FLAGS_NONE, INTERFACE_GENERIC, {"positive z invert t"});
sceneClass.setGroup("Positive Z Modifiers", ProjectTriplanarMap_attr::attrPZInvT);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZInvT, "label", "positive z invert t");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZInvT, "enable if", "OrderedDict({'positive_z_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZInvT, "comment", "Flip in the t direction (vertical)");
ProjectTriplanarMap_attr::attrPZSwapST = sceneClass.declareAttribute<Bool>("positive_z_swap_st", false, FLAGS_NONE, INTERFACE_GENERIC, {"positive z swap st"});
sceneClass.setGroup("Positive Z Modifiers", ProjectTriplanarMap_attr::attrPZSwapST);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZSwapST, "label", "positive z swap st");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZSwapST, "enable if", "OrderedDict({'positive_z_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZSwapST, "comment", "Swap the s and t directions.   Same as a 90 degree rotation");
ProjectTriplanarMap_attr::attrPZRot = sceneClass.declareAttribute<float>("positive_z_rotation", 0, FLAGS_NONE, INTERFACE_GENERIC, {"positive z rotation"});
sceneClass.setGroup("Positive Z Modifiers", ProjectTriplanarMap_attr::attrPZRot);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZRot, "label", "positive z rotation");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZRot, "enable if", "OrderedDict({'positive_z_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZRot, "comment", "2D rotation amount");
ProjectTriplanarMap_attr::attrPZRotCntr = sceneClass.declareAttribute<Vec2f>("positive_z_rotation_center", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"positive z rotation center"});
sceneClass.setGroup("Positive Z Modifiers", ProjectTriplanarMap_attr::attrPZRotCntr);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZRotCntr, "label", "positive z rotation center");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZRotCntr, "enable if", "OrderedDict({'positive_z_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZRotCntr, "comment", "2D rotation center");
ProjectTriplanarMap_attr::attrPZWrap = sceneClass.declareAttribute<Bool>("positive_z_wrap_around", true, FLAGS_NONE, INTERFACE_GENERIC, {"positive z wrap around"});
sceneClass.setGroup("Positive Z Modifiers", ProjectTriplanarMap_attr::attrPZWrap);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZWrap, "label", "positive z wrap around");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZWrap, "enable if", "OrderedDict({'positive_z_active': 'true'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrPZWrap, "comment", "Controls whether to repeat (true) or clamp (false) the texture");
ProjectTriplanarMap_attr::attrNXScale = sceneClass.declareAttribute<Vec2f>("negative_x_scale", Vec2f(1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"negative x scale"});
sceneClass.setGroup("Negative X Modifiers", ProjectTriplanarMap_attr::attrNXScale);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXScale, "label", "negative x scale");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXScale, "enable if", "OrderedDict({'negative_x_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXScale, "comment", "2D scale");
ProjectTriplanarMap_attr::attrNXOffset = sceneClass.declareAttribute<Vec2f>("negative_x_offset", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"negative x offset"});
sceneClass.setGroup("Negative X Modifiers", ProjectTriplanarMap_attr::attrNXOffset);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXOffset, "label", "negative x offset");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXOffset, "enable if", "OrderedDict({'negative_x_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXOffset, "comment", "2D offset");
ProjectTriplanarMap_attr::attrNXInvS = sceneClass.declareAttribute<Bool>("negative_x_invert_s", false, FLAGS_NONE, INTERFACE_GENERIC, {"negative x invert s"});
sceneClass.setGroup("Negative X Modifiers", ProjectTriplanarMap_attr::attrNXInvS);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXInvS, "label", "negative x invert s");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXInvS, "enable if", "OrderedDict({'negative_x_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXInvS, "comment", "Flip in the s direction (horizontal)");
ProjectTriplanarMap_attr::attrNXInvT = sceneClass.declareAttribute<Bool>("negative_x_invert_t", false, FLAGS_NONE, INTERFACE_GENERIC, {"negative x invert t"});
sceneClass.setGroup("Negative X Modifiers", ProjectTriplanarMap_attr::attrNXInvT);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXInvT, "label", "negative x invert t");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXInvT, "enable if", "OrderedDict({'negative_x_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXInvT, "comment", "Flip in the t direction (vertical)");
ProjectTriplanarMap_attr::attrNXSwapST = sceneClass.declareAttribute<Bool>("negative_x_swap_st", false, FLAGS_NONE, INTERFACE_GENERIC, {"negative x swap st"});
sceneClass.setGroup("Negative X Modifiers", ProjectTriplanarMap_attr::attrNXSwapST);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXSwapST, "label", "negative x swap st");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXSwapST, "enable if", "OrderedDict({'negative_x_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXSwapST, "comment", "Swap the s and t directions.   Same as a 90 degree rotation");
ProjectTriplanarMap_attr::attrNXRot = sceneClass.declareAttribute<float>("negative_x_rotation", 0, FLAGS_NONE, INTERFACE_GENERIC, {"negative x rotation"});
sceneClass.setGroup("Negative X Modifiers", ProjectTriplanarMap_attr::attrNXRot);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXRot, "label", "negative x rotation");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXRot, "enable if", "OrderedDict({'negative_x_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXRot, "comment", "2D rotation amount");
ProjectTriplanarMap_attr::attrNXRotCntr = sceneClass.declareAttribute<Vec2f>("negative_x_rotation_center", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"negative x rotation center"});
sceneClass.setGroup("Negative X Modifiers", ProjectTriplanarMap_attr::attrNXRotCntr);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXRotCntr, "label", "negative x rotation center");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXRotCntr, "enable if", "OrderedDict({'negative_x_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXRotCntr, "comment", "2D rotation center");
ProjectTriplanarMap_attr::attrNXWrap = sceneClass.declareAttribute<Bool>("negative_x_wrap_around", true, FLAGS_NONE, INTERFACE_GENERIC, {"negative x wrap around"});
sceneClass.setGroup("Negative X Modifiers", ProjectTriplanarMap_attr::attrNXWrap);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXWrap, "label", "negative x wrap around");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXWrap, "enable if", "OrderedDict({'negative_x_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNXWrap, "comment", "Controls whether to repeat (true) or clamp (false) the texture");
ProjectTriplanarMap_attr::attrNYScale = sceneClass.declareAttribute<Vec2f>("negative_y_scale", Vec2f(1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"negative y scale"});
sceneClass.setGroup("Negative Y Modifiers", ProjectTriplanarMap_attr::attrNYScale);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYScale, "label", "negative y scale");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYScale, "enable if", "OrderedDict({'negative_y_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYScale, "comment", "2D scale");
ProjectTriplanarMap_attr::attrNYOffset = sceneClass.declareAttribute<Vec2f>("negative_y_offset", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"negative y offset"});
sceneClass.setGroup("Negative Y Modifiers", ProjectTriplanarMap_attr::attrNYOffset);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYOffset, "label", "negative y offset");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYOffset, "enable if", "OrderedDict({'negative_y_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYOffset, "comment", "2D offset");
ProjectTriplanarMap_attr::attrNYInvS = sceneClass.declareAttribute<Bool>("negative_y_invert_s", false, FLAGS_NONE, INTERFACE_GENERIC, {"negative y invert s"});
sceneClass.setGroup("Negative Y Modifiers", ProjectTriplanarMap_attr::attrNYInvS);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYInvS, "label", "negative y invert s");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYInvS, "enable if", "OrderedDict({'negative_y_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYInvS, "comment", "Flip in the s direction (horizontal)");
ProjectTriplanarMap_attr::attrNYInvT = sceneClass.declareAttribute<Bool>("negative_y_invert_t", false, FLAGS_NONE, INTERFACE_GENERIC, {"negative y invert t"});
sceneClass.setGroup("Negative Y Modifiers", ProjectTriplanarMap_attr::attrNYInvT);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYInvT, "label", "negative y invert t");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYInvT, "enable if", "OrderedDict({'negative_y_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYInvT, "comment", "Flip in the t direction (vertical)");
ProjectTriplanarMap_attr::attrNYSwapST = sceneClass.declareAttribute<Bool>("negative_y_swap_st", false, FLAGS_NONE, INTERFACE_GENERIC, {"negative y swap st"});
sceneClass.setGroup("Negative Y Modifiers", ProjectTriplanarMap_attr::attrNYSwapST);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYSwapST, "label", "negative y swap st");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYSwapST, "enable if", "OrderedDict({'negative_y_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYSwapST, "comment", "Swap the s and t directions.   Same as a 90 degree rotation");
ProjectTriplanarMap_attr::attrNYRot = sceneClass.declareAttribute<float>("negative_y_rotation", 0, FLAGS_NONE, INTERFACE_GENERIC, {"negative y rotation"});
sceneClass.setGroup("Negative Y Modifiers", ProjectTriplanarMap_attr::attrNYRot);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYRot, "label", "negative y rotation");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYRot, "enable if", "OrderedDict({'negative_y_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYRot, "comment", "2D rotation amount");
ProjectTriplanarMap_attr::attrNYRotCntr = sceneClass.declareAttribute<Vec2f>("negative_y_rotation_center", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"negative y rotation center"});
sceneClass.setGroup("Negative Y Modifiers", ProjectTriplanarMap_attr::attrNYRotCntr);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYRotCntr, "label", "negative y rotation center");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYRotCntr, "enable if", "OrderedDict({'negative_y_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYRotCntr, "comment", "2D rotation center");
ProjectTriplanarMap_attr::attrNYWrap = sceneClass.declareAttribute<Bool>("negative_y_wrap_around", true, FLAGS_NONE, INTERFACE_GENERIC, {"negative y wrap around"});
sceneClass.setGroup("Negative Y Modifiers", ProjectTriplanarMap_attr::attrNYWrap);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYWrap, "label", "negative y wrap around");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYWrap, "enable if", "OrderedDict({'negative_y_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNYWrap, "comment", "Controls whether to repeat (true) or clamp (false) the texture");
ProjectTriplanarMap_attr::attrNZScale = sceneClass.declareAttribute<Vec2f>("negative_z_scale", Vec2f(1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"negative z scale"});
sceneClass.setGroup("Negative Z Modifiers", ProjectTriplanarMap_attr::attrNZScale);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZScale, "label", "negative z scale");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZScale, "enable if", "OrderedDict({'negative_z_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZScale, "comment", "2D scale");
ProjectTriplanarMap_attr::attrNZOffset = sceneClass.declareAttribute<Vec2f>("negative_z_offset", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"negative z offset"});
sceneClass.setGroup("Negative Z Modifiers", ProjectTriplanarMap_attr::attrNZOffset);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZOffset, "label", "negative z offset");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZOffset, "enable if", "OrderedDict({'negative_z_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZOffset, "comment", "2D offset");
ProjectTriplanarMap_attr::attrNZInvS = sceneClass.declareAttribute<Bool>("negative_z_invert_s", false, FLAGS_NONE, INTERFACE_GENERIC, {"negative z invert s"});
sceneClass.setGroup("Negative Z Modifiers", ProjectTriplanarMap_attr::attrNZInvS);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZInvS, "label", "negative z invert s");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZInvS, "enable if", "OrderedDict({'negative_z_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZInvS, "comment", "Flip in the s direction (horizontal)");
ProjectTriplanarMap_attr::attrNZInvT = sceneClass.declareAttribute<Bool>("negative_z_invert_t", false, FLAGS_NONE, INTERFACE_GENERIC, {"negative z invert t"});
sceneClass.setGroup("Negative Z Modifiers", ProjectTriplanarMap_attr::attrNZInvT);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZInvT, "label", "negative z invert t");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZInvT, "enable if", "OrderedDict({'negative_z_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZInvT, "comment", "Flip in the t direction (vertical)");
ProjectTriplanarMap_attr::attrNZSwapST = sceneClass.declareAttribute<Bool>("negative_z_swap_st", false, FLAGS_NONE, INTERFACE_GENERIC, {"negative z swap st"});
sceneClass.setGroup("Negative Z Modifiers", ProjectTriplanarMap_attr::attrNZSwapST);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZSwapST, "label", "negative z swap st");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZSwapST, "enable if", "OrderedDict({'negative_z_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZSwapST, "comment", "Swap the s and t directions.   Same as a 90 degree rotation");
ProjectTriplanarMap_attr::attrNZRot = sceneClass.declareAttribute<float>("negative_z_rotation", 0, FLAGS_NONE, INTERFACE_GENERIC, {"negative z rotation"});
sceneClass.setGroup("Negative Z Modifiers", ProjectTriplanarMap_attr::attrNZRot);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZRot, "label", "negative z rotation");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZRot, "enable if", "OrderedDict({'negative_z_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZRot, "comment", "2D rotation amount");
ProjectTriplanarMap_attr::attrNZRotCntr = sceneClass.declareAttribute<Vec2f>("negative_z_rotation_center", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"negative z rotation center"});
sceneClass.setGroup("Negative Z Modifiers", ProjectTriplanarMap_attr::attrNZRotCntr);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZRotCntr, "label", "negative z rotation center");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZRotCntr, "enable if", "OrderedDict({'negative_z_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZRotCntr, "comment", "2D rotation center");
ProjectTriplanarMap_attr::attrNZWrap = sceneClass.declareAttribute<Bool>("negative_z_wrap_around", true, FLAGS_NONE, INTERFACE_GENERIC, {"negative z wrap around"});
sceneClass.setGroup("Negative Z Modifiers", ProjectTriplanarMap_attr::attrNZWrap);
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZWrap, "label", "negative z wrap around");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZWrap, "enable if", "OrderedDict({'negative_z_active': 'true', 'number_of_textures': 'six'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrNZWrap, "comment", "Controls whether to repeat (true) or clamp (false) the texture");
ProjectTriplanarMap_attr::attrProjectionMode = sceneClass.declareAttribute<Int>("projection_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrProjectionMode, 0, "projector");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrProjectionMode, 1, "projection_matrix");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrProjectionMode, 2, "TRS");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrProjectionMode, "comment", "Source parameters to use for projection transform");
ProjectTriplanarMap_attr::attrProjector = sceneClass.declareAttribute<SceneObject*>("projector", FLAGS_NONE, INTERFACE_NODE, {});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrProjector, "enable if", "OrderedDict({'projection_mode': 'projector'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrProjector, "comment", "The object whose transform to use for projection when 'projection_mode' is set to 'projector'");
ProjectTriplanarMap_attr::attrProjectionMatrix = sceneClass.declareAttribute<Mat4d>("projection_matrix", Mat4d(1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrProjectionMatrix, "label", "projection matrix");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrProjectionMatrix, "enable if", "OrderedDict({'projection_mode': 'projection_matrix'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrProjectionMatrix, "comment", "The transform to use for projection when 'projection_mode' is set to 'projection_matrix'");
ProjectTriplanarMap_attr::attrTRSOrder = sceneClass.declareAttribute<Int>("TRS_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrTRSOrder, 0, "Scale Rot Trans");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrTRSOrder, 1, "Scale Trans Rot");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrTRSOrder, 2, "Rot Scale Trans");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrTRSOrder, 3, "Rot Trans Scale");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrTRSOrder, 4, "Trans Scale Rot");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrTRSOrder, 5, "Trans Rot Scale");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrTRSOrder, "label", "TRS order");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrTRSOrder, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrTRSOrder, "comment", "Order in which to apply transformations when 'projection_mode' is set to 'TRS'");
ProjectTriplanarMap_attr::attrRotationOrder = sceneClass.declareAttribute<Int>("rotation_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrRotationOrder, 0, "xyz");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrRotationOrder, 1, "xzy");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrRotationOrder, 2, "yxz");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrRotationOrder, 3, "yzx");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrRotationOrder, 4, "zxy");
sceneClass.setEnumValue(ProjectTriplanarMap_attr::attrRotationOrder, 5, "zyx");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRotationOrder, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRotationOrder, "comment", "Order in which to apply rotation transformations when 'projection_mode' is set to 'TRS'");
ProjectTriplanarMap_attr::attrTranslate = sceneClass.declareAttribute<Vec3d>("translate", Vec3d(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrTranslate, "label", "translate");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrTranslate, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrTranslate, "comment", "Translation of the projection transform when 'projection_mode' is set to 'TRS'");
ProjectTriplanarMap_attr::attrRotate = sceneClass.declareAttribute<Vec3d>("rotate", Vec3d(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRotate, "label", "rotate");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRotate, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrRotate, "comment", "Rotation of the projection transform when 'projection_mode' is set to 'TRS'");
ProjectTriplanarMap_attr::attrScale = sceneClass.declareAttribute<Vec3d>("scale", Vec3d(1.0f, 1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrScale, "label", "scale");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrScale, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectTriplanarMap_attr::attrScale, "comment", "Scale of the projection transform when 'projection_mode' is set to 'TRS'");
RDL2_DSO_ATTR_END
using namespace ProjectTriplanarMap_attr;
