#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ProjectTriplanarUdimMap_attr)
AttributeKey<Bool> attrUseCorrectUv;
AttributeKey<Bool> attrUseReferenceSpace;
AttributeKey<Vec2f> attrXOffset;
AttributeKey<Vec2f> attrXScale;
AttributeKey<float> attrXRotation;
AttributeKey<Vec2f> attrXRotationCenter;
AttributeKey<Vec2f> attrYOffset;
AttributeKey<Vec2f> attrYScale;
AttributeKey<float> attrYRotation;
AttributeKey<Vec2f> attrYRotationCenter;
AttributeKey<Vec2f> attrZOffset;
AttributeKey<Vec2f> attrZScale;
AttributeKey<float> attrZRotation;
AttributeKey<Vec2f> attrZRotationCenter;
AttributeKey<Int> attrProjectionMode;
AttributeKey<SceneObject*> attrProjector;
AttributeKey<Mat4d> attrProjectionMatrix;
AttributeKey<Int> attrTRSOrder;
AttributeKey<Int> attrRotationOrder;
AttributeKey<Vec3d> attrTranslate;
AttributeKey<Vec3d> attrRotate;
AttributeKey<Vec3d> attrScale;
RDL2_DSO_ATTR_DEFINE(Map)
ProjectTriplanarUdimMap_attr::attrUseCorrectUv = sceneClass.declareAttribute<Bool>("use_correct_uv", false, FLAGS_NONE, INTERFACE_GENERIC, {"use correct uv"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrUseCorrectUv, "label", "use correct uv");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrUseCorrectUv, "comment", "use correct uv orientation");
ProjectTriplanarUdimMap_attr::attrUseReferenceSpace = sceneClass.declareAttribute<Bool>("use_reference_space", false, FLAGS_NONE, INTERFACE_GENERIC, {"use reference space"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrUseReferenceSpace, "label", "use reference space");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrUseReferenceSpace, "comment", "use reference space");
ProjectTriplanarUdimMap_attr::attrXOffset = sceneClass.declareAttribute<Vec2f>("x_offset", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"x offset"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrXOffset, "label", "x offset");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrXOffset, "comment", "2D offset for x projected map");
ProjectTriplanarUdimMap_attr::attrXScale = sceneClass.declareAttribute<Vec2f>("x_scale", Vec2f(1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"x scale"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrXScale, "label", "x scale");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrXScale, "comment", "2D scale for x projected map");
ProjectTriplanarUdimMap_attr::attrXRotation = sceneClass.declareAttribute<float>("x_rotation", 0, FLAGS_NONE, INTERFACE_GENERIC, {"x rotation"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrXRotation, "label", "x rotation");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrXRotation, "comment", "2D rotation for x projected map");
ProjectTriplanarUdimMap_attr::attrXRotationCenter = sceneClass.declareAttribute<Vec2f>("x_rotation_center", Vec2f(0.5f, 0.5f), FLAGS_NONE, INTERFACE_GENERIC, {"x rotation center"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrXRotationCenter, "label", "x rotation center");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrXRotationCenter, "comment", "2D rotation center for x projected map");
ProjectTriplanarUdimMap_attr::attrYOffset = sceneClass.declareAttribute<Vec2f>("y_offset", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"y offset"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrYOffset, "label", "y offset");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrYOffset, "comment", "2D offset for y projected map");
ProjectTriplanarUdimMap_attr::attrYScale = sceneClass.declareAttribute<Vec2f>("y_scale", Vec2f(1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"y scale"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrYScale, "label", "y scale");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrYScale, "comment", "2D scale for y projected map");
ProjectTriplanarUdimMap_attr::attrYRotation = sceneClass.declareAttribute<float>("y_rotation", 0, FLAGS_NONE, INTERFACE_GENERIC, {"y rotation"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrYRotation, "label", "y rotation");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrYRotation, "comment", "2D rotation for y projected map");
ProjectTriplanarUdimMap_attr::attrYRotationCenter = sceneClass.declareAttribute<Vec2f>("y_rotation_center", Vec2f(0.5f, 0.5f), FLAGS_NONE, INTERFACE_GENERIC, {"y rotation center"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrYRotationCenter, "label", "y rotation center");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrYRotationCenter, "comment", "2D rotation center for y projected map");
ProjectTriplanarUdimMap_attr::attrZOffset = sceneClass.declareAttribute<Vec2f>("z_offset", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"z offset"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrZOffset, "label", "z offset");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrZOffset, "comment", "2D offset for z projected map");
ProjectTriplanarUdimMap_attr::attrZScale = sceneClass.declareAttribute<Vec2f>("z_scale", Vec2f(1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"z scale"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrZScale, "label", "z scale");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrZScale, "comment", "2D scale for z projected map");
ProjectTriplanarUdimMap_attr::attrZRotation = sceneClass.declareAttribute<float>("z_rotation", 0, FLAGS_NONE, INTERFACE_GENERIC, {"z rotation"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrZRotation, "label", "z rotation");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrZRotation, "comment", "2D rotation for z projected map");
ProjectTriplanarUdimMap_attr::attrZRotationCenter = sceneClass.declareAttribute<Vec2f>("z_rotation_center", Vec2f(0.5f, 0.5f), FLAGS_NONE, INTERFACE_GENERIC, {"z rotation center"});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrZRotationCenter, "label", "z rotation center");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrZRotationCenter, "comment", "2D rotation center for z projected map");
ProjectTriplanarUdimMap_attr::attrProjectionMode = sceneClass.declareAttribute<Int>("projection_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrProjectionMode, 0, "projector");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrProjectionMode, 1, "projection_matrix");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrProjectionMode, 2, "TRS");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrProjectionMode, "comment", "Source parameters to use for projection transform");
ProjectTriplanarUdimMap_attr::attrProjector = sceneClass.declareAttribute<SceneObject*>("projector", FLAGS_NONE, INTERFACE_NODE, {});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrProjector, "enable if", "OrderedDict({'projection_mode': 'projector'})");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrProjector, "comment", "The object whose transform to use for projection when 'projection_mode' is set to 'projector'");
ProjectTriplanarUdimMap_attr::attrProjectionMatrix = sceneClass.declareAttribute<Mat4d>("projection_matrix", Mat4d(1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrProjectionMatrix, "label", "projection matrix");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrProjectionMatrix, "enable if", "OrderedDict({'projection_mode': 'projection_matrix'})");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrProjectionMatrix, "comment", "The transform to use for projection when 'projection_mode' is set to 'projection_matrix'");
ProjectTriplanarUdimMap_attr::attrTRSOrder = sceneClass.declareAttribute<Int>("TRS_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrTRSOrder, 0, "Scale Rot Trans");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrTRSOrder, 1, "Scale Trans Rot");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrTRSOrder, 2, "Rot Scale Trans");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrTRSOrder, 3, "Rot Trans Scale");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrTRSOrder, 4, "Trans Scale Rot");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrTRSOrder, 5, "Trans Rot Scale");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrTRSOrder, "label", "TRS order");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrTRSOrder, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrTRSOrder, "comment", "Order in which to apply transformations when 'projection_mode' is set to 'TRS'");
ProjectTriplanarUdimMap_attr::attrRotationOrder = sceneClass.declareAttribute<Int>("rotation_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrRotationOrder, 0, "xyz");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrRotationOrder, 1, "xzy");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrRotationOrder, 2, "yxz");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrRotationOrder, 3, "yzx");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrRotationOrder, 4, "zxy");
sceneClass.setEnumValue(ProjectTriplanarUdimMap_attr::attrRotationOrder, 5, "zyx");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrRotationOrder, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrRotationOrder, "comment", "Order in which to apply rotation transformations when 'projection_mode' is set to 'TRS'");
ProjectTriplanarUdimMap_attr::attrTranslate = sceneClass.declareAttribute<Vec3d>("translate", Vec3d(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrTranslate, "label", "translate");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrTranslate, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrTranslate, "comment", "Translation of the projection transform when 'projection_mode' is set to 'TRS'");
ProjectTriplanarUdimMap_attr::attrRotate = sceneClass.declareAttribute<Vec3d>("rotate", Vec3d(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrRotate, "label", "rotate");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrRotate, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrRotate, "comment", "Rotation of the projection transform when 'projection_mode' is set to 'TRS'");
ProjectTriplanarUdimMap_attr::attrScale = sceneClass.declareAttribute<Vec3d>("scale", Vec3d(1.0f, 1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrScale, "label", "scale");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrScale, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectTriplanarUdimMap_attr::attrScale, "comment", "Scale of the projection transform when 'projection_mode' is set to 'TRS'");
RDL2_DSO_ATTR_END
using namespace ProjectTriplanarUdimMap_attr;
