#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(RampMap_attr)
AttributeKey<FloatVector> attrPositions;
AttributeKey<RgbVector> attrColors;
AttributeKey<IntVector> attrInterpolations;
AttributeKey<Int> attrRampType;
AttributeKey<Float> attrInput;
AttributeKey<Int> attrSpace;
AttributeKey<SceneObject*> attrObject;
AttributeKey<SceneObject*> attrCamera;
AttributeKey<Int> attrColorSpace;
AttributeKey<Int> attrTextureEnum;
AttributeKey<Vec3f> attrInputTextureCoordinate;
AttributeKey<Int> attrWrapType;
AttributeKey<Vec2f> attrUvWave;
AttributeKey<Vec2f> attrUvRepeat;
RDL2_DSO_ATTR_DEFINE(Map)
RampMap_attr::attrPositions = sceneClass.declareAttribute<FloatVector>("positions", {0.0, 0.25, 0.75, 1.0}, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Ramp Knot", RampMap_attr::attrPositions);
sceneClass.setMetadata(RampMap_attr::attrPositions, "comment", "Color ramp");
sceneClass.setMetadata(RampMap_attr::attrPositions, "structure_type", "ramp_color");
sceneClass.setMetadata(RampMap_attr::attrPositions, "structure_name", "ramp");
sceneClass.setMetadata(RampMap_attr::attrPositions, "structure_path", "positions");
RampMap_attr::attrColors = sceneClass.declareAttribute<RgbVector>("colors", {Rgb(0.0), Rgb(0.25), Rgb(0.75), Rgb(1.0)}, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Ramp Knot", RampMap_attr::attrColors);
sceneClass.setMetadata(RampMap_attr::attrColors, "comment", "List of colors on the ramp");
sceneClass.setMetadata(RampMap_attr::attrColors, "structure_type", "ramp_color");
sceneClass.setMetadata(RampMap_attr::attrColors, "structure_name", "ramp");
sceneClass.setMetadata(RampMap_attr::attrColors, "structure_path", "values");
RampMap_attr::attrInterpolations = sceneClass.declareAttribute<IntVector>("interpolations", {0, 0, 0, 0}, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Ramp Knot", RampMap_attr::attrInterpolations);
sceneClass.setMetadata(RampMap_attr::attrInterpolations, "comment", "None: 0 | Linear: 1 | Exponential Up: 2 | Exponential Down: 3 |\n\t\t\tSmooth: 4 | Catmull Rom: 5 | Monotone Cubic: 6");
sceneClass.setMetadata(RampMap_attr::attrInterpolations, "structure_type", "ramp_color");
sceneClass.setMetadata(RampMap_attr::attrInterpolations, "structure_name", "ramp");
sceneClass.setMetadata(RampMap_attr::attrInterpolations, "structure_path", "interpolation_types");
RampMap_attr::attrRampType = sceneClass.declareAttribute<Int>("ramp_type", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"ramp type"});
sceneClass.setGroup("Ramp properties", RampMap_attr::attrRampType);
sceneClass.setEnumValue(RampMap_attr::attrRampType, 0, "v");
sceneClass.setEnumValue(RampMap_attr::attrRampType, 1, "u");
sceneClass.setEnumValue(RampMap_attr::attrRampType, 2, "diagonal");
sceneClass.setEnumValue(RampMap_attr::attrRampType, 3, "radial");
sceneClass.setEnumValue(RampMap_attr::attrRampType, 4, "circular");
sceneClass.setEnumValue(RampMap_attr::attrRampType, 5, "box");
sceneClass.setEnumValue(RampMap_attr::attrRampType, 6, "uxv");
sceneClass.setEnumValue(RampMap_attr::attrRampType, 7, "four corner");
sceneClass.setEnumValue(RampMap_attr::attrRampType, 8, "input");
sceneClass.setMetadata(RampMap_attr::attrRampType, "label", "ramp type");
sceneClass.setMetadata(RampMap_attr::attrRampType, "comment", "Determines input signal / shape of the ramp");
RampMap_attr::attrInput = sceneClass.declareAttribute<Float>("input", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Ramp properties", RampMap_attr::attrInput);
sceneClass.setMetadata(RampMap_attr::attrInput, "comment", "Input signal for ramp, used when ramp type is set to input");
RampMap_attr::attrSpace = sceneClass.declareAttribute<Int>("space", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Ramp properties", RampMap_attr::attrSpace);
sceneClass.setEnumValue(RampMap_attr::attrSpace, 0, "render");
sceneClass.setEnumValue(RampMap_attr::attrSpace, 1, "camera");
sceneClass.setEnumValue(RampMap_attr::attrSpace, 2, "world");
sceneClass.setEnumValue(RampMap_attr::attrSpace, 3, "screen");
sceneClass.setEnumValue(RampMap_attr::attrSpace, 4, "object");
sceneClass.setEnumValue(RampMap_attr::attrSpace, 5, "reference");
sceneClass.setEnumValue(RampMap_attr::attrSpace, 6, "texture");
sceneClass.setMetadata(RampMap_attr::attrSpace, "comment", "Only applies when 'texture coordinates' is set to 'default state coordinates'");
RampMap_attr::attrObject = sceneClass.declareAttribute<SceneObject*>("object", FLAGS_NONE, INTERFACE_GEOMETRY, {});
sceneClass.setGroup("Ramp properties", RampMap_attr::attrObject);
RampMap_attr::attrCamera = sceneClass.declareAttribute<SceneObject*>("camera", FLAGS_NONE, INTERFACE_CAMERA, {});
sceneClass.setGroup("Ramp properties", RampMap_attr::attrCamera);
sceneClass.setMetadata(RampMap_attr::attrCamera, "comment", "Camera used to define camera and screen space");
RampMap_attr::attrColorSpace = sceneClass.declareAttribute<Int>("color_space", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"color space"});
sceneClass.setGroup("Ramp properties", RampMap_attr::attrColorSpace);
sceneClass.setEnumValue(RampMap_attr::attrColorSpace, 0, "rgb");
sceneClass.setEnumValue(RampMap_attr::attrColorSpace, 1, "hsv");
sceneClass.setEnumValue(RampMap_attr::attrColorSpace, 2, "hsl");
sceneClass.setMetadata(RampMap_attr::attrColorSpace, "label", "color space");
sceneClass.setMetadata(RampMap_attr::attrColorSpace, "comment", "Color space to perform interpolation in");
RampMap_attr::attrTextureEnum = sceneClass.declareAttribute<Int>("texture_coordinates", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"texture coordinates"});
sceneClass.setEnumValue(RampMap_attr::attrTextureEnum, 0, "default state coordinates");
sceneClass.setEnumValue(RampMap_attr::attrTextureEnum, 1, "input texture coordinates");
sceneClass.setMetadata(RampMap_attr::attrTextureEnum, "label", "texture coordinates");
sceneClass.setMetadata(RampMap_attr::attrTextureEnum, "comment", "Whether to read existing coordinates or bind custom ones");
RampMap_attr::attrInputTextureCoordinate = sceneClass.declareAttribute<Vec3f>("input_texture_coordinates", Vec3f(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"input texture coordinates"});
sceneClass.setGroup("Additional properties", RampMap_attr::attrInputTextureCoordinate);
sceneClass.setMetadata(RampMap_attr::attrInputTextureCoordinate, "label", "input texture coordinates");
sceneClass.setMetadata(RampMap_attr::attrInputTextureCoordinate, "comment", "Bind custom UV coordinates");
RampMap_attr::attrWrapType = sceneClass.declareAttribute<Int>("wrap_type", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"wrap type"});
sceneClass.setGroup("Additional properties", RampMap_attr::attrWrapType);
sceneClass.setEnumValue(RampMap_attr::attrWrapType, 0, "wrap");
sceneClass.setEnumValue(RampMap_attr::attrWrapType, 1, "clamp");
sceneClass.setMetadata(RampMap_attr::attrWrapType, "label", "wrap type");
sceneClass.setMetadata(RampMap_attr::attrWrapType, "comment", "Whether to repeat the ramp or maintain the color at each edge");
RampMap_attr::attrUvWave = sceneClass.declareAttribute<Vec2f>("uv_wave", Vec2f(0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {"uv wave"});
sceneClass.setGroup("Additional properties", RampMap_attr::attrUvWave);
sceneClass.setMetadata(RampMap_attr::attrUvWave, "label", "uv wave");
sceneClass.setMetadata(RampMap_attr::attrUvWave, "comment", "Creates waves which perturb the ramp pattern");
RampMap_attr::attrUvRepeat = sceneClass.declareAttribute<Vec2f>("uv_repeat", Vec2f(1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"uv repeat"});
sceneClass.setGroup("Additional properties", RampMap_attr::attrUvRepeat);
sceneClass.setMetadata(RampMap_attr::attrUvRepeat, "label", "uv repeat");
sceneClass.setMetadata(RampMap_attr::attrUvRepeat, "comment", "Number of times to repeat the ramp pattern");
RDL2_DSO_ATTR_END
using namespace RampMap_attr;
