#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(RandomMap_attr)
AttributeKey<Rgb> attrInput;
AttributeKey<Int> attrSeed;
AttributeKey<Bool> attrMonochrome;
AttributeKey<Float> attrOutMin;
AttributeKey<Float> attrOutMax;
RDL2_DSO_ATTR_DEFINE(Map)
RandomMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(RandomMap_attr::attrInput, "comment", "the input color used as a base seed to generate the random value");
RandomMap_attr::attrSeed = sceneClass.declareAttribute<Int>("seed", 0, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(RandomMap_attr::attrSeed, "label", "seed");
sceneClass.setMetadata(RandomMap_attr::attrSeed, "comment", "additional seed added to input for random number generator");
RandomMap_attr::attrMonochrome = sceneClass.declareAttribute<Bool>("monochrome", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(RandomMap_attr::attrMonochrome, "label", "monochrome");
sceneClass.setMetadata(RandomMap_attr::attrMonochrome, "comment", "outputs the same color for all three channels");
RandomMap_attr::attrOutMin = sceneClass.declareAttribute<Float>("output_min", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"output min"});
sceneClass.setMetadata(RandomMap_attr::attrOutMin, "label", "output min");
sceneClass.setMetadata(RandomMap_attr::attrOutMin, "comment", "the minimum output random value");
RandomMap_attr::attrOutMax = sceneClass.declareAttribute<Float>("output_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"output max"});
sceneClass.setMetadata(RandomMap_attr::attrOutMax, "label", "output max");
sceneClass.setMetadata(RandomMap_attr::attrOutMax, "comment", "the maximum output random value");
RDL2_DSO_ATTR_END
using namespace RandomMap_attr;
