#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(RemapMap_attr)
AttributeKey<Int> attrRemapMethod;
AttributeKey<Rgb> attrInput;
AttributeKey<Float> attrInMin;
AttributeKey<Float> attrInMax;
AttributeKey<Float> attrOutMin;
AttributeKey<Float> attrOutMax;
AttributeKey<Float> attrBias;
AttributeKey<Bool> attrClamp;
AttributeKey<Float> attrClampMin;
AttributeKey<Float> attrClampMax;
AttributeKey<Rgb> attrInMinRGB;
AttributeKey<Rgb> attrInMaxRGB;
AttributeKey<Rgb> attrOutMinRGB;
AttributeKey<Rgb> attrOutMaxRGB;
AttributeKey<Rgb> attrBiasRGB;
AttributeKey<Bool> attrClampRGB;
AttributeKey<Rgb> attrClampMinRGB;
AttributeKey<Rgb> attrClampMaxRGB;
RDL2_DSO_ATTR_DEFINE(Map)
RemapMap_attr::attrRemapMethod = sceneClass.declareAttribute<Int>("remap_method", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(RemapMap_attr::attrRemapMethod, 0, "uniform");
sceneClass.setEnumValue(RemapMap_attr::attrRemapMethod, 1, "RGB");
sceneClass.setMetadata(RemapMap_attr::attrRemapMethod, "label", "remap method");
sceneClass.setMetadata(RemapMap_attr::attrRemapMethod, "comment", "Choose whether you are remapping using single values (uniform) or with separate RGB channels");
RemapMap_attr::attrInput = sceneClass.declareAttribute<Rgb>("input", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(RemapMap_attr::attrInput, "comment", "the input values to be remapped");
RemapMap_attr::attrInMin = sceneClass.declareAttribute<Float>("input_min", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"input min"});
sceneClass.setMetadata(RemapMap_attr::attrInMin, "label", "input min");
sceneClass.setMetadata(RemapMap_attr::attrInMin, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapMap_attr::attrInMin, "comment", "the input value that will be remapped to the 'output min' value");
RemapMap_attr::attrInMax = sceneClass.declareAttribute<Float>("input_max", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"input max"});
sceneClass.setMetadata(RemapMap_attr::attrInMax, "label", "input max");
sceneClass.setMetadata(RemapMap_attr::attrInMax, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapMap_attr::attrInMax, "comment", "the input value that will be remapped to the 'output max' value");
RemapMap_attr::attrOutMin = sceneClass.declareAttribute<Float>("output_min", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"output min"});
sceneClass.setMetadata(RemapMap_attr::attrOutMin, "label", "output min");
sceneClass.setMetadata(RemapMap_attr::attrOutMin, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapMap_attr::attrOutMin, "comment", "the value that 'input min' is remapped to");
RemapMap_attr::attrOutMax = sceneClass.declareAttribute<Float>("output_max", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"output max"});
sceneClass.setMetadata(RemapMap_attr::attrOutMax, "label", "output max");
sceneClass.setMetadata(RemapMap_attr::attrOutMax, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapMap_attr::attrOutMax, "comment", "the value that 'input max' is remapped to");
RemapMap_attr::attrBias = sceneClass.declareAttribute<Float>("midpoint_bias", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"midpoint bias"});
sceneClass.setMetadata(RemapMap_attr::attrBias, "label", "midpoint bias");
sceneClass.setMetadata(RemapMap_attr::attrBias, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapMap_attr::attrBias, "comment", "biases the in-between values toward 'output min' or 'output max'. Default = 0.5");
RemapMap_attr::attrClamp = sceneClass.declareAttribute<Bool>("clamp", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(RemapMap_attr::attrClamp, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapMap_attr::attrClamp, "comment", "enables/disables clamping of the output values.  This useful prevent out-of-range values when expanding the input values.");
RemapMap_attr::attrClampMin = sceneClass.declareAttribute<Float>("clamp_min", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"clamp min"});
sceneClass.setMetadata(RemapMap_attr::attrClampMin, "label", "clamp min");
sceneClass.setMetadata(RemapMap_attr::attrClampMin, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapMap_attr::attrClampMin, "comment", "the minimum value output by this map when 'clamp' is enabled");
RemapMap_attr::attrClampMax = sceneClass.declareAttribute<Float>("clamp_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"clamp max"});
sceneClass.setMetadata(RemapMap_attr::attrClampMax, "label", "clamp max");
sceneClass.setMetadata(RemapMap_attr::attrClampMax, "enable if", "OrderedDict({'remap_method': 'uniform'})");
sceneClass.setMetadata(RemapMap_attr::attrClampMax, "comment", "the maximum value output by this map when 'clamp' is enabled");
RemapMap_attr::attrInMinRGB = sceneClass.declareAttribute<Rgb>("input_min_RGB", Rgb(0.f, 0.f, 0.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapMap_attr::attrInMinRGB);
sceneClass.setMetadata(RemapMap_attr::attrInMinRGB, "label", "input min RGB");
sceneClass.setMetadata(RemapMap_attr::attrInMinRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapMap_attr::attrInMinRGB, "comment", "the input value that will be remapped to the 'output min' value");
RemapMap_attr::attrInMaxRGB = sceneClass.declareAttribute<Rgb>("input_max_RGB", Rgb(1.f, 1.f, 1.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapMap_attr::attrInMaxRGB);
sceneClass.setMetadata(RemapMap_attr::attrInMaxRGB, "label", "input max RGB");
sceneClass.setMetadata(RemapMap_attr::attrInMaxRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapMap_attr::attrInMaxRGB, "comment", "the input value that will be remapped to the 'output max' value");
RemapMap_attr::attrOutMinRGB = sceneClass.declareAttribute<Rgb>("output_min_RGB", Rgb(0.f, 0.f, 0.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapMap_attr::attrOutMinRGB);
sceneClass.setMetadata(RemapMap_attr::attrOutMinRGB, "label", "output min RGB");
sceneClass.setMetadata(RemapMap_attr::attrOutMinRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapMap_attr::attrOutMinRGB, "comment", "the value that 'input min' is remapped to");
RemapMap_attr::attrOutMaxRGB = sceneClass.declareAttribute<Rgb>("output_max_RGB", Rgb(1.f, 1.f, 1.f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapMap_attr::attrOutMaxRGB);
sceneClass.setMetadata(RemapMap_attr::attrOutMaxRGB, "label", "output max RGB");
sceneClass.setMetadata(RemapMap_attr::attrOutMaxRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapMap_attr::attrOutMaxRGB, "comment", "the value that 'input max' is remapped to");
RemapMap_attr::attrBiasRGB = sceneClass.declareAttribute<Rgb>("midpoint_bias_RGB", Rgb(0.5f, 0.5f, 0.5f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapMap_attr::attrBiasRGB);
sceneClass.setMetadata(RemapMap_attr::attrBiasRGB, "label", "midpoint bias RGB");
sceneClass.setMetadata(RemapMap_attr::attrBiasRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapMap_attr::attrBiasRGB, "comment", "biases the in-between values toward 'output min' or 'output max'. Default = 0.5");
RemapMap_attr::attrClampRGB = sceneClass.declareAttribute<Bool>("clamp_RGB", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(RemapMap_attr::attrClampRGB, "label", "clamp RGB");
sceneClass.setMetadata(RemapMap_attr::attrClampRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapMap_attr::attrClampRGB, "comment", "enables/disables clamping of the output values.  This useful prevent out-of-range values when expanding the input values.");
RemapMap_attr::attrClampMinRGB = sceneClass.declareAttribute<Rgb>("clamp_min_RGB", Rgb(0.f, 0.f, 0.f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapMap_attr::attrClampMinRGB);
sceneClass.setMetadata(RemapMap_attr::attrClampMinRGB, "label", "clamp min RGB");
sceneClass.setMetadata(RemapMap_attr::attrClampMinRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapMap_attr::attrClampMinRGB, "comment", "the minimum value output by this map when 'clamp' is enabled");
RemapMap_attr::attrClampMaxRGB = sceneClass.declareAttribute<Rgb>("clamp_max_RGB", Rgb(1.f, 1.f, 1.f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Channel", RemapMap_attr::attrClampMaxRGB);
sceneClass.setMetadata(RemapMap_attr::attrClampMaxRGB, "label", "clamp max RGB");
sceneClass.setMetadata(RemapMap_attr::attrClampMaxRGB, "enable if", "OrderedDict({'remap_method': 'RGB'})");
sceneClass.setMetadata(RemapMap_attr::attrClampMaxRGB, "comment", "the maximum value output by this map when 'clamp' is enabled");
RDL2_DSO_ATTR_END
using namespace RemapMap_attr;
