#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ToonMap_attr)
AttributeKey<Int> attrMode;
AttributeKey<Rgb> attrFillColor;
AttributeKey<Rgb> attrOutlineColor;
AttributeKey<Rgb> attrCreaseColor;
AttributeKey<Float> attrOutlineThreshold;
AttributeKey<Float> attrOutlineScale;
AttributeKey<Float> attrCreaseThreshold;
AttributeKey<Float> attrCreaseScale;
RDL2_DSO_ATTR_DEFINE(Map)
ToonMap_attr::attrMode = sceneClass.declareAttribute<Int>("mode", 2, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ToonMap_attr::attrMode, 0, "outline");
sceneClass.setEnumValue(ToonMap_attr::attrMode, 1, "crease");
sceneClass.setEnumValue(ToonMap_attr::attrMode, 2, "both");
sceneClass.setMetadata(ToonMap_attr::attrMode, "comment", "Pick which features are displayed");
ToonMap_attr::attrFillColor = sceneClass.declareAttribute<Rgb>("fill_color", Rgb(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"fill color"});
sceneClass.setMetadata(ToonMap_attr::attrFillColor, "label", "fill color");
sceneClass.setMetadata(ToonMap_attr::attrFillColor, "comment", "Default color, within the outlines and creases");
ToonMap_attr::attrOutlineColor = sceneClass.declareAttribute<Rgb>("outline_color", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"outline color"});
sceneClass.setMetadata(ToonMap_attr::attrOutlineColor, "label", "outline color");
sceneClass.setMetadata(ToonMap_attr::attrOutlineColor, "comment", "Outlines are silhouettes of the geometry");
ToonMap_attr::attrCreaseColor = sceneClass.declareAttribute<Rgb>("crease_color", Rgb(1.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"crease color"});
sceneClass.setMetadata(ToonMap_attr::attrCreaseColor, "label", "crease color");
sceneClass.setMetadata(ToonMap_attr::attrCreaseColor, "comment", "Creases are sharp edges like corners in the geometry.");
ToonMap_attr::attrOutlineThreshold = sceneClass.declareAttribute<Float>("outline_threshold", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"outline threshold"});
sceneClass.setMetadata(ToonMap_attr::attrOutlineThreshold, "label", "outline threshold");
sceneClass.setMetadata(ToonMap_attr::attrOutlineThreshold, "comment", "In most cases, the shader would trace an outline of a model well when this threshold is zero.");
ToonMap_attr::attrOutlineScale = sceneClass.declareAttribute<Float>("outline_scale", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"outline scale"});
sceneClass.setMetadata(ToonMap_attr::attrOutlineScale, "label", "outline scale");
sceneClass.setMetadata(ToonMap_attr::attrOutlineScale, "comment", "This attribute controls the thickness of outlines.");
ToonMap_attr::attrCreaseThreshold = sceneClass.declareAttribute<Float>("crease_threshold", 45.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"crease threshold"});
sceneClass.setMetadata(ToonMap_attr::attrCreaseThreshold, "label", "crease threshold");
sceneClass.setMetadata(ToonMap_attr::attrCreaseThreshold, "comment", "This attribute sets the threshold angle (in degree units) to draw creases. The more the threshold angle is, the less the creases are traced.");
ToonMap_attr::attrCreaseScale = sceneClass.declareAttribute<Float>("crease_scale", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"crease scale"});
sceneClass.setMetadata(ToonMap_attr::attrCreaseScale, "label", "crease scale");
sceneClass.setMetadata(ToonMap_attr::attrCreaseScale, "comment", "This attribute controls the thickness of creases.");
RDL2_DSO_ATTR_END
using namespace ToonMap_attr;
