#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(TransformNormalMap_attr)
AttributeKey<Vec3f> attrInputNormal;
AttributeKey<Int> attrTransform;
AttributeKey<Bool> attrDecodeInputNormal;
RDL2_DSO_ATTR_DEFINE(Map)
TransformNormalMap_attr::attrInputNormal = sceneClass.declareAttribute<Vec3f>("input_normal", Vec3f(0.0f, 0.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"input normal"});
sceneClass.setGroup("Normal", TransformNormalMap_attr::attrInputNormal);
sceneClass.setMetadata(TransformNormalMap_attr::attrInputNormal, "label", "input normal");
sceneClass.setMetadata(TransformNormalMap_attr::attrInputNormal, "comment", "input normal in either tangent or render space");
TransformNormalMap_attr::attrTransform = sceneClass.declareAttribute<Int>("transform", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"transform"});
sceneClass.setEnumValue(TransformNormalMap_attr::attrTransform, 0, "tangent to render");
sceneClass.setEnumValue(TransformNormalMap_attr::attrTransform, 1, "render to tangent");
sceneClass.setMetadata(TransformNormalMap_attr::attrTransform, "label", "transform");
sceneClass.setMetadata(TransformNormalMap_attr::attrTransform, "comment", "transform to apply to the normals");
TransformNormalMap_attr::attrDecodeInputNormal = sceneClass.declareAttribute<Bool>("decode_input_normal", true, FLAGS_NONE, INTERFACE_GENERIC, {"decode input normal"});
sceneClass.setMetadata(TransformNormalMap_attr::attrDecodeInputNormal, "label", "decode_input_normal");
sceneClass.setMetadata(TransformNormalMap_attr::attrDecodeInputNormal, "comment", "decode the input normal if it's in tangent space [0,1] -> [-1,1]");
RDL2_DSO_ATTR_END
using namespace TransformNormalMap_attr;
