#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(TransformSpaceMap_attr)
AttributeKey<Vec3f> attrInput;
AttributeKey<Int> attrInputType;
AttributeKey<Int> attrFromSpace;
AttributeKey<Int> attrToSpace;
AttributeKey<Bool> attrConcatenateTransforms;
AttributeKey<SceneObject*> attrCamera;
AttributeKey<SceneObject*> attrObject;
AttributeKey<Bool> attrUseCustomWindowCoordinates;
AttributeKey<Float> attrWindowXMin;
AttributeKey<Float> attrWindowXMax;
AttributeKey<Float> attrWindowYMin;
AttributeKey<Float> attrWindowYMax;
RDL2_DSO_ATTR_DEFINE(Map)
TransformSpaceMap_attr::attrInput = sceneClass.declareAttribute<Vec3f>("input", Vec3f(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(TransformSpaceMap_attr::attrInput, "comment", "the input value to transform");
TransformSpaceMap_attr::attrInputType = sceneClass.declareAttribute<Int>("input_type", 1, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"input type"});
sceneClass.setEnumValue(TransformSpaceMap_attr::attrInputType, 0, "point");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrInputType, 1, "vector");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrInputType, 2, "normal");
sceneClass.setMetadata(TransformSpaceMap_attr::attrInputType, "label", "input type");
sceneClass.setMetadata(TransformSpaceMap_attr::attrInputType, "comment", "the type of input value provided");
TransformSpaceMap_attr::attrFromSpace = sceneClass.declareAttribute<Int>("from_space", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"from space"});
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 0, "render");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 1, "camera");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 2, "world");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 3, "screen");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 4, "object");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 5, "local tangent");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 6, "instance object transform");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 7, "instance level 0");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 8, "instance level 1");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 9, "instance level 2");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 10, "instance level 3");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrFromSpace, 11, "instance level 4");
sceneClass.setMetadata(TransformSpaceMap_attr::attrFromSpace, "label", "from space");
sceneClass.setMetadata(TransformSpaceMap_attr::attrFromSpace, "comment", "the space to transform from");
TransformSpaceMap_attr::attrToSpace = sceneClass.declareAttribute<Int>("to_space", 2, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"to space"});
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 0, "render");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 1, "camera");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 2, "world");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 3, "screen");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 4, "object");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 5, "local reference tangent");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 6, "instance object transform");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 7, "instance level 0");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 8, "instance level 1");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 9, "instance level 2");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 10, "instance level 3");
sceneClass.setEnumValue(TransformSpaceMap_attr::attrToSpace, 11, "instance level 4");
sceneClass.setMetadata(TransformSpaceMap_attr::attrToSpace, "label", "to space");
sceneClass.setMetadata(TransformSpaceMap_attr::attrToSpace, "comment", "the space to transform to");
TransformSpaceMap_attr::attrConcatenateTransforms = sceneClass.declareAttribute<Bool>("concatenate_instance_level_transforms", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(TransformSpaceMap_attr::attrConcatenateTransforms, "label", "concatenate instance level transforms");
sceneClass.setMetadata(TransformSpaceMap_attr::attrConcatenateTransforms, "comment", "When true, instance level transforms below the specified one are concatenated otherwise only the selected level's transform is used");
TransformSpaceMap_attr::attrCamera = sceneClass.declareAttribute<SceneObject*>("camera", FLAGS_NONE, INTERFACE_CAMERA, {});
sceneClass.setMetadata(TransformSpaceMap_attr::attrCamera, "comment", "an alternate camera to use when transforming to/from 'camera' space");
TransformSpaceMap_attr::attrObject = sceneClass.declareAttribute<SceneObject*>("object", FLAGS_NONE, INTERFACE_GEOMETRY, {});
sceneClass.setMetadata(TransformSpaceMap_attr::attrObject, "comment", "an alternate object to use when transforming to/from 'object' space");
TransformSpaceMap_attr::attrUseCustomWindowCoordinates = sceneClass.declareAttribute<Bool>("use_custom_window_coordinates", false, FLAGS_NONE, INTERFACE_GENERIC, {"use custom window coordinates"});
sceneClass.setMetadata(TransformSpaceMap_attr::attrUseCustomWindowCoordinates, "label", "use custom window coordinates");
sceneClass.setMetadata(TransformSpaceMap_attr::attrUseCustomWindowCoordinates, "comment", "used to apply non-uniform scaling to projection");
TransformSpaceMap_attr::attrWindowXMin = sceneClass.declareAttribute<Float>("window_x_min", -1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"window x min"});
sceneClass.setMetadata(TransformSpaceMap_attr::attrWindowXMin, "label", "window x min");
sceneClass.setMetadata(TransformSpaceMap_attr::attrWindowXMin, "comment", "minimum projected x coordinate");
TransformSpaceMap_attr::attrWindowXMax = sceneClass.declareAttribute<Float>("window_x_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"window x max"});
sceneClass.setMetadata(TransformSpaceMap_attr::attrWindowXMax, "label", "window x max");
sceneClass.setMetadata(TransformSpaceMap_attr::attrWindowXMax, "comment", "maximum projected x coordinate");
TransformSpaceMap_attr::attrWindowYMin = sceneClass.declareAttribute<Float>("window_y_min", -1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"window y min"});
sceneClass.setMetadata(TransformSpaceMap_attr::attrWindowYMin, "label", "window y min");
sceneClass.setMetadata(TransformSpaceMap_attr::attrWindowYMin, "comment", "minimum projected y coordinate");
TransformSpaceMap_attr::attrWindowYMax = sceneClass.declareAttribute<Float>("window_y_max", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {"window y max"});
sceneClass.setMetadata(TransformSpaceMap_attr::attrWindowYMax, "label", "window y max");
sceneClass.setMetadata(TransformSpaceMap_attr::attrWindowYMax, "comment", "maximum projected y coordinate");
RDL2_DSO_ATTR_END
using namespace TransformSpaceMap_attr;
