#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(UVTransformMap_attr)
AttributeKey<Int> attrSpace;
AttributeKey<Vec2f> attrOffset;
AttributeKey<Vec2f> attrScale;
AttributeKey<Float> attrRotationAngle;
AttributeKey<Vec2f> attrRotationCenter;
AttributeKey<Vec3f> attrRotationAxis;
RDL2_DSO_ATTR_DEFINE(Map)
UVTransformMap_attr::attrSpace = sceneClass.declareAttribute<Int>("space", 6, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(UVTransformMap_attr::attrSpace, 0, "render");
sceneClass.setEnumValue(UVTransformMap_attr::attrSpace, 1, "camera");
sceneClass.setEnumValue(UVTransformMap_attr::attrSpace, 2, "world");
sceneClass.setEnumValue(UVTransformMap_attr::attrSpace, 3, "screen");
sceneClass.setEnumValue(UVTransformMap_attr::attrSpace, 4, "object");
sceneClass.setEnumValue(UVTransformMap_attr::attrSpace, 5, "reference");
sceneClass.setEnumValue(UVTransformMap_attr::attrSpace, 6, "texture");
sceneClass.setMetadata(UVTransformMap_attr::attrSpace, "comment", "Determines source of coordinates. Default is mesh UVs. Other options procedurally create UVs from the chosen space.");
UVTransformMap_attr::attrOffset = sceneClass.declareAttribute<Vec2f>("offset", Vec2f(0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(UVTransformMap_attr::attrOffset, "comment", "Shifts UV coordinates");
UVTransformMap_attr::attrScale = sceneClass.declareAttribute<Vec2f>("scale", Vec2f(1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(UVTransformMap_attr::attrScale, "comment", "Scales UV coordinates (after rotation, before offset)");
UVTransformMap_attr::attrRotationAngle = sceneClass.declareAttribute<Float>("rotation_angle", 0.0f, FLAGS_NONE, INTERFACE_GENERIC, {"rotation angle"});
sceneClass.setMetadata(UVTransformMap_attr::attrRotationAngle, "label", "rotation angle");
sceneClass.setMetadata(UVTransformMap_attr::attrRotationAngle, "comment", "Rotation in degrees");
UVTransformMap_attr::attrRotationCenter = sceneClass.declareAttribute<Vec2f>("rotation_center", Vec2f(0.5f, 0.5f), FLAGS_NONE, INTERFACE_GENERIC, {"rotation center"});
sceneClass.setMetadata(UVTransformMap_attr::attrRotationCenter, "label", "rotation center");
sceneClass.setMetadata(UVTransformMap_attr::attrRotationCenter, "comment", "UV coordinate around which to rotate");
UVTransformMap_attr::attrRotationAxis = sceneClass.declareAttribute<Vec3f>("rotation_axis", Vec3f(0.0f, 0.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {"rotation axis"});
sceneClass.setMetadata(UVTransformMap_attr::attrRotationAxis, "label", "rotation axis");
sceneClass.setMetadata(UVTransformMap_attr::attrRotationAxis, "comment", "Axis in which to rotate (only for 3D spaces)");
RDL2_DSO_ATTR_END
using namespace UVTransformMap_attr;
