#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(DwaAdjustMaterial_attr)
AttributeKey<SceneObject*> attrInputMaterial;
AttributeKey<Bool> attrOn;
AttributeKey<Float> attrMix;
AttributeKey<Int> attrEmissionMode;
AttributeKey<Rgb> attrEmission;
AttributeKey<Bool> attrEnableSpecular;
AttributeKey<Bool> attrEnableRoughness;
AttributeKey<Bool> attrEnableColor;
AttributeKey<Bool> attrEnablePresence;
AttributeKey<Int> attrOverrideCastsCaustics;
AttributeKey<Int> attrOverrideThinGeometry;
AttributeKey<Bool> attrDisableDiffuse;
AttributeKey<Bool> attrDisableClearcoat;
AttributeKey<Bool> attrDisableSpecular;
RDL2_DSO_ATTR_DEFINE(Material)
DwaAdjustMaterial_attr::attrInputMaterial = sceneClass.declareAttribute<SceneObject*>("input_material", FLAGS_NONE, INTERFACE_DWABASELAYERABLE, {});
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrInputMaterial, "label", "input material");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrInputMaterial, "comment", "Material to modify");
DwaAdjustMaterial_attr::attrOn = sceneClass.declareAttribute<Bool>("on", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrOn, "comment", "Enable/disable all adjustments");
DwaAdjustMaterial_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrMix, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrMix, "comment", "weight of adjustments applied to the material");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrMix, "max", "1.0f");
DwaAdjustMaterial_attr::attrEmissionMode = sceneClass.declareAttribute<Int>("emission_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(DwaAdjustMaterial_attr::attrEmissionMode, 0, "off");
sceneClass.setEnumValue(DwaAdjustMaterial_attr::attrEmissionMode, 1, "masked");
sceneClass.setEnumValue(DwaAdjustMaterial_attr::attrEmissionMode, 2, "unmasked");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEmissionMode, "label", "emission mode");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEmissionMode, "comment", "how to handle emission input. masked uses mix input, unmasked is mix = 1");
DwaAdjustMaterial_attr::attrEmission = sceneClass.declareAttribute<Rgb>("emission", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEmission, "comment", "emissive map to add to material's emission");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEmission, "disable when", "{ emission_mode 0 }");
DwaAdjustMaterial_attr::attrEnableSpecular = sceneClass.declareAttribute<Bool>("adjust_specular", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Enable", DwaAdjustMaterial_attr::attrEnableSpecular);
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEnableSpecular, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEnableSpecular, "comment", "use specular adjustment attrs: specular_set, specular_set_blend, specular_mult");
DwaAdjustMaterial_attr::attrEnableRoughness = sceneClass.declareAttribute<Bool>("adjust_roughness", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Enable", DwaAdjustMaterial_attr::attrEnableRoughness);
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEnableRoughness, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEnableRoughness, "comment", "use roughness adjustment attrs: roughness_set, roughness_set_blend, roughness_mult, roughness_remap_{in/out}_{min/max}");
DwaAdjustMaterial_attr::attrEnableColor = sceneClass.declareAttribute<Bool>("adjust_color", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Enable", DwaAdjustMaterial_attr::attrEnableColor);
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEnableColor, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEnableColor, "comment", "use color adjustment attrs: color_hue_shift, color_saturation, color_gain");
DwaAdjustMaterial_attr::attrEnablePresence = sceneClass.declareAttribute<Bool>("adjust_presence", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Enable", DwaAdjustMaterial_attr::attrEnablePresence);
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEnablePresence, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrEnablePresence, "comment", "use presence adjustment attrs: presence_set, presence_set_blend, presence_mult");
DwaAdjustMaterial_attr::attrOverrideCastsCaustics = sceneClass.declareAttribute<Int>("casts_caustics", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Override", DwaAdjustMaterial_attr::attrOverrideCastsCaustics);
sceneClass.setEnumValue(DwaAdjustMaterial_attr::attrOverrideCastsCaustics, 0, "unmodified");
sceneClass.setEnumValue(DwaAdjustMaterial_attr::attrOverrideCastsCaustics, 1, "force on");
sceneClass.setEnumValue(DwaAdjustMaterial_attr::attrOverrideCastsCaustics, 2, "force off");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrOverrideCastsCaustics, "label", "casts caustics");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrOverrideCastsCaustics, "comment", "allows you to keep or set casts caustics attribute");
DwaAdjustMaterial_attr::attrOverrideThinGeometry = sceneClass.declareAttribute<Int>("thin_geometry", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Override", DwaAdjustMaterial_attr::attrOverrideThinGeometry);
sceneClass.setEnumValue(DwaAdjustMaterial_attr::attrOverrideThinGeometry, 0, "unmodified");
sceneClass.setEnumValue(DwaAdjustMaterial_attr::attrOverrideThinGeometry, 1, "force on");
sceneClass.setEnumValue(DwaAdjustMaterial_attr::attrOverrideThinGeometry, 2, "force off");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrOverrideThinGeometry, "label", "thin geometry");
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrOverrideThinGeometry, "comment", "allows you to keep or set thin geometry attribute");
DwaAdjustMaterial_attr::attrDisableDiffuse = sceneClass.declareAttribute<Bool>("disable_diffuse", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Override", DwaAdjustMaterial_attr::attrDisableDiffuse);
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrDisableDiffuse, "comment", "when checked, turn off all diffuse from input");
DwaAdjustMaterial_attr::attrDisableClearcoat = sceneClass.declareAttribute<Bool>("disable_clearcoat", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Override", DwaAdjustMaterial_attr::attrDisableClearcoat);
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrDisableClearcoat, "comment", "when checked, turn off clearcoat from input");
DwaAdjustMaterial_attr::attrDisableSpecular = sceneClass.declareAttribute<Bool>("disable_specular", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Override", DwaAdjustMaterial_attr::attrDisableSpecular);
sceneClass.setMetadata(DwaAdjustMaterial_attr::attrDisableSpecular, "comment", "when checked, turn off all specular from input");
static const char *labels[] = {
    "glitter",
    "hair",
    "hair R",
    "hair TT",
    "hair TRT",
    "hair TRRT",
    "hair diffuse",
    "fuzz",
    "outer specular",
    "specular",
    "diffuse",
    "specular transmission",
    "diffuse transmission",
    nullptr
};
sceneClass.declareDataPtr("labels", labels);
rdl2_dso_interface |= INTERFACE_DWABASELAYERABLE;
RDL2_DSO_ATTR_END
using namespace DwaAdjustMaterial_attr;
