#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(DwaEmissiveMaterial_attr)
AttributeKey<Bool> attrShowEmission;
AttributeKey<Rgb> attrEmission;
AttributeKey<Float> attrPresence;
RDL2_DSO_ATTR_DEFINE(Material)
DwaEmissiveMaterial_attr::attrShowEmission = sceneClass.declareAttribute<Bool>("show_emission", true, FLAGS_NONE, INTERFACE_GENERIC, {"show emission"});
sceneClass.setGroup("Emission", DwaEmissiveMaterial_attr::attrShowEmission);
sceneClass.setMetadata(DwaEmissiveMaterial_attr::attrShowEmission, "label", "show emission");
sceneClass.setMetadata(DwaEmissiveMaterial_attr::attrShowEmission, "comment", "enables/disable emission");
DwaEmissiveMaterial_attr::attrEmission = sceneClass.declareAttribute<Rgb>("emission", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"emission color", "emission_color"});
sceneClass.setGroup("Emission", DwaEmissiveMaterial_attr::attrEmission);
sceneClass.setMetadata(DwaEmissiveMaterial_attr::attrEmission, "comment", "the energy emitted from this material");
sceneClass.setMetadata(DwaEmissiveMaterial_attr::attrEmission, "enable if", "OrderedDict({'show_emission': 'true'})");
DwaEmissiveMaterial_attr::attrPresence = sceneClass.declareAttribute<Float>("presence", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Common", DwaEmissiveMaterial_attr::attrPresence);
sceneClass.setMetadata(DwaEmissiveMaterial_attr::attrPresence, "comment", "controls the visibility of this object. Useful for fading an object in/out, or to specify a cut-out mask on thin single-sided geometry (eg. a complex leaf texture on a simple card).");
static const char *labels[] = {
    "glitter",
    "hair",
    "hair R",
    "hair TT",
    "hair TRT",
    "hair TRRT",
    "hair diffuse",
    "fuzz",
    "outer specular",
    "specular",
    "diffuse",
    "specular transmission",
    "diffuse transmission",
    nullptr
};
sceneClass.declareDataPtr("labels", labels);
rdl2_dso_interface |= INTERFACE_DWABASELAYERABLE;
RDL2_DSO_ATTR_END
using namespace DwaEmissiveMaterial_attr;
