#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(DwaFabricMaterial_attr)
AttributeKey<Bool> attrShowFuzz;
AttributeKey<Float> attrFuzz;
AttributeKey<Float> attrFuzzRoughness;
AttributeKey<Rgb> attrFuzzAlbedo;
AttributeKey<Bool> attrFuzzUseAbsorbingFibers;
AttributeKey<SceneObject*> attrFuzzNormal;
AttributeKey<Float> attrFuzzNormalDial;
AttributeKey<Bool> attrShowGlitter;
AttributeKey<Float> attrGlitter;
AttributeKey<Int> attrGlitterSeed;
AttributeKey<Int> attrGlitterSpace;
AttributeKey<Float> attrGlitterDensity;
AttributeKey<Float> attrGlitterRandomness;
AttributeKey<Int> attrGlitterLayeringMode;
AttributeKey<Float> attrGlitterStyleAFrequency;
AttributeKey<Float> attrGlitterSizeA;
AttributeKey<Float> attrGlitterRoughnessA;
AttributeKey<Rgb> attrGlitterColorA;
AttributeKey<String> attrGlitterTextureA;
AttributeKey<Float> attrGlitterStyleBFrequency;
AttributeKey<Float> attrGlitterSizeB;
AttributeKey<Float> attrGlitterRoughnessB;
AttributeKey<Rgb> attrGlitterColorB;
AttributeKey<String> attrGlitterTextureB;
AttributeKey<Float> attrGlitterTextureOrientationRandomness;
AttributeKey<Float> attrGlitterHueVariation;
AttributeKey<Float> attrGlitterSaturationVariation;
AttributeKey<Float> attrGlitterValueVariation;
AttributeKey<Float> attrGlitterJitter;
AttributeKey<Bool> attrGlitterCompensateDeformation;
AttributeKey<Bool> attrGlitterApproximateForSecRays;
AttributeKey<Float> attrGlitterLodQuality;
AttributeKey<Int> attrGlitterDebugMode;
AttributeKey<Bool> attrShowFabricSpecular;
AttributeKey<Rgb> attrWarpColor;
AttributeKey<Float> attrWarpRoughness;
AttributeKey<Bool> attrUseIndependentWeftAttributes;
AttributeKey<Rgb> attrWeftColor;
AttributeKey<Float> attrWeftRoughness;
AttributeKey<Bool> attrUseUVsForThreadDirection;
AttributeKey<Float> attrFabricDiffuseScattering;
AttributeKey<Bool> attrShowDiffuse;
AttributeKey<Rgb> attrAlbedo;
AttributeKey<Float> attrDiffuseRoughness;
AttributeKey<Float> attrDiffuseTransmission;
AttributeKey<Rgb> attrDiffuseTransmissionColor;
AttributeKey<Int> attrDiffuseTransmissionBlendingBehavior;
AttributeKey<Vec3f> attrWarpThreadDirection;
AttributeKey<Float> attrWarpThreadCoverage;
AttributeKey<Float> attrWarpThreadElevation;
AttributeKey<Bool> attrShowEmission;
AttributeKey<Rgb> attrEmission;
AttributeKey<SceneObject*> attrInputNormal;
AttributeKey<Float> attrInputNormalDial;
AttributeKey<Float> attrPresence;
AttributeKey<Bool> attrThinGeometry;
AttributeKey<Bool> attrCastsCaustics;
RDL2_DSO_ATTR_DEFINE(Material)
DwaFabricMaterial_attr::attrShowFuzz = sceneClass.declareAttribute<Bool>("show_fuzz", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Fuzz", DwaFabricMaterial_attr::attrShowFuzz);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrShowFuzz, "label", "show fuzz");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrShowFuzz, "comment", "Enables/disables fuzz lobe");
DwaFabricMaterial_attr::attrFuzz = sceneClass.declareAttribute<Float>("fuzz", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Fuzz", DwaFabricMaterial_attr::attrFuzz);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzz, "label", "fuzz");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzz, "comment", "fuzz mask");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzz, "enable if", "OrderedDict({'show_fuzz': 'true'})");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzz, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzz, "max", "1.0f");
DwaFabricMaterial_attr::attrFuzzRoughness = sceneClass.declareAttribute<Float>("fuzz_roughness", 0.25f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"fuzz_coverage"});
sceneClass.setGroup("Fuzz", DwaFabricMaterial_attr::attrFuzzRoughness);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzRoughness, "label", "fuzz roughness");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzRoughness, "comment", "Lower values result in glancing angle highlights while higher values result in a broad, uniform coverage");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzRoughness, "enable if", "OrderedDict({'show_fuzz': 'true'})");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzRoughness, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzRoughness, "max", "1.0f");
DwaFabricMaterial_attr::attrFuzzAlbedo = sceneClass.declareAttribute<Rgb>("fuzz_albedo", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Fuzz", DwaFabricMaterial_attr::attrFuzzAlbedo);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzAlbedo, "label", "fuzz albedo");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzAlbedo, "comment", "Color of the fuzz highlights.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzAlbedo, "enable if", "OrderedDict({'show_fuzz': 'true'})");
DwaFabricMaterial_attr::attrFuzzUseAbsorbingFibers = sceneClass.declareAttribute<Bool>("use_absorbing_fuzz_fibers", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Fuzz", DwaFabricMaterial_attr::attrFuzzUseAbsorbingFibers);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzUseAbsorbingFibers, "label", "use absorbing fuzz fibers");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzUseAbsorbingFibers, "comment", "Specify whether dark fuzz fibers absorb energy or transmit it to the layers below.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzUseAbsorbingFibers, "enable if", "OrderedDict({'show_fuzz': 'true'})");
DwaFabricMaterial_attr::attrFuzzNormal = sceneClass.declareAttribute<SceneObject*>("fuzz_normal", FLAGS_NONE, INTERFACE_NORMALMAP, {"fuzz normal"});
sceneClass.setGroup("Fuzz", DwaFabricMaterial_attr::attrFuzzNormal);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzNormal, "label", "fuzz normal");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzNormal, "comment", "specifies an independent shading normal (normal map) for the fuzz lobe");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzNormal, "enable if", "OrderedDict({'show_fuzz': 'true'})");
DwaFabricMaterial_attr::attrFuzzNormalDial = sceneClass.declareAttribute<Float>("fuzz_normal_dial", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Fuzz", DwaFabricMaterial_attr::attrFuzzNormalDial);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzNormalDial, "label", "fuzz normal dial");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzNormalDial, "comment", "controls the amount of infuence of the alternate fuzz normal");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzNormalDial, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzNormalDial, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFuzzNormalDial, "enable if", "OrderedDict({'show_fuzz': 'true'})");
DwaFabricMaterial_attr::attrShowGlitter = sceneClass.declareAttribute<Bool>("show_glitter", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrShowGlitter);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrShowGlitter, "label", "show glitter");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrShowGlitter, "comment", "Enables/disables glitter lobes");
DwaFabricMaterial_attr::attrGlitter = sceneClass.declareAttribute<Float>("glitter", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitter);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitter, "label", "glitter");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitter, "comment", "enables/disables glitter model (binary 0|1 for plausibility)");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitter, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitter, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitter, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterSeed = sceneClass.declareAttribute<Int>("glitter_seed", 0, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterSeed);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSeed, "label", "glitter seed");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSeed, "comment", "The seed for the glitter random number generator");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSeed, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterSpace = sceneClass.declareAttribute<Int>("glitter_space", 5, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterSpace);
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrGlitterSpace, 4, "object");
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrGlitterSpace, 5, "reference");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSpace, "label", "glitter space");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSpace, "comment", "The space to calculate the worley noise in, defaults to reference space");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSpace, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterDensity = sceneClass.declareAttribute<Float>("glitter_density", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterDensity);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterDensity, "label", "glitter density");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterDensity, "comment", "controls the number of flakes per unit length; larger density packs more flakes into same space");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterDensity, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterRandomness = sceneClass.declareAttribute<Float>("glitter_randomness", 0.5f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterRandomness);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRandomness, "label", "glitter randomness");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRandomness, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRandomness, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRandomness, "comment", "randomness of flake orientation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRandomness, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterLayeringMode = sceneClass.declareAttribute<Int>("glitter_layering_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterLayeringMode);
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrGlitterLayeringMode, 0, "physical");
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrGlitterLayeringMode, 1, "additive");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterLayeringMode, "label", "glitter layering mode");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterLayeringMode, "comment", "layering mode for glitter on top of the under material. physical: conserves energy and glitter attenuates under material, additive: breaks energy conservation but glitter is never darker than the under material (eg. use case: snow)");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterLayeringMode, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterStyleAFrequency = sceneClass.declareAttribute<Float>("glitter_style_A_frequency", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterStyleAFrequency);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleAFrequency, "label", "glitter style A frequency");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleAFrequency, "subgroup", "Glitter A Appearance");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleAFrequency, "comment", "0 implies none of this style, 1 implies all the flakes will get this style");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleAFrequency, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleAFrequency, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleAFrequency, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterSizeA = sceneClass.declareAttribute<Float>("glitter_size_A", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterSizeA);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSizeA, "label", "glitter size A");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSizeA, "subgroup", "Glitter A Appearance");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSizeA, "comment", "size of the flakes.  Apparent flake size may vary based on how much the flake spheres intersect the surface");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSizeA, "disable when", "{ show_glitter 0 } { glitter_style_A_frequency 0 }");
DwaFabricMaterial_attr::attrGlitterRoughnessA = sceneClass.declareAttribute<Float>("glitter_roughness_A", 0.14f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterRoughnessA);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessA, "label", "glitter roughness A");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessA, "subgroup", "Glitter A Appearance");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessA, "comment", "specular roughness of individual flakes (0 makes flakes mirror-like)");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessA, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessA, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessA, "disable when", "{ show_glitter 0 } { glitter_style_A_frequency 0 }");
DwaFabricMaterial_attr::attrGlitterColorA = sceneClass.declareAttribute<Rgb>("glitter_color_A", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterColorA);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterColorA, "label", "glitter color A");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterColorA, "subgroup", "Glitter A Appearance");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterColorA, "comment", "base flake color (use physical metallic color values)");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterColorA, "disable when", "{ show_glitter 0 } { glitter_style_A_frequency 0 }");
DwaFabricMaterial_attr::attrGlitterTextureA = sceneClass.declareAttribute<String>("glitter_texture_A", FLAGS_FILENAME, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterTextureA);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureA, "label", "glitter texture A");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureA, "subgroup", "Glitter A Appearance");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureA, "comment", "filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureA, "disable when", "{ show_glitter 0 } { glitter_style_A_frequency 0 }");
DwaFabricMaterial_attr::attrGlitterStyleBFrequency = sceneClass.declareAttribute<Float>("glitter_style_B_frequency", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterStyleBFrequency);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleBFrequency, "label", "glitter style B frequency");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleBFrequency, "subgroup", "Glitter B Appearance");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleBFrequency, "comment", "0 implies none of this style, 1 implies all the flakes will get this style");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleBFrequency, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleBFrequency, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterStyleBFrequency, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterSizeB = sceneClass.declareAttribute<Float>("glitter_size_B", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterSizeB);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSizeB, "label", "glitter size B");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSizeB, "subgroup", "Glitter B Appearance");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSizeB, "comment", "size of the flakes.  Apparent flake size may vary based on how much the flake spheres intersect the surface");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSizeB, "disable when", "{ show_glitter 0 } { glitter_style_B_frequency 0 }");
DwaFabricMaterial_attr::attrGlitterRoughnessB = sceneClass.declareAttribute<Float>("glitter_roughness_B", 0.14f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterRoughnessB);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessB, "label", "glitter roughness B");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessB, "subgroup", "Glitter B Appearance");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessB, "comment", "specular roughness of individual flakes (0 makes flakes mirror-like)");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessB, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessB, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterRoughnessB, "disable when", "{ show_glitter 0 } { glitter_style_B_frequency 0 }");
DwaFabricMaterial_attr::attrGlitterColorB = sceneClass.declareAttribute<Rgb>("glitter_color_B", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterColorB);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterColorB, "label", "glitter color B");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterColorB, "subgroup", "Glitter B Appearance");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterColorB, "comment", "base flake color (use physical metallic color values)");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterColorB, "disable when", "{ show_glitter 0 } { glitter_style_B_frequency 0 }");
DwaFabricMaterial_attr::attrGlitterTextureB = sceneClass.declareAttribute<String>("glitter_texture_B", FLAGS_FILENAME, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterTextureB);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureB, "label", "glitter texture B");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureB, "subgroup", "Glitter B Appearance");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureB, "comment", "filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureB, "disable when", "{ show_glitter 0 } { glitter_style_B_frequency 0 }");
DwaFabricMaterial_attr::attrGlitterTextureOrientationRandomness = sceneClass.declareAttribute<Float>("glitter_texture_orientation_randomness", 0.15f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterTextureOrientationRandomness);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureOrientationRandomness, "label", "glitter texture orientation randomness");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureOrientationRandomness, "subgroup", "Variation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureOrientationRandomness, "comment", "randomly orient each texture");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureOrientationRandomness, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureOrientationRandomness, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterTextureOrientationRandomness, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterHueVariation = sceneClass.declareAttribute<Float>("glitter_color_hue_variation", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"flake color hue variation"});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterHueVariation);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterHueVariation, "label", "glitter color hue variation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterHueVariation, "subgroup", "Variation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterHueVariation, "comment", "introduce hue variation in flake color centered at the base flake color's hue on the hue wheel");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterHueVariation, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterHueVariation, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterHueVariation, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterSaturationVariation = sceneClass.declareAttribute<Float>("glitter_color_saturation_variation", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"flake color saturation variation"});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterSaturationVariation);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSaturationVariation, "label", "glitter color saturation variation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSaturationVariation, "subgroup", "Variation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSaturationVariation, "comment", "introduce saturation variation in flake color centered at the base flake color's saturation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSaturationVariation, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSaturationVariation, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterSaturationVariation, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterValueVariation = sceneClass.declareAttribute<Float>("glitter_color_value_variation", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterValueVariation);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterValueVariation, "label", "glitter color value variation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterValueVariation, "subgroup", "Variation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterValueVariation, "comment", "introduce value variation in flake color centered at the base flake color's value");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterValueVariation, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterValueVariation, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterValueVariation, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterJitter = sceneClass.declareAttribute<Float>("glitter_jitter", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterJitter);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterJitter, "label", "glitter jitter");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterJitter, "subgroup", "Advanced");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterJitter, "comment", "Controls how much the flakes are randomly offset from a regular grid");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterJitter, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterJitter, "max", "1.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterJitter, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterCompensateDeformation = sceneClass.declareAttribute<Bool>("glitter_compensate_reference_space_deformation", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterCompensateDeformation);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterCompensateDeformation, "label", "glitter compensate reference space deformation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterCompensateDeformation, "subgroup", "Advanced");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterCompensateDeformation, "enable if", "OrderedDict({'show_glitter': 'true', 'glitter_space': '5'})");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterCompensateDeformation, "comment", "(In ReferenceSpace) Compensates for stretch/compression/shear in glitter shapes resulting from animation etc");
DwaFabricMaterial_attr::attrGlitterApproximateForSecRays = sceneClass.declareAttribute<Bool>("glitter_approximate_for_secondary_rays", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterApproximateForSecRays);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterApproximateForSecRays, "label", "glitter approximate for secondary rays");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterApproximateForSecRays, "subgroup", "Advanced");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterApproximateForSecRays, "comment", "use an approximation to shade glitter for non-mirror secondary rays");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterApproximateForSecRays, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterLodQuality = sceneClass.declareAttribute<Float>("glitter_LOD_quality", 0.5f, FLAGS_NONE, INTERFACE_GENERIC, {"dense glitter LOD quality"});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterLodQuality);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterLodQuality, "label", "glitter LOD quality");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterLodQuality, "subgroup", "Advanced");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterLodQuality, "comment", "controls quality of glitter at distances where individual flakes cannot be perceived; at lower values, approximation kicks in earlier");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterLodQuality, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrGlitterDebugMode = sceneClass.declareAttribute<Int>("glitter_debug_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter", DwaFabricMaterial_attr::attrGlitterDebugMode);
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrGlitterDebugMode, 0, "off");
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrGlitterDebugMode, 1, "blend");
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrGlitterDebugMode, 2, "color");
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrGlitterDebugMode, 3, "averageColor");
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrGlitterDebugMode, 4, "footprintArea");
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrGlitterDebugMode, 5, "radius");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterDebugMode, "label", "glitter debug mode");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterDebugMode, "subgroup", "Advanced");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterDebugMode, "comment", "developer debug visualization modes");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrGlitterDebugMode, "enable if", "OrderedDict({'show_glitter': 'true'})");
DwaFabricMaterial_attr::attrShowFabricSpecular = sceneClass.declareAttribute<Bool>("show_specular", true, FLAGS_NONE, INTERFACE_GENERIC, {"show specular"});
sceneClass.setGroup("Fabric", DwaFabricMaterial_attr::attrShowFabricSpecular);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrShowFabricSpecular, "label", "show specular");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrShowFabricSpecular, "comment", "Enables/disables specular fabric lobes");
DwaFabricMaterial_attr::attrWarpColor = sceneClass.declareAttribute<Rgb>("warp_color", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"warp color"});
sceneClass.setGroup("Fabric", DwaFabricMaterial_attr::attrWarpColor);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpColor, "label", "warp color");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpColor, "comment", "Color of the fabric specular highlights. Or if 'use independent weft attributes' is 'true,' just the color of the fabric specular highlights of the warp threads.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpColor, "enable if", "OrderedDict({'show_specular': 'true'})");
DwaFabricMaterial_attr::attrWarpRoughness = sceneClass.declareAttribute<Float>("warp_roughness", 0.75f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"warp roughness"});
sceneClass.setGroup("Fabric", DwaFabricMaterial_attr::attrWarpRoughness);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpRoughness, "label", "warp roughness");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpRoughness, "comment", "Roughness of the fabric specular highlights. Or if 'use independent weft attributes' is 'true,' just the roughness of the fabric specular highlights of the warp threads.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpRoughness, "enable if", "OrderedDict({'show_specular': 'true'})");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpRoughness, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpRoughness, "max", "1.0f");
DwaFabricMaterial_attr::attrUseIndependentWeftAttributes = sceneClass.declareAttribute<Bool>("use_independent_weft_attributes", false, FLAGS_NONE, INTERFACE_GENERIC, {"use independent weft attributes"});
sceneClass.setGroup("Fabric", DwaFabricMaterial_attr::attrUseIndependentWeftAttributes);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrUseIndependentWeftAttributes, "label", "use independent weft attributes");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrUseIndependentWeftAttributes, "comment", "Use a separate set of attributes for the 'weft' thread specular response.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrUseIndependentWeftAttributes, "enable if", "OrderedDict({'show_specular': 'true'})");
DwaFabricMaterial_attr::attrWeftColor = sceneClass.declareAttribute<Rgb>("weft_color", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"weft color"});
sceneClass.setGroup("Fabric", DwaFabricMaterial_attr::attrWeftColor);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWeftColor, "label", "weft color");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWeftColor, "comment", "Color of the fabric specular highlights from the weft threads.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWeftColor, "enable if", "OrderedDict({'show_specular': 'true', 'use_independent_weft_attributes': 'true'})");
DwaFabricMaterial_attr::attrWeftRoughness = sceneClass.declareAttribute<Float>("weft_roughness", 0.75f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"weft roughness"});
sceneClass.setGroup("Fabric", DwaFabricMaterial_attr::attrWeftRoughness);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWeftRoughness, "label", "weft roughness");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWeftRoughness, "comment", "Roughness of the fabric specular highlights from the weft threads.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWeftRoughness, "enable if", "OrderedDict({'show_specular': 'true', 'use_independent_weft_attributes': 'true'})");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWeftRoughness, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWeftRoughness, "max", "1.0f");
DwaFabricMaterial_attr::attrUseUVsForThreadDirection = sceneClass.declareAttribute<Bool>("use_UVs_for_thread_direction", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Fabric", DwaFabricMaterial_attr::attrUseUVsForThreadDirection);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrUseUVsForThreadDirection, "label", "use UVs for thread direction");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrUseUVsForThreadDirection, "comment", "Use UV texture coordinates to compute thread direction (along dPds). Switch OFF for seamless camera aligned thread direction.  The warp_thread_direction parameter rotates this direction in tangent space.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrUseUVsForThreadDirection, "enable if", "OrderedDict({'show_specular': 'true'})");
DwaFabricMaterial_attr::attrFabricDiffuseScattering = sceneClass.declareAttribute<Float>("fabric_diffuse_scattering", 0.2f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"fabric diffuse scattering"});
sceneClass.setGroup("Diffuse", DwaFabricMaterial_attr::attrFabricDiffuseScattering);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFabricDiffuseScattering, "label", "fabric diffuse scattering");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFabricDiffuseScattering, "comment", "Amount of diffuse to mix in fabric. A value of 1 means fully diffuse fabric.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFabricDiffuseScattering, "enable if", "OrderedDict({'show_diffuse': 'true'})");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFabricDiffuseScattering, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrFabricDiffuseScattering, "max", "1.0f");
DwaFabricMaterial_attr::attrShowDiffuse = sceneClass.declareAttribute<Bool>("show_diffuse", true, FLAGS_NONE, INTERFACE_GENERIC, {"show diffuse"});
sceneClass.setGroup("Diffuse", DwaFabricMaterial_attr::attrShowDiffuse);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrShowDiffuse, "label", "show diffuse");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrShowDiffuse, "comment", "enables/disables diffuse reflectance");
DwaFabricMaterial_attr::attrAlbedo = sceneClass.declareAttribute<Rgb>("albedo", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Diffuse", DwaFabricMaterial_attr::attrAlbedo);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrAlbedo, "recolorable", "true");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrAlbedo, "recolorSample", "true");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrAlbedo, "comment", "the overall surface color as seen from a distance (ie. diffuse color)");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrAlbedo, "enable if", "OrderedDict({'show_diffuse': 'true'})");
DwaFabricMaterial_attr::attrDiffuseRoughness = sceneClass.declareAttribute<Float>("diffuse_roughness", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Diffuse", DwaFabricMaterial_attr::attrDiffuseRoughness);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseRoughness, "label", "diffuse roughness");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseRoughness, "comment", "Roughness of the diffuse shading.  If the value is zero a Lambertian model is used.  If it's above zero the Oren Nayar model is used.   Not compatible with subsurface scattering.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseRoughness, "enable if", "OrderedDict({'show_diffuse': 'true'})");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseRoughness, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseRoughness, "max", "1.0f");
DwaFabricMaterial_attr::attrDiffuseTransmission = sceneClass.declareAttribute<Float>("diffuse_transmission", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Diffuse", DwaFabricMaterial_attr::attrDiffuseTransmission);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseTransmission, "label", "diffuse transmission");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseTransmission, "comment", "multiplier on the amount of light that is transmitted through the surface.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseTransmission, "enable if", "OrderedDict({'show_diffuse': 'true'})");
DwaFabricMaterial_attr::attrDiffuseTransmissionColor = sceneClass.declareAttribute<Rgb>("diffuse_transmission_color", Rgb(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"translucent_diffuse", "translucent diffuse"});
sceneClass.setGroup("Diffuse", DwaFabricMaterial_attr::attrDiffuseTransmissionColor);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseTransmissionColor, "label", "diffuse transmission color");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseTransmissionColor, "comment", "the color/amount of light that is transmitted through the surface.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseTransmissionColor, "enable if", "OrderedDict({'show_diffuse': 'true'})");
DwaFabricMaterial_attr::attrDiffuseTransmissionBlendingBehavior = sceneClass.declareAttribute<Int>("diffuse_transmission_blending_behavior", 1, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"translucent_diffuse_blending_behavior"});
sceneClass.setGroup("Diffuse", DwaFabricMaterial_attr::attrDiffuseTransmissionBlendingBehavior);
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrDiffuseTransmissionBlendingBehavior, 0, "RGB");
sceneClass.setEnumValue(DwaFabricMaterial_attr::attrDiffuseTransmissionBlendingBehavior, 1, "Monochromatic");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseTransmissionBlendingBehavior, "label", "diffuse transmission blending behavior");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseTransmissionBlendingBehavior, "comment", "Controls how diffuse transmission color attenuates diffuse reflection");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrDiffuseTransmissionBlendingBehavior, "enable if", "OrderedDict({'show_diffuse': 'true'})");
DwaFabricMaterial_attr::attrWarpThreadDirection = sceneClass.declareAttribute<Vec3f>("warp_thread_direction", Vec3f(1.0f, 1.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"warp thread direction"});
sceneClass.setGroup("Threads", DwaFabricMaterial_attr::attrWarpThreadDirection);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadDirection, "label", "warp thread direction");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadDirection, "comment", "Direction of the major/warp thread for the fabric. The fabric highlights will be relative to this direction.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadDirection, "enable if", "OrderedDict({'show_specular': 'true'})");
DwaFabricMaterial_attr::attrWarpThreadCoverage = sceneClass.declareAttribute<Float>("warp_thread_coverage", 0.75, FLAGS_NONE, INTERFACE_GENERIC, {"warp thread coverage"});
sceneClass.setGroup("Threads", DwaFabricMaterial_attr::attrWarpThreadCoverage);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadCoverage, "label", "warp thread coverage");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadCoverage, "comment", "When set to 1, creates specular highlights only relative to the warp thread direction. When less than one, starts acting like a 'woven' fabric with specular contributions added in by a corresponding 'weft' thread direction, perpendicular to the 'warp' thread direction.");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadCoverage, "enable if", "OrderedDict({'show_specular': 'true'})");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadCoverage, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadCoverage, "max", "1.0f");
DwaFabricMaterial_attr::attrWarpThreadElevation = sceneClass.declareAttribute<Float>("warp_thread_elevation", 0.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {"warp thread elevation"});
sceneClass.setGroup("Threads", DwaFabricMaterial_attr::attrWarpThreadElevation);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadElevation, "label", "warp thread elevation");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadElevation, "comment", "This attribute can be used to 'elevate/rotate' the threads from their default direction. When laying flat on the surface (thread_direction.z=0), a value around 45 works well for 'silky' looks. Range - -90, +90. When threads are upright (thread_direction.z=1), this attribute can be used to 'dishevel' the threads and create a 'velvety' look (see wiki).");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrWarpThreadElevation, "enable if", "OrderedDict({'show_specular': 'true'})");
DwaFabricMaterial_attr::attrShowEmission = sceneClass.declareAttribute<Bool>("show_emission", false, FLAGS_NONE, INTERFACE_GENERIC, {"show emission"});
sceneClass.setGroup("Emission", DwaFabricMaterial_attr::attrShowEmission);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrShowEmission, "label", "show emission");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrShowEmission, "comment", "enables/disable emission");
DwaFabricMaterial_attr::attrEmission = sceneClass.declareAttribute<Rgb>("emission", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"emission color", "emission_color"});
sceneClass.setGroup("Emission", DwaFabricMaterial_attr::attrEmission);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrEmission, "comment", "the energy emitted from this material");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrEmission, "enable if", "OrderedDict({'show_emission': 'true'})");
DwaFabricMaterial_attr::attrInputNormal = sceneClass.declareAttribute<SceneObject*>("input_normal", FLAGS_NONE, INTERFACE_NORMALMAP, {"input normal"});
sceneClass.setGroup("Normal", DwaFabricMaterial_attr::attrInputNormal);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrInputNormal, "label", "input normal");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrInputNormal, "comment", "specifies an alternate shading normal in the tangent frame (normal map)");
DwaFabricMaterial_attr::attrInputNormalDial = sceneClass.declareAttribute<Float>("input_normal_dial", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"input normal dial"});
sceneClass.setGroup("Normal", DwaFabricMaterial_attr::attrInputNormalDial);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrInputNormalDial, "label", "input normal dial");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrInputNormalDial, "comment", "controls the amount of influence of the alternate normal");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrInputNormalDial, "min", "0.0f");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrInputNormalDial, "max", "1.0f");
DwaFabricMaterial_attr::attrPresence = sceneClass.declareAttribute<Float>("presence", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Common", DwaFabricMaterial_attr::attrPresence);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrPresence, "comment", "controls the visibility of this object. Useful for fading an object in/out, or to specify a cut-out mask on thin single-sided geometry (eg. a complex leaf texture on a simple card).");
DwaFabricMaterial_attr::attrThinGeometry = sceneClass.declareAttribute<Bool>("thin_geometry", false, FLAGS_NONE, INTERFACE_GENERIC, {"thin geometry"});
sceneClass.setGroup("Common", DwaFabricMaterial_attr::attrThinGeometry);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrThinGeometry, "label", "thin geometry");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrThinGeometry, "comment", "enables proper shading of infinitely thin geometry such as paper or leaves.");
DwaFabricMaterial_attr::attrCastsCaustics = sceneClass.declareAttribute<Bool>("casts_caustics", false, FLAGS_NONE, INTERFACE_GENERIC, {"casts caustics"});
sceneClass.setGroup("Common", DwaFabricMaterial_attr::attrCastsCaustics);
sceneClass.setMetadata(DwaFabricMaterial_attr::attrCastsCaustics, "label", "casts caustics");
sceneClass.setMetadata(DwaFabricMaterial_attr::attrCastsCaustics, "comment", "allows continuation of caustic light paths.");
static const char *labels[] = {
    "glitter",
    "hair",
    "hair R",
    "hair TT",
    "hair TRT",
    "hair TRRT",
    "hair diffuse",
    "fuzz",
    "outer specular",
    "specular",
    "diffuse",
    "specular transmission",
    "diffuse transmission",
    nullptr
};
sceneClass.declareDataPtr("labels", labels);
rdl2_dso_interface |= INTERFACE_DWABASELAYERABLE;
RDL2_DSO_ATTR_END
using namespace DwaFabricMaterial_attr;
