#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(DwaLayerMaterial_attr)
AttributeKey<SceneObject*> attrMaterialA;
AttributeKey<SceneObject*> attrMaterialB;
AttributeKey<Float> attrMask;
AttributeKey<Int> attrFallbackBSSRDF;
AttributeKey<Int> attrFallbackSpecularModel;
AttributeKey<Int> attrFallbackOuterSpecularModel;
AttributeKey<Bool> attrFallbackOuterSpecularUseBending;
AttributeKey<Bool> attrFallbackThinGeometry;
AttributeKey<Bool> attrFallbackPreventLightCulling;
AttributeKey<Int> attrColorSpace;
AttributeKey<SceneObject*> attrSubsurfaceTraceSet;
AttributeKey<Int> attrFallbackGlitterSeed;
AttributeKey<Int> attrFallbackGlitterSpace;
AttributeKey<Float> attrFallbackGlitterRandomness;
AttributeKey<Float> attrFallbackGlitterStyleAFrequency;
AttributeKey<String> attrFallbackGlitterTextureA;
AttributeKey<Float> attrFallbackGlitterStyleBFrequency;
AttributeKey<String> attrFallbackGlitterTextureB;
AttributeKey<Float> attrFallbackGlitterLodQuality;
AttributeKey<Int> attrFallbackGlitterLayeringMode;
AttributeKey<Int> attrFallbackGlitterDebugMode;
RDL2_DSO_ATTR_DEFINE(Material)
DwaLayerMaterial_attr::attrMaterialA = sceneClass.declareAttribute<SceneObject*>("material_A", FLAGS_NONE, INTERFACE_DWABASELAYERABLE, {"material A"});
sceneClass.setMetadata(DwaLayerMaterial_attr::attrMaterialA, "label", "material A");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrMaterialA, "comment", "foreground material");
DwaLayerMaterial_attr::attrMaterialB = sceneClass.declareAttribute<SceneObject*>("material_B", FLAGS_NONE, INTERFACE_DWABASELAYERABLE, {"material B"});
sceneClass.setMetadata(DwaLayerMaterial_attr::attrMaterialB, "label", "material B");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrMaterialB, "comment", "background material");
DwaLayerMaterial_attr::attrMask = sceneClass.declareAttribute<Float>("mask", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DwaLayerMaterial_attr::attrMask, "comment", "foreground material weight");
DwaLayerMaterial_attr::attrFallbackBSSRDF = sceneClass.declareAttribute<Int>("fallback_bssrdf", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaLayerMaterial_attr::attrFallbackBSSRDF);
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackBSSRDF, 0, "normalized diffusion");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackBSSRDF, 1, "dipole");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackBSSRDF, 2, "random walk");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackBSSRDF, "label", "fallback bssrdf");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackBSSRDF, "comment", "If child materials disagree on the type of bssrdf, this type will be used instead.");
DwaLayerMaterial_attr::attrFallbackSpecularModel = sceneClass.declareAttribute<Int>("fallback_specular_model", 1, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaLayerMaterial_attr::attrFallbackSpecularModel);
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackSpecularModel, 0, "Beckmann");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackSpecularModel, 1, "GGX");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackSpecularModel, "label", "fallback specular model");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackSpecularModel, "comment", "If child materials disagree on the type of specular model, this type will be used instead.");
DwaLayerMaterial_attr::attrFallbackOuterSpecularModel = sceneClass.declareAttribute<Int>("fallback_outer_specular_model", 1, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaLayerMaterial_attr::attrFallbackOuterSpecularModel);
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackOuterSpecularModel, 0, "Beckmann");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackOuterSpecularModel, 1, "GGX");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackOuterSpecularModel, "label", "fallback outer specular model");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackOuterSpecularModel, "comment", "If child materials disagree on the type of outer specular model, this type will be used instead.");
DwaLayerMaterial_attr::attrFallbackOuterSpecularUseBending = sceneClass.declareAttribute<Bool>("fallback_clearcoat_use_bending", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaLayerMaterial_attr::attrFallbackOuterSpecularUseBending);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackOuterSpecularUseBending, "label", "fallback clearcoat use bending");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackOuterSpecularUseBending, "comment", "If child materials disagree on the type of clearcoat use bending, this type will be used instead.");
DwaLayerMaterial_attr::attrFallbackThinGeometry = sceneClass.declareAttribute<Bool>("fallback_thin_geometry", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaLayerMaterial_attr::attrFallbackThinGeometry);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackThinGeometry, "label", "fallback thin geometry");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackThinGeometry, "comment", "If child materials disagree on the type of thin geometry, this type will be used instead.");
DwaLayerMaterial_attr::attrFallbackPreventLightCulling = sceneClass.declareAttribute<Bool>("fallback_prevent_light_culling", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaLayerMaterial_attr::attrFallbackPreventLightCulling);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackPreventLightCulling, "label", "fallback prevent light culling");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackPreventLightCulling, "comment", "If child materials disagree on prevent light culling, this will be used instead.");
DwaLayerMaterial_attr::attrColorSpace = sceneClass.declareAttribute<Int>("blend_color_space", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaLayerMaterial_attr::attrColorSpace);
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrColorSpace, 0, "RGB");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrColorSpace, 1, "HSV");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrColorSpace, 2, "HSL");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrColorSpace, "label", "blend color space");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrColorSpace, "comment", "Color space used when blending the two material's color parameters");
DwaLayerMaterial_attr::attrSubsurfaceTraceSet = sceneClass.declareAttribute<SceneObject*>("sss_trace_set", FLAGS_NONE, INTERFACE_TRACESET, {"sss trace set"});
sceneClass.setGroup("Advanced", DwaLayerMaterial_attr::attrSubsurfaceTraceSet);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrSubsurfaceTraceSet, "label", "sss trace set");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrSubsurfaceTraceSet, "comment", "By default, only the geometry associated with this material contributes to subsurface. The DwaLayerMaterial ignores the sss trace sets of the submaterials. If you want adjacent geometry with different material to contribute as well, specify all those parts here.");
DwaLayerMaterial_attr::attrFallbackGlitterSeed = sceneClass.declareAttribute<Int>("fallback_glitter_seed", 0, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter Fallback", DwaLayerMaterial_attr::attrFallbackGlitterSeed);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterSeed, "comment", "The seed for the glitter random number generator.  This parameter will only be used when layering two distinct glitter materials.");
DwaLayerMaterial_attr::attrFallbackGlitterSpace = sceneClass.declareAttribute<Int>("fallback_glitter_space", 5, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter Fallback", DwaLayerMaterial_attr::attrFallbackGlitterSpace);
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackGlitterSpace, 4, "object");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackGlitterSpace, 5, "reference");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterSpace, "label", "fallback glitter space");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterSpace, "comment", "The space to calculate the worley noise in, defaults to reference space.  This parameter will only be used when layering two distinct glitter materials.");
DwaLayerMaterial_attr::attrFallbackGlitterRandomness = sceneClass.declareAttribute<Float>("fallback_glitter_randomness", 0.5f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter Fallback", DwaLayerMaterial_attr::attrFallbackGlitterRandomness);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterRandomness, "label", "fallback glitter randomness");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterRandomness, "comment", "randomness of flake orientation.  This parameter will only be used when layering two distinct glitter materials.");
DwaLayerMaterial_attr::attrFallbackGlitterStyleAFrequency = sceneClass.declareAttribute<Float>("fallback_glitter_style_A_frequency", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter Fallback", DwaLayerMaterial_attr::attrFallbackGlitterStyleAFrequency);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterStyleAFrequency, "label", "fallback glitter style A frequency");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterStyleAFrequency, "comment", "0 implies none of this style, 1 implies all the flakes will get this style.  This parameter will only be used when layering two distinct glitter materials.");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterStyleAFrequency, "min", "0.0f");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterStyleAFrequency, "max", "1.0f");
DwaLayerMaterial_attr::attrFallbackGlitterTextureA = sceneClass.declareAttribute<String>("fallback_glitter_texture_A", FLAGS_FILENAME, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter Fallback", DwaLayerMaterial_attr::attrFallbackGlitterTextureA);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterTextureA, "label", "fallback glitter texture A");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterTextureA, "comment", "filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).  This parameter will only be used when layering two distinct glitter materials.");
DwaLayerMaterial_attr::attrFallbackGlitterStyleBFrequency = sceneClass.declareAttribute<Float>("fallback_glitter_style_B_frequency", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter Fallback", DwaLayerMaterial_attr::attrFallbackGlitterStyleBFrequency);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterStyleBFrequency, "label", "fallback glitter style B frequency");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterStyleBFrequency, "comment", "0 implies none of this style, 1 implies all the flakes will get this style.  This parameter will only be used when layering two distinct glitter materials.");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterStyleBFrequency, "min", "0.0f");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterStyleBFrequency, "max", "1.0f");
DwaLayerMaterial_attr::attrFallbackGlitterTextureB = sceneClass.declareAttribute<String>("fallback_glitter_texture_B", FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter Fallback", DwaLayerMaterial_attr::attrFallbackGlitterTextureB);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterTextureB, "label", "fallback glitter texture B");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterTextureB, "comment", "filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).  This parameter will only be used when layering two distinct glitter materials.");
DwaLayerMaterial_attr::attrFallbackGlitterLodQuality = sceneClass.declareAttribute<Float>("fallback_glitter_LOD_quality", 0.5f, FLAGS_NONE, INTERFACE_GENERIC, {"dense glitter LOD quality"});
sceneClass.setGroup("Glitter Fallback", DwaLayerMaterial_attr::attrFallbackGlitterLodQuality);
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterLodQuality, "label", "fallback glitter LOD quality");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterLodQuality, "comment", "controls quality of glitter at distances where individual flakes cannot be perceived; at lower values, approximation kicks in earlier.  This parameter will only be used when layering two distinct glitter materials.");
DwaLayerMaterial_attr::attrFallbackGlitterLayeringMode = sceneClass.declareAttribute<Int>("fallback_glitter_layering_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter Fallback", DwaLayerMaterial_attr::attrFallbackGlitterLayeringMode);
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackGlitterLayeringMode, 0, "physical");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackGlitterLayeringMode, 1, "additive");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterLayeringMode, "label", "fallback glitter layering mode");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterLayeringMode, "comment", "layering mode for glitter on top of the under material. physical: conserves energy and glitter attenuates under material, additive: breaks energy conservation but glitter is never darker than the under material (eg. use case: snow).  This parameter will only be used when layering two distinct glitter materials.");
DwaLayerMaterial_attr::attrFallbackGlitterDebugMode = sceneClass.declareAttribute<Int>("fallback_glitter_debug_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Glitter Fallback", DwaLayerMaterial_attr::attrFallbackGlitterDebugMode);
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackGlitterDebugMode, 0, "off");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackGlitterDebugMode, 1, "blend");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackGlitterDebugMode, 2, "color");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackGlitterDebugMode, 3, "averageColor");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackGlitterDebugMode, 4, "footprintArea");
sceneClass.setEnumValue(DwaLayerMaterial_attr::attrFallbackGlitterDebugMode, 5, "radius");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterDebugMode, "label", "fallback glitter debug mode");
sceneClass.setMetadata(DwaLayerMaterial_attr::attrFallbackGlitterDebugMode, "comment", "developer debug visualization modes.  This parameter will only be used when layering two distinct glitter materials.");
static const char *labels[] = {
    "glitter",
    "hair",
    "hair R",
    "hair TT",
    "hair TRT",
    "hair TRRT",
    "hair diffuse",
    "fuzz",
    "outer specular",
    "specular",
    "diffuse",
    "specular transmission",
    "diffuse transmission",
    nullptr
};
sceneClass.declareDataPtr("labels", labels);
rdl2_dso_interface |= INTERFACE_DWABASELAYERABLE;
RDL2_DSO_ATTR_END
using namespace DwaLayerMaterial_attr;
