#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(DwaTwoSidedMaterial_attr)
AttributeKey<SceneObject*> attrFrontMaterial;
AttributeKey<SceneObject*> attrBackMaterial;
AttributeKey<Int> attrFallbackBSSRDF;
AttributeKey<Int> attrFallbackSpecularModel;
AttributeKey<Int> attrFallbackOuterSpecularModel;
AttributeKey<Bool> attrFallbackOuterSpecularUseBending;
AttributeKey<Bool> attrFallbackPreventLightCulling;
AttributeKey<SceneObject*> attrSubsurfaceTraceSet;
RDL2_DSO_ATTR_DEFINE(Material)
DwaTwoSidedMaterial_attr::attrFrontMaterial = sceneClass.declareAttribute<SceneObject*>("front_material", FLAGS_NONE, INTERFACE_DWABASELAYERABLE, {});
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFrontMaterial, "label", "front material");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFrontMaterial, "comment", "material to use on front-facing surfaces");
DwaTwoSidedMaterial_attr::attrBackMaterial = sceneClass.declareAttribute<SceneObject*>("back_material", FLAGS_NONE, INTERFACE_DWABASELAYERABLE, {});
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrBackMaterial, "label", "back material");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrBackMaterial, "comment", "material to use on back-facing surfaces");
DwaTwoSidedMaterial_attr::attrFallbackBSSRDF = sceneClass.declareAttribute<Int>("fallback_bssrdf", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaTwoSidedMaterial_attr::attrFallbackBSSRDF);
sceneClass.setEnumValue(DwaTwoSidedMaterial_attr::attrFallbackBSSRDF, 0, "normalized diffusion");
sceneClass.setEnumValue(DwaTwoSidedMaterial_attr::attrFallbackBSSRDF, 1, "dipole");
sceneClass.setEnumValue(DwaTwoSidedMaterial_attr::attrFallbackBSSRDF, 2, "random walk");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFallbackBSSRDF, "label", "fallback bssrdf");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFallbackBSSRDF, "comment", "If the two materials disagree on the type of bssrdf, this type will be used instead.");
DwaTwoSidedMaterial_attr::attrFallbackSpecularModel = sceneClass.declareAttribute<Int>("fallback_specular_model", 1, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaTwoSidedMaterial_attr::attrFallbackSpecularModel);
sceneClass.setEnumValue(DwaTwoSidedMaterial_attr::attrFallbackSpecularModel, 0, "Beckmann");
sceneClass.setEnumValue(DwaTwoSidedMaterial_attr::attrFallbackSpecularModel, 1, "GGX");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFallbackSpecularModel, "label", "fallback specular model");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFallbackSpecularModel, "comment", "If child materials disagree on the type of specular model, this type will be used instead.");
DwaTwoSidedMaterial_attr::attrFallbackOuterSpecularModel = sceneClass.declareAttribute<Int>("fallback_outer_specular_model", 1, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaTwoSidedMaterial_attr::attrFallbackOuterSpecularModel);
sceneClass.setEnumValue(DwaTwoSidedMaterial_attr::attrFallbackOuterSpecularModel, 0, "Beckmann");
sceneClass.setEnumValue(DwaTwoSidedMaterial_attr::attrFallbackOuterSpecularModel, 1, "GGX");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFallbackOuterSpecularModel, "label", "fallback outer specular model");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFallbackOuterSpecularModel, "comment", "If child materials disagree on the type of outer specular model, this type will be used instead.");
DwaTwoSidedMaterial_attr::attrFallbackOuterSpecularUseBending = sceneClass.declareAttribute<Bool>("fallback_clearcoat_use_bending", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaTwoSidedMaterial_attr::attrFallbackOuterSpecularUseBending);
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFallbackOuterSpecularUseBending, "label", "fallback clearcoat use bending");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFallbackOuterSpecularUseBending, "comment", "If child materials disagree on the type of clearcoat use bending, this type will be used instead.");
DwaTwoSidedMaterial_attr::attrFallbackPreventLightCulling = sceneClass.declareAttribute<Bool>("fallback_prevent_light_culling", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", DwaTwoSidedMaterial_attr::attrFallbackPreventLightCulling);
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFallbackPreventLightCulling, "label", "fallback prevent light culling");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrFallbackPreventLightCulling, "comment", "If child materials disagree on prevent light culling, this will be used instead.");
DwaTwoSidedMaterial_attr::attrSubsurfaceTraceSet = sceneClass.declareAttribute<SceneObject*>("sss_trace_set", FLAGS_NONE, INTERFACE_TRACESET, {"sss trace set"});
sceneClass.setGroup("Advanced", DwaTwoSidedMaterial_attr::attrSubsurfaceTraceSet);
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrSubsurfaceTraceSet, "label", "sss trace set");
sceneClass.setMetadata(DwaTwoSidedMaterial_attr::attrSubsurfaceTraceSet, "comment", "By default, only the geometry associated with this material contributes to subsurface. The DwaTwoSidedMaterial ignores the sss trace sets of the submaterials. If you want adjacent geometry with different material to contribute as well, specify all those parts here.");
static const char *labels[] = {
    "glitter",
    "hair",
    "hair R",
    "hair TT",
    "hair TRT",
    "hair TRRT",
    "hair diffuse",
    "fuzz",
    "outer specular",
    "specular",
    "diffuse",
    "specular transmission",
    "diffuse transmission",
    nullptr
};
sceneClass.declareDataPtr("labels", labels);
rdl2_dso_interface |= INTERFACE_DWABASELAYERABLE;
RDL2_DSO_ATTR_END
using namespace DwaTwoSidedMaterial_attr;
