#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(HairMaterial_v3_attr)
AttributeKey<Float> attrPresence;
AttributeKey<Bool> attrCastsCaustics;
AttributeKey<Rgb> attrHairColor;
AttributeKey<Float> attrRefractiveIndex;
AttributeKey<Int> attrFresnelType;
AttributeKey<Float> attrCuticleLayerThickness;
AttributeKey<Bool> attrShowR;
AttributeKey<Float> attrROffset;
AttributeKey<Float> attrRRoughness;
AttributeKey<Rgb> attrRTintColor;
AttributeKey<Bool> attrShowTRT;
AttributeKey<Float> attrTRTOffset;
AttributeKey<Bool> attrUseTRTRoughness;
AttributeKey<Float> attrTRTRoughness;
AttributeKey<Rgb> attrTRTTintColor;
AttributeKey<Bool> attrShowHairGlint;
AttributeKey<Float> attrGlintRoughness;
AttributeKey<Float> attrGlintEccentricity;
AttributeKey<Float> attrGlintMinTwists;
AttributeKey<Float> attrGlintMaxTwists;
AttributeKey<Float> attrGlintSaturation;
AttributeKey<Bool> attrShowTT;
AttributeKey<Float> attrTTOffset;
AttributeKey<Bool> attrUseTTRoughness;
AttributeKey<Float> attrTTRoughness;
AttributeKey<Float> attrTTAzimuthalRoughness;
AttributeKey<Rgb> attrTTTintColor;
AttributeKey<Float> attrTTSaturation;
AttributeKey<Bool> attrUseOptimizedSampling;
AttributeKey<Bool> attrShowTRRTPlus;
AttributeKey<Bool> attrShowEmission;
AttributeKey<Rgb> attrEmission;
RDL2_DSO_ATTR_DEFINE(Material)
HairMaterial_v3_attr::attrPresence = sceneClass.declareAttribute<Float>("presence", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Common", HairMaterial_v3_attr::attrPresence);
sceneClass.setMetadata(HairMaterial_v3_attr::attrPresence, "comment", "controls the visibility of this object. Useful for fading an object in/out, or to specify a cut-out mask on thin single-sided geometry (eg. a complex leaf texture on a simple card).");
HairMaterial_v3_attr::attrCastsCaustics = sceneClass.declareAttribute<Bool>("casts_caustics", false, FLAGS_NONE, INTERFACE_GENERIC, {"casts caustics"});
sceneClass.setGroup("Common", HairMaterial_v3_attr::attrCastsCaustics);
sceneClass.setMetadata(HairMaterial_v3_attr::attrCastsCaustics, "label", "casts caustics");
sceneClass.setMetadata(HairMaterial_v3_attr::attrCastsCaustics, "comment", "allows continuation of caustic light paths.");
HairMaterial_v3_attr::attrHairColor = sceneClass.declareAttribute<Rgb>("hair_color", Rgb(1.0, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"hair color"});
sceneClass.setMetadata(HairMaterial_v3_attr::attrHairColor, "label", "hair color");
HairMaterial_v3_attr::attrRefractiveIndex = sceneClass.declareAttribute<Float>("refractive_index", 1.45f, FLAGS_NONE, INTERFACE_GENERIC, {"refractive index"});
sceneClass.setGroup("Fresnel", HairMaterial_v3_attr::attrRefractiveIndex);
sceneClass.setMetadata(HairMaterial_v3_attr::attrRefractiveIndex, "label", "refractive index");
sceneClass.setMetadata(HairMaterial_v3_attr::attrRefractiveIndex, "comment", "keep this value between [1.3,2.0] for realistic behavior (human hair is around 1.55)");
HairMaterial_v3_attr::attrFresnelType = sceneClass.declareAttribute<Int>("fresnel_type", 1, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Fresnel", HairMaterial_v3_attr::attrFresnelType);
sceneClass.setEnumValue(HairMaterial_v3_attr::attrFresnelType, 0, "simple longitudinal");
sceneClass.setEnumValue(HairMaterial_v3_attr::attrFresnelType, 1, "dielectric cylinder");
sceneClass.setEnumValue(HairMaterial_v3_attr::attrFresnelType, 2, "layered cuticles");
sceneClass.setMetadata(HairMaterial_v3_attr::attrFresnelType, "label", "fresnel type");
HairMaterial_v3_attr::attrCuticleLayerThickness = sceneClass.declareAttribute<Float>("cuticle_layer_thickness", 0.1f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Fresnel", HairMaterial_v3_attr::attrCuticleLayerThickness);
sceneClass.setMetadata(HairMaterial_v3_attr::attrCuticleLayerThickness, "label", "cuticle layer thickness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrCuticleLayerThickness, "enable if", "OrderedDict({'fresnel_type': 'layered cuticles'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrCuticleLayerThickness, "min", "0.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrCuticleLayerThickness, "max", "1.0f");
HairMaterial_v3_attr::attrShowR = sceneClass.declareAttribute<Bool>("show_primary_specular", true, FLAGS_NONE, INTERFACE_GENERIC, {"show primary specular"});
sceneClass.setGroup("Primary Specular", HairMaterial_v3_attr::attrShowR);
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowR, "label", "show primary specular");
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowR, "comment", "show primary specular");
HairMaterial_v3_attr::attrROffset = sceneClass.declareAttribute<Float>("primary_specular_offset", -3.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"primary specular offset"});
sceneClass.setGroup("Primary Specular", HairMaterial_v3_attr::attrROffset);
sceneClass.setMetadata(HairMaterial_v3_attr::attrROffset, "label", "primary specular offset");
sceneClass.setMetadata(HairMaterial_v3_attr::attrROffset, "comment", "offset specular highlight along hair direction (in degrees) [-10,+10], around -3 for human hair");
sceneClass.setMetadata(HairMaterial_v3_attr::attrROffset, "enable if", "OrderedDict({'show_primary_specular': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrROffset, "min", "-10.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrROffset, "max", "10.0f");
HairMaterial_v3_attr::attrRRoughness = sceneClass.declareAttribute<Float>("primary_specular_roughness", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"primary specular roughness"});
sceneClass.setGroup("Primary Specular", HairMaterial_v3_attr::attrRRoughness);
sceneClass.setMetadata(HairMaterial_v3_attr::attrRRoughness, "label", "primary specular roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrRRoughness, "comment", "roughness of the primary specular highlight, also sets the transmission roughness to 0.5x and secondary specular roughness to 2x by default unless independent roughnesses are being used for both");
sceneClass.setMetadata(HairMaterial_v3_attr::attrRRoughness, "enable if", "OrderedDict({'show_primary_specular': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrRRoughness, "min", "0.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrRRoughness, "max", "1.0f");
HairMaterial_v3_attr::attrRTintColor = sceneClass.declareAttribute<Rgb>("primary_specular_tint", Rgb(1.0, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"primary specular tint"});
sceneClass.setGroup("Primary Specular", HairMaterial_v3_attr::attrRTintColor);
sceneClass.setMetadata(HairMaterial_v3_attr::attrRTintColor, "label", "primary specular tint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrRTintColor, "comment", "tint the primary specular highlight with this color (leave white for physical behavior)");
sceneClass.setMetadata(HairMaterial_v3_attr::attrRTintColor, "enable if", "OrderedDict({'show_primary_specular': 'true'})");
HairMaterial_v3_attr::attrShowTRT = sceneClass.declareAttribute<Bool>("show_secondary_specular", true, FLAGS_NONE, INTERFACE_GENERIC, {"show secondary specular"});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrShowTRT);
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowTRT, "label", "show secondary specular");
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowTRT, "comment", "show secondary specular");
HairMaterial_v3_attr::attrTRTOffset = sceneClass.declareAttribute<Float>("secondary_specular_offset", -4.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"secondary specular offset"});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrTRTOffset);
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTOffset, "label", "secondary specular offset");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTOffset, "comment", "offset secondary specular highlight along hair direction (in degrees) [-10,+10], around -4.5 for human hair");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTOffset, "enable if", "OrderedDict({'show_secondary_specular': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTOffset, "min", "-10.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTOffset, "max", "10.0f");
HairMaterial_v3_attr::attrUseTRTRoughness = sceneClass.declareAttribute<Bool>("use_independent_secondary_specular_roughness", false, FLAGS_NONE, INTERFACE_GENERIC, {"use independent secondary specular roughness"});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrUseTRTRoughness);
sceneClass.setMetadata(HairMaterial_v3_attr::attrUseTRTRoughness, "label", "use independent secondary specular roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrUseTRTRoughness, "comment", "when disabled, uses a physically correct value for secondary specular roughness which is linked to the primary specular roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrUseTRTRoughness, "enable if", "OrderedDict({'show_secondary_specular': 'true'})");
HairMaterial_v3_attr::attrTRTRoughness = sceneClass.declareAttribute<Float>("independent_secondary_specular_roughness", 0.4f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"independent secondary specular roughness"});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrTRTRoughness);
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTRoughness, "label", "independent secondary specular roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTRoughness, "comment", "secondary specular roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTRoughness, "enable if", "OrderedDict({'show_secondary_specular': 'true', 'use_independent_secondary_specular_roughness': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTRoughness, "min", "0.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTRoughness, "max", "1.0f");
HairMaterial_v3_attr::attrTRTTintColor = sceneClass.declareAttribute<Rgb>("secondary_specular_tint", Rgb(1.0, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"secondary specular tint"});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrTRTTintColor);
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTTintColor, "label", "secondary specular tint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTTintColor, "comment", "tint secondary specular with this color (leave white for physical behavior)");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTRTTintColor, "enable if", "OrderedDict({'show_secondary_specular': 'true'})");
HairMaterial_v3_attr::attrShowHairGlint = sceneClass.declareAttribute<Bool>("show_hair_glint", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrShowHairGlint);
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowHairGlint, "label", "show hair glint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowHairGlint, "comment", "show hair glint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowHairGlint, "subgroup", "Glint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowHairGlint, "enable if", "OrderedDict({'show_secondary_specular': 'true'})");
HairMaterial_v3_attr::attrGlintRoughness = sceneClass.declareAttribute<Float>("glint_roughness", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrGlintRoughness);
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintRoughness, "label", "glint roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintRoughness, "comment", "secondary specular glint roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintRoughness, "subgroup", "Glint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintRoughness, "enable if", "OrderedDict({'show_secondary_specular': 'true', 'show_hair_glint': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintRoughness, "min", "0.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintRoughness, "max", "1.0f");
HairMaterial_v3_attr::attrGlintEccentricity = sceneClass.declareAttribute<Float>("glint_eccentricity", 0.85f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrGlintEccentricity);
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintEccentricity, "label", "glint eccentricity");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintEccentricity, "comment", "secondary specular glint eccentricity [0.85, 1], values that deviate from 1 make the hair fiber more elliptical and more glinty");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintEccentricity, "subgroup", "Glint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintEccentricity, "enable if", "OrderedDict({'show_secondary_specular': 'true', 'show_hair_glint': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintEccentricity, "min", "0.85f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintEccentricity, "max", "1.0f");
HairMaterial_v3_attr::attrGlintMinTwists = sceneClass.declareAttribute<Float>("glint_min_twists", 1.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrGlintMinTwists);
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintMinTwists, "label", "glint min twists");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintMinTwists, "comment", "the minimum number of twists along the hair's length. More twists means more glints. Each hair strand will be randomly assigned a twist amount between [min twists, max twists]");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintMinTwists, "subgroup", "Glint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintMinTwists, "enable if", "OrderedDict({'show_secondary_specular': 'true', 'show_hair_glint': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintMinTwists, "min", "0.0f");
HairMaterial_v3_attr::attrGlintMaxTwists = sceneClass.declareAttribute<Float>("glint_max_twists", 2.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrGlintMaxTwists);
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintMaxTwists, "label", "glint max twists");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintMaxTwists, "comment", "the maximum number of twists along the hair's length. More twists means more glints. Each hair strand will be randomly assigned a twist amount between [min twists, max twists]");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintMaxTwists, "subgroup", "Glint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintMaxTwists, "enable if", "OrderedDict({'show_secondary_specular': 'true', 'show_hair_glint': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintMaxTwists, "min", "0.0f");
HairMaterial_v3_attr::attrGlintSaturation = sceneClass.declareAttribute<Float>("glint_saturation", 0.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Secondary Specular", HairMaterial_v3_attr::attrGlintSaturation);
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintSaturation, "label", "glint saturation");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintSaturation, "comment", "secondary specular glint saturation");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintSaturation, "subgroup", "Glint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintSaturation, "enable if", "OrderedDict({'show_secondary_specular': 'true', 'show_hair_glint': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintSaturation, "min", "0.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrGlintSaturation, "max", "1.0f");
HairMaterial_v3_attr::attrShowTT = sceneClass.declareAttribute<Bool>("show_transmission", true, FLAGS_NONE, INTERFACE_GENERIC, {"show transmission"});
sceneClass.setGroup("Transmission", HairMaterial_v3_attr::attrShowTT);
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowTT, "label", "show transmission");
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowTT, "comment", "show tranmission specular");
HairMaterial_v3_attr::attrTTOffset = sceneClass.declareAttribute<Float>("transmission_offset", -1.5f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"transmission offset"});
sceneClass.setGroup("Transmission", HairMaterial_v3_attr::attrTTOffset);
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTOffset, "label", "transmission offset");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTOffset, "comment", "offset transmission highlight along hair direction (in degrees) [-10,+10], around -1.5 for human hair");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTOffset, "enable if", "OrderedDict({'show_transmission': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTOffset, "min", "-10.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTOffset, "max", "10.0f");
HairMaterial_v3_attr::attrUseTTRoughness = sceneClass.declareAttribute<Bool>("use_independent_transmission_roughness", false, FLAGS_NONE, INTERFACE_GENERIC, {"use independent transmission roughness"});
sceneClass.setGroup("Transmission", HairMaterial_v3_attr::attrUseTTRoughness);
sceneClass.setMetadata(HairMaterial_v3_attr::attrUseTTRoughness, "label", "use independent transmission roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrUseTTRoughness, "comment", "when disabled, uses a physically correct value for Transmission roughness which is linked to the primary specular roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrUseTTRoughness, "enable if", "OrderedDict({'show_transmission': 'true'})");
HairMaterial_v3_attr::attrTTRoughness = sceneClass.declareAttribute<Float>("independent_transmission_roughness", 0.1f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"independent transmission roughness"});
sceneClass.setGroup("Transmission", HairMaterial_v3_attr::attrTTRoughness);
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTRoughness, "label", "independent transmission roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTRoughness, "comment", "transmission roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTRoughness, "enable if", "OrderedDict({'show_transmission': 'true', 'use_independent_transmission_roughness': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTRoughness, "min", "0.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTRoughness, "max", "1.0f");
HairMaterial_v3_attr::attrTTAzimuthalRoughness = sceneClass.declareAttribute<Float>("transmission_azimuthal_roughness", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"transmission azimuthal roughness"});
sceneClass.setGroup("Transmission", HairMaterial_v3_attr::attrTTAzimuthalRoughness);
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTAzimuthalRoughness, "label", "transmission azimuthal roughness");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTAzimuthalRoughness, "comment", "higher values create a softer look");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTAzimuthalRoughness, "enable if", "OrderedDict({'show_transmission': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTAzimuthalRoughness, "min", "0.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTAzimuthalRoughness, "max", "1.0f");
HairMaterial_v3_attr::attrTTTintColor = sceneClass.declareAttribute<Rgb>("transmission_tint", Rgb(1.0, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"transmission tint"});
sceneClass.setGroup("Transmission", HairMaterial_v3_attr::attrTTTintColor);
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTTintColor, "label", "transmission tint");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTTintColor, "comment", "tint transmission with this color (leave white for physical behavior)");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTTintColor, "enable if", "OrderedDict({'show_transmission': 'true'})");
HairMaterial_v3_attr::attrTTSaturation = sceneClass.declareAttribute<Float>("direct_transmission_saturation", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Transmission", HairMaterial_v3_attr::attrTTSaturation);
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTSaturation, "label", "direct transmission saturation");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTSaturation, "comment", "(Non-Physical, Advanced) saturate/desaturate direct transmission highlights.");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTSaturation, "subgroup", "Advanced");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTSaturation, "enable if", "OrderedDict({'show_transmission': 'true'})");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTSaturation, "min", "0.0f");
sceneClass.setMetadata(HairMaterial_v3_attr::attrTTSaturation, "max", "4.0f");
HairMaterial_v3_attr::attrUseOptimizedSampling = sceneClass.declareAttribute<Bool>("use_optimized_sampling", true, FLAGS_NONE, INTERFACE_GENERIC, {"use optimized sampling"});
sceneClass.setGroup("Advanced", HairMaterial_v3_attr::attrUseOptimizedSampling);
sceneClass.setMetadata(HairMaterial_v3_attr::attrUseOptimizedSampling, "display_name", "use optimized sampling");
sceneClass.setMetadata(HairMaterial_v3_attr::attrUseOptimizedSampling, "comment", "optimized sampling of all the hair lobes, results in 2x-4x speedup on average (disables individual hair lobe AOVs). When false, the look may slightly change if using biased techniques like roughness/sample clamping. ");
HairMaterial_v3_attr::attrShowTRRTPlus = sceneClass.declareAttribute<Bool>("show_multiple_scattering", true, FLAGS_NONE, INTERFACE_GENERIC, {"show multiple scattering"});
sceneClass.setGroup("Advanced", HairMaterial_v3_attr::attrShowTRRTPlus);
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowTRRTPlus, "label", "show multiple scattering");
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowTRRTPlus, "comment", "show the amount of light scattered after TRT bounce, good for blonde/white hair");
HairMaterial_v3_attr::attrShowEmission = sceneClass.declareAttribute<Bool>("show_emission", false, FLAGS_NONE, INTERFACE_GENERIC, {"show emission"});
sceneClass.setGroup("Emission", HairMaterial_v3_attr::attrShowEmission);
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowEmission, "label", "show emission");
sceneClass.setMetadata(HairMaterial_v3_attr::attrShowEmission, "comment", "enables/disable emission");
HairMaterial_v3_attr::attrEmission = sceneClass.declareAttribute<Rgb>("emission", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"emission color", "emission_color"});
sceneClass.setGroup("Emission", HairMaterial_v3_attr::attrEmission);
sceneClass.setMetadata(HairMaterial_v3_attr::attrEmission, "comment", "the energy emitted from this material");
sceneClass.setMetadata(HairMaterial_v3_attr::attrEmission, "enable if", "OrderedDict({'show_emission': 'true'})");
static const char *labels[] = {
    "glitter",
    "hair",
    "hair R",
    "hair TT",
    "hair TRT",
    "hair TRRT",
    "hair diffuse",
    "fuzz",
    "outer specular",
    "specular",
    "diffuse",
    "specular transmission",
    "diffuse transmission",
    nullptr
};
sceneClass.declareDataPtr("labels", labels);
rdl2_dso_interface |= INTERFACE_DWABASEHAIRLAYERABLE;
RDL2_DSO_ATTR_END
using namespace HairMaterial_v3_attr;
