#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(HairColorCorrectMaterial_attr)
AttributeKey<SceneObject*> attrInputMaterial;
AttributeKey<Bool> attrOn;
AttributeKey<Float> attrMix;
AttributeKey<Float> attrHueShift;
AttributeKey<Float> attrSaturation;
AttributeKey<Float> attrGain;
AttributeKey<Bool> attrTMIEnabled;
AttributeKey<Rgb> attrTMI;
RDL2_DSO_ATTR_DEFINE(Material)
HairColorCorrectMaterial_attr::attrInputMaterial = sceneClass.declareAttribute<SceneObject*>("input_hair_material", FLAGS_NONE, INTERFACE_DWABASEHAIRLAYERABLE, {});
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrInputMaterial, "label", "input hair material");
HairColorCorrectMaterial_attr::attrOn = sceneClass.declareAttribute<Bool>("on", true, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrOn, "comment", "Enable/disable all color corrections");
HairColorCorrectMaterial_attr::attrMix = sceneClass.declareAttribute<Float>("mix", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrMix, "comment", "how much of the overall color correct to mix in");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrMix, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrMix, "min", "0.0f");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrMix, "max", "1.0f");
HairColorCorrectMaterial_attr::attrHueShift = sceneClass.declareAttribute<Float>("hue_shift", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Hue/Sat/Gain", HairColorCorrectMaterial_attr::attrHueShift);
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrHueShift, "label", "hue shift");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrHueShift, "comment", "shifts the hue of the input (spectrum range is 0-1)");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrHueShift, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrHueShift, "min", "0.0f");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrHueShift, "max", "1.0f");
HairColorCorrectMaterial_attr::attrSaturation = sceneClass.declareAttribute<Float>("saturation", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Hue/Sat/Gain", HairColorCorrectMaterial_attr::attrSaturation);
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrSaturation, "comment", "desaturates the input below 1.0 and adds saturation above 1.0");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrSaturation, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrSaturation, "min", "0.0f");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrSaturation, "max", "1.0f");
HairColorCorrectMaterial_attr::attrGain = sceneClass.declareAttribute<Float>("gain", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Hue/Sat/Gain", HairColorCorrectMaterial_attr::attrGain);
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrGain, "comment", "multiplies the input channels by the specified value");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrGain, "enable if", "OrderedDict({'on': 'true'})");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrGain, "min", "0.0f");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrGain, "max", "4.0f");
HairColorCorrectMaterial_attr::attrTMIEnabled = sceneClass.declareAttribute<Bool>("TMI_enabled", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("TMI", HairColorCorrectMaterial_attr::attrTMIEnabled);
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrTMIEnabled, "label", "TMI enabled");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrTMIEnabled, "comment", "enables the TMI parameters");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrTMIEnabled, "enable if", "OrderedDict({'on': 'true'})");
HairColorCorrectMaterial_attr::attrTMI = sceneClass.declareAttribute<Rgb>("TMI", Rgb(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("TMI", HairColorCorrectMaterial_attr::attrTMI);
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrTMI, "display", "tmi");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrTMI, "comment", "T = Temperature where positive values push towards blue and negative towards red.   M = Magenta where positive values push towards magenta and negative towards green.  I = Intensity where negative values remove and positive values add energy ");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrTMI, "enable if", "OrderedDict({'on': 'true', 'TMI_enabled': 'true'})");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrTMI, "min", "-2.0f");
sceneClass.setMetadata(HairColorCorrectMaterial_attr::attrTMI, "max", "2.0f");
static const char *labels[] = {
    "glitter",
    "hair",
    "hair R",
    "hair TT",
    "hair TRT",
    "hair TRRT",
    "hair diffuse",
    "fuzz",
    "outer specular",
    "specular",
    "diffuse",
    "specular transmission",
    "diffuse transmission",
    nullptr
};
sceneClass.declareDataPtr("labels", labels);
rdl2_dso_interface |= INTERFACE_DWABASEHAIRLAYERABLE;
RDL2_DSO_ATTR_END
using namespace HairColorCorrectMaterial_attr;
