#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(HairDiffuseMaterial_attr)
AttributeKey<Float> attrPresence;
AttributeKey<Bool> attrCastsCaustics;
AttributeKey<Rgb> attrHairColor;
AttributeKey<Bool> attrUseIndependentFrontAndBackHairColor;
AttributeKey<Rgb> attrFrontHairColor;
AttributeKey<Rgb> attrBackHairColor;
AttributeKey<Float> attrHairSubsurfaceBlend;
AttributeKey<Int> attrHairSubsurface;
AttributeKey<Rgb> attrHairScatteringColor;
AttributeKey<Float> attrHairScatteringRadius;
AttributeKey<SceneObject*> attrHairSubsurfaceTraceSet;
AttributeKey<Bool> attrHairEnableSubsurfaceInputNormal;
AttributeKey<SceneObject*> attrHairInputNormal;
AttributeKey<Float> attrHairInputNormalDial;
AttributeKey<Bool> attrShowEmission;
AttributeKey<Rgb> attrEmission;
RDL2_DSO_ATTR_DEFINE(Material)
HairDiffuseMaterial_attr::attrPresence = sceneClass.declareAttribute<Float>("presence", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Common", HairDiffuseMaterial_attr::attrPresence);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrPresence, "comment", "controls the visibility of this object. Useful for fading an object in/out, or to specify a cut-out mask on thin single-sided geometry (eg. a complex leaf texture on a simple card).");
HairDiffuseMaterial_attr::attrCastsCaustics = sceneClass.declareAttribute<Bool>("casts_caustics", false, FLAGS_NONE, INTERFACE_GENERIC, {"casts caustics"});
sceneClass.setGroup("Common", HairDiffuseMaterial_attr::attrCastsCaustics);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrCastsCaustics, "label", "casts caustics");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrCastsCaustics, "comment", "allows continuation of caustic light paths.");
HairDiffuseMaterial_attr::attrHairColor = sceneClass.declareAttribute<Rgb>("hair_color", Rgb(1.0, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"hair color"});
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairColor, "label", "hair color");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairColor, "enable if", "OrderedDict({'use_independent_front_and_back_hair_color': 'false'})");
HairDiffuseMaterial_attr::attrUseIndependentFrontAndBackHairColor = sceneClass.declareAttribute<Bool>("use_independent_front_and_back_hair_color", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", HairDiffuseMaterial_attr::attrUseIndependentFrontAndBackHairColor);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrUseIndependentFrontAndBackHairColor, "label", "use independent front and back hair color");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrUseIndependentFrontAndBackHairColor, "comment", "(advanced) use a separate hair color for front and back");
HairDiffuseMaterial_attr::attrFrontHairColor = sceneClass.declareAttribute<Rgb>("front_hair_color", Rgb(1.0, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", HairDiffuseMaterial_attr::attrFrontHairColor);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrFrontHairColor, "label", "front hair color");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrFrontHairColor, "comment", "(advanced only) hair color used for front-lit hair (backward reflectance)");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrFrontHairColor, "enable if", "OrderedDict({'use_independent_front_and_back_hair_color': 'true'})");
HairDiffuseMaterial_attr::attrBackHairColor = sceneClass.declareAttribute<Rgb>("back_hair_color", Rgb(1.0, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", HairDiffuseMaterial_attr::attrBackHairColor);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrBackHairColor, "label", "back hair color");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrBackHairColor, "comment", "(advanced only) hair color used for back-lit hair (transmission/forward reflectance)");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrBackHairColor, "enable if", "OrderedDict({'use_independent_front_and_back_hair_color': 'true'})");
HairDiffuseMaterial_attr::attrHairSubsurfaceBlend = sceneClass.declareAttribute<Float>("subsurface_blend", 1.0, FLAGS_BINDABLE, INTERFACE_GENERIC, {"subsurface blend"});
sceneClass.setGroup("Subsurface", HairDiffuseMaterial_attr::attrHairSubsurfaceBlend);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairSubsurfaceBlend, "label", "subsurface blend");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairSubsurfaceBlend, "comment", "0 is fully hair diffuse, 1 is fully SSS. No effect if scattering radius is 0.");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairSubsurfaceBlend, "min", "0.0f");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairSubsurfaceBlend, "max", "1.0f");
HairDiffuseMaterial_attr::attrHairSubsurface = sceneClass.declareAttribute<Int>("bssrdf", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Subsurface", HairDiffuseMaterial_attr::attrHairSubsurface);
sceneClass.setEnumValue(HairDiffuseMaterial_attr::attrHairSubsurface, 0, "normalized diffusion");
sceneClass.setEnumValue(HairDiffuseMaterial_attr::attrHairSubsurface, 1, "dipole");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairSubsurface, "comment", "0 for NormalizedDiffuse, 1 for Dipole. Random walk unsupported for hair.");
HairDiffuseMaterial_attr::attrHairScatteringColor = sceneClass.declareAttribute<Rgb>("scattering_color", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"scattering color"});
sceneClass.setGroup("Subsurface", HairDiffuseMaterial_attr::attrHairScatteringColor);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairScatteringColor, "label", "scattering color");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairScatteringColor, "comment", "the subsurface scattering 'falloff' color");
HairDiffuseMaterial_attr::attrHairScatteringRadius = sceneClass.declareAttribute<Float>("scattering_radius", 0.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"scattering radius"});
sceneClass.setGroup("Subsurface", HairDiffuseMaterial_attr::attrHairScatteringRadius);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairScatteringRadius, "label", "scattering radius");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairScatteringRadius, "comment", "the distance the light scatters beneath the surface.  When 0 surface diffuse is used");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairScatteringRadius, "min", "0.0f");
HairDiffuseMaterial_attr::attrHairSubsurfaceTraceSet = sceneClass.declareAttribute<SceneObject*>("sss_trace_set", FLAGS_NONE, INTERFACE_TRACESET, {"sss trace set"});
sceneClass.setGroup("Advanced", HairDiffuseMaterial_attr::attrHairSubsurfaceTraceSet);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairSubsurfaceTraceSet, "label", "sss trace set");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairSubsurfaceTraceSet, "comment", "Set of geometries that contribute neighboring subsurface points. By default, only the geometry associated with this material contributes to subsurface. If you want adjacent geometry with different material to contribute as well, specify all those parts here.");
HairDiffuseMaterial_attr::attrHairEnableSubsurfaceInputNormal = sceneClass.declareAttribute<Bool>("enable_sss_input_normal", false, FLAGS_NONE, INTERFACE_GENERIC, {"enable sss input normal"});
sceneClass.setGroup("Subsurface", HairDiffuseMaterial_attr::attrHairEnableSubsurfaceInputNormal);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairEnableSubsurfaceInputNormal, "label", "enable sss input normal");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairEnableSubsurfaceInputNormal, "comment", "enables sampling the normal map for sss samples. More accurate but potentially expensive");
HairDiffuseMaterial_attr::attrHairInputNormal = sceneClass.declareAttribute<SceneObject*>("input_normal", FLAGS_NONE, INTERFACE_NORMALMAP, {"input normal"});
sceneClass.setGroup("Subsurface", HairDiffuseMaterial_attr::attrHairInputNormal);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairInputNormal, "label", "input normal");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairInputNormal, "comment", "specifies an alternate shading normal (only for SSS lobe)");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairInputNormal, "enable if", "OrderedDict({'enable_sss_input_normal': 'true'})");
HairDiffuseMaterial_attr::attrHairInputNormalDial = sceneClass.declareAttribute<Float>("input_normal_dial", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {"input normal dial"});
sceneClass.setGroup("Subsurface", HairDiffuseMaterial_attr::attrHairInputNormalDial);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairInputNormalDial, "label", "input normal dial");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairInputNormalDial, "comment", "controls influence of input normal versus hair normal for SSS");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairInputNormalDial, "enable if", "OrderedDict({'enable_sss_input_normal': 'true'})");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairInputNormalDial, "min", "0.0f");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrHairInputNormalDial, "max", "1.0f");
HairDiffuseMaterial_attr::attrShowEmission = sceneClass.declareAttribute<Bool>("show_emission", false, FLAGS_NONE, INTERFACE_GENERIC, {"show emission"});
sceneClass.setGroup("Emission", HairDiffuseMaterial_attr::attrShowEmission);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrShowEmission, "label", "show emission");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrShowEmission, "comment", "enables/disable emission");
HairDiffuseMaterial_attr::attrEmission = sceneClass.declareAttribute<Rgb>("emission", Rgb(1.0f, 1.0f, 1.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"emission color", "emission_color"});
sceneClass.setGroup("Emission", HairDiffuseMaterial_attr::attrEmission);
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrEmission, "comment", "the energy emitted from this material");
sceneClass.setMetadata(HairDiffuseMaterial_attr::attrEmission, "enable if", "OrderedDict({'show_emission': 'true'})");
static const char *labels[] = {
    "glitter",
    "hair",
    "hair R",
    "hair TT",
    "hair TRT",
    "hair TRRT",
    "hair diffuse",
    "fuzz",
    "outer specular",
    "specular",
    "diffuse",
    "specular transmission",
    "diffuse transmission",
    nullptr
};
sceneClass.declareDataPtr("labels", labels);
rdl2_dso_interface |= INTERFACE_DWABASEHAIRLAYERABLE;
RDL2_DSO_ATTR_END
using namespace HairDiffuseMaterial_attr;
