#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(HairLayerMaterial_attr)
AttributeKey<SceneObject*> attrHairMaterialA;
AttributeKey<SceneObject*> attrHairMaterialB;
AttributeKey<Float> attrMask;
AttributeKey<Int> attrColorSpace;
AttributeKey<Int> attrFallbackBSSRDF;
RDL2_DSO_ATTR_DEFINE(Material)
HairLayerMaterial_attr::attrHairMaterialA = sceneClass.declareAttribute<SceneObject*>("hair_material_A", FLAGS_NONE, INTERFACE_DWABASEHAIRLAYERABLE, {"hair material A"});
sceneClass.setMetadata(HairLayerMaterial_attr::attrHairMaterialA, "label", "hair material A");
sceneClass.setMetadata(HairLayerMaterial_attr::attrHairMaterialA, "comment", "foreground hair material");
HairLayerMaterial_attr::attrHairMaterialB = sceneClass.declareAttribute<SceneObject*>("hair_material_B", FLAGS_NONE, INTERFACE_DWABASEHAIRLAYERABLE, {"hair material B"});
sceneClass.setMetadata(HairLayerMaterial_attr::attrHairMaterialB, "label", "hair material B");
sceneClass.setMetadata(HairLayerMaterial_attr::attrHairMaterialB, "comment", "background hair material");
HairLayerMaterial_attr::attrMask = sceneClass.declareAttribute<Float>("mask", 1.0f, FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(HairLayerMaterial_attr::attrMask, "comment", "foreground hair material weight");
sceneClass.setMetadata(HairLayerMaterial_attr::attrMask, "min", "0.0");
sceneClass.setMetadata(HairLayerMaterial_attr::attrMask, "max", "1.0");
HairLayerMaterial_attr::attrColorSpace = sceneClass.declareAttribute<Int>("blend_color_space", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", HairLayerMaterial_attr::attrColorSpace);
sceneClass.setEnumValue(HairLayerMaterial_attr::attrColorSpace, 0, "RGB");
sceneClass.setEnumValue(HairLayerMaterial_attr::attrColorSpace, 1, "HSV");
sceneClass.setEnumValue(HairLayerMaterial_attr::attrColorSpace, 2, "HSL");
sceneClass.setMetadata(HairLayerMaterial_attr::attrColorSpace, "label", "blend color space");
sceneClass.setMetadata(HairLayerMaterial_attr::attrColorSpace, "comment", "Color space used when blending the two material's color parameters");
HairLayerMaterial_attr::attrFallbackBSSRDF = sceneClass.declareAttribute<Int>("fallback_bssrdf", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Advanced", HairLayerMaterial_attr::attrFallbackBSSRDF);
sceneClass.setEnumValue(HairLayerMaterial_attr::attrFallbackBSSRDF, 0, "normalized diffusion");
sceneClass.setEnumValue(HairLayerMaterial_attr::attrFallbackBSSRDF, 1, "dipole");
sceneClass.setMetadata(HairLayerMaterial_attr::attrFallbackBSSRDF, "label", "fallback bssrdf");
sceneClass.setMetadata(HairLayerMaterial_attr::attrFallbackBSSRDF, "comment", "If child materials disagree on the type of bssrdf, this type will be used instead.");
static const char *labels[] = {
    "glitter",
    "hair",
    "hair R",
    "hair TT",
    "hair TRT",
    "hair TRRT",
    "hair diffuse",
    "fuzz",
    "outer specular",
    "specular",
    "diffuse",
    "specular transmission",
    "diffuse transmission",
    nullptr
};
sceneClass.declareDataPtr("labels", labels);
rdl2_dso_interface |= INTERFACE_DWABASEHAIRLAYERABLE;
RDL2_DSO_ATTR_END
using namespace HairLayerMaterial_attr;
