#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(DistortNormalMap_attr)
AttributeKey<Int> attrNoiseSpace;
AttributeKey<Vec3f> attrInputTextureCoordinate;
AttributeKey<Bool> attrUseInputVectors;
AttributeKey<Rgb> attrInputU;
AttributeKey<Rgb> attrInputV;
AttributeKey<Int> attrSeed;
AttributeKey<Vec3f> attrFrequencyU;
AttributeKey<Vec3f> attrFrequencyV;
AttributeKey<Float> attrAmplitudeU;
AttributeKey<Float> attrAmplitudeV;
AttributeKey<SceneObject*> attrInputNormals;
RDL2_DSO_ATTR_DEFINE(NormalMap)
DistortNormalMap_attr::attrNoiseSpace = sceneClass.declareAttribute<Int>("noise_space", 4, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setGroup("Space", DistortNormalMap_attr::attrNoiseSpace);
sceneClass.setEnumValue(DistortNormalMap_attr::attrNoiseSpace, 2, "world");
sceneClass.setEnumValue(DistortNormalMap_attr::attrNoiseSpace, 4, "object");
sceneClass.setEnumValue(DistortNormalMap_attr::attrNoiseSpace, 5, "reference");
sceneClass.setEnumValue(DistortNormalMap_attr::attrNoiseSpace, 6, "texture");
sceneClass.setEnumValue(DistortNormalMap_attr::attrNoiseSpace, 7, "input texture coordinates");
sceneClass.setEnumValue(DistortNormalMap_attr::attrNoiseSpace, 8, "hair_surface_uv");
sceneClass.setEnumValue(DistortNormalMap_attr::attrNoiseSpace, 9, "hair_closest_surface_uv");
sceneClass.setMetadata(DistortNormalMap_attr::attrNoiseSpace, "comment", "The space to calculate the noise in");
DistortNormalMap_attr::attrInputTextureCoordinate = sceneClass.declareAttribute<Vec3f>("input_texture_coordinates", Vec3f(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {"input texture coordinates"});
sceneClass.setGroup("Space", DistortNormalMap_attr::attrInputTextureCoordinate);
sceneClass.setMetadata(DistortNormalMap_attr::attrInputTextureCoordinate, "label", "input texture coordinates");
sceneClass.setMetadata(DistortNormalMap_attr::attrInputTextureCoordinate, "disable when", "{ noise_space != 7 }");
DistortNormalMap_attr::attrUseInputVectors = sceneClass.declareAttribute<Bool>("use_input_vectors", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DistortNormalMap_attr::attrUseInputVectors, "comment", "when checked, use input_U and V. otherwise use geometry dPds/t");
DistortNormalMap_attr::attrInputU = sceneClass.declareAttribute<Rgb>("input_U", Rgb(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DistortNormalMap_attr::attrInputU, "disable when", "{ use_input_vectors 0 }");
sceneClass.setMetadata(DistortNormalMap_attr::attrInputU, "comment", "input U / tangent for distortion");
DistortNormalMap_attr::attrInputV = sceneClass.declareAttribute<Rgb>("input_V", Rgb(0.0f, 0.0f, 0.0f), FLAGS_BINDABLE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DistortNormalMap_attr::attrInputV, "disable when", "{ use_input_vectors 0 }");
sceneClass.setMetadata(DistortNormalMap_attr::attrInputV, "comment", "input V / bitangent for distortion");
DistortNormalMap_attr::attrSeed = sceneClass.declareAttribute<Int>("seed", 0, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DistortNormalMap_attr::attrSeed, "comment", "the seed for the noise generation");
DistortNormalMap_attr::attrFrequencyU = sceneClass.declareAttribute<Vec3f>("frequency_U", Vec3f(1.0f, 1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DistortNormalMap_attr::attrFrequencyU, "comment", "controls noise frequency for U distortion");
DistortNormalMap_attr::attrFrequencyV = sceneClass.declareAttribute<Vec3f>("frequency_V", Vec3f(1.0f, 1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DistortNormalMap_attr::attrFrequencyV, "comment", "controls noise frequency for V distortion");
DistortNormalMap_attr::attrAmplitudeU = sceneClass.declareAttribute<Float>("amplitude_U", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DistortNormalMap_attr::attrAmplitudeU, "comment", "controls amplitude of U distortion");
sceneClass.setMetadata(DistortNormalMap_attr::attrAmplitudeU, "min", "0.0f");
sceneClass.setMetadata(DistortNormalMap_attr::attrAmplitudeU, "max", "1.0f");
DistortNormalMap_attr::attrAmplitudeV = sceneClass.declareAttribute<Float>("amplitude_V", 1.0f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(DistortNormalMap_attr::attrAmplitudeV, "comment", "controls amplitude of V distortion");
sceneClass.setMetadata(DistortNormalMap_attr::attrAmplitudeV, "min", "0.0f");
sceneClass.setMetadata(DistortNormalMap_attr::attrAmplitudeV, "max", "1.0f");
DistortNormalMap_attr::attrInputNormals = sceneClass.declareAttribute<SceneObject*>("input_normals", FLAGS_NONE, INTERFACE_NORMALMAP, {});
sceneClass.setMetadata(DistortNormalMap_attr::attrInputNormals, "comment", "optional input to distort. if not connected, use geom normals");
RDL2_DSO_ATTR_END
using namespace DistortNormalMap_attr;
