#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ProjectCameraNormalMap_attr)
AttributeKey<SceneObject*> attrProjector;
AttributeKey<Bool> attrProjectOnBackFaces;
AttributeKey<Bool> attrUseReferenceSpace;
AttributeKey<String> attrTexture;
AttributeKey<Int> attrAspectRatioSource;
AttributeKey<Float> attrCustomAspectRatio;
AttributeKey<Int> attrNormalEncoding;
RDL2_DSO_ATTR_DEFINE(NormalMap)
ProjectCameraNormalMap_attr::attrProjector = sceneClass.declareAttribute<SceneObject*>("projector", FLAGS_NONE, INTERFACE_CAMERA, {});
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrProjector, "comment", "The camera to project from");
ProjectCameraNormalMap_attr::attrProjectOnBackFaces = sceneClass.declareAttribute<Bool>("project_on_back_faces", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrProjectOnBackFaces, "label", "project on back faces");
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrProjectOnBackFaces, "comment", "Toggles whether camera projections appear on back faces");
ProjectCameraNormalMap_attr::attrUseReferenceSpace = sceneClass.declareAttribute<Bool>("use_reference_space", false, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrUseReferenceSpace, "label", "use reference space");
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrUseReferenceSpace, "comment", "Use reference space position (ref_P) and normals (ref_N)");
ProjectCameraNormalMap_attr::attrTexture = sceneClass.declareAttribute<String>("texture", FLAGS_FILENAME, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrTexture, "comment", "Filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
ProjectCameraNormalMap_attr::attrAspectRatioSource = sceneClass.declareAttribute<Int>("aspect_ratio_source", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectCameraNormalMap_attr::attrAspectRatioSource, 0, "from texture");
sceneClass.setEnumValue(ProjectCameraNormalMap_attr::attrAspectRatioSource, 1, "custom");
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrAspectRatioSource, "label", "aspect ratio source");
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrAspectRatioSource, "comment", "Whether to use the image and pixel aspect ratio of the texture being projected, or a custom aspect ratio");
ProjectCameraNormalMap_attr::attrCustomAspectRatio = sceneClass.declareAttribute<Float>("custom_aspect_ratio", 1.f, FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrCustomAspectRatio, "label", "custom aspect ratio");
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrCustomAspectRatio, "comment", "Custom aspect ratio for the projected texture to use when 'aspect_ratio_source' is set to 'custom'");
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrCustomAspectRatio, "enable if", "OrderedDict({'aspect_ratio_source': '1'})");
ProjectCameraNormalMap_attr::attrNormalEncoding = sceneClass.declareAttribute<Int>("normal_encoding", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"normal encoding"});
sceneClass.setEnumValue(ProjectCameraNormalMap_attr::attrNormalEncoding, 0, "[0,1]");
sceneClass.setEnumValue(ProjectCameraNormalMap_attr::attrNormalEncoding, 1, "[-1,1]");
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrNormalEncoding, "label", "normal encoding");
sceneClass.setMetadata(ProjectCameraNormalMap_attr::attrNormalEncoding, "comment", "Most normal maps are encoded [0,1].   Only certain rare floating point normal maps are encoded [-1,1]");
RDL2_DSO_ATTR_END
using namespace ProjectCameraNormalMap_attr;
