#include <scene_rdl2/scene/rdl2/rdl2.h>
using namespace scene_rdl2::rdl2;
RDL2_DSO_ATTR_DECLARE_NS(ProjectPlanarNormalMap_attr)
AttributeKey<Bool> attrUseReferenceSpace;
AttributeKey<String> attrTexture;
AttributeKey<Bool> attrWrapAround;
AttributeKey<Int> attrNormalEncoding;
AttributeKey<Int> attrProjectionMode;
AttributeKey<SceneObject*> attrProjector;
AttributeKey<Mat4d> attrProjectionMatrix;
AttributeKey<Int> attrTRSOrder;
AttributeKey<Int> attrRotationOrder;
AttributeKey<Vec3d> attrTranslate;
AttributeKey<Vec3d> attrRotate;
AttributeKey<Vec3d> attrScale;
RDL2_DSO_ATTR_DEFINE(NormalMap)
ProjectPlanarNormalMap_attr::attrUseReferenceSpace = sceneClass.declareAttribute<Bool>("use_reference_space", false, FLAGS_NONE, INTERFACE_GENERIC, {"use reference space"});
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrUseReferenceSpace, "label", "use reference space");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrUseReferenceSpace, "comment", "Use reference space position (ref_P) and normals (ref_N)");
ProjectPlanarNormalMap_attr::attrTexture = sceneClass.declareAttribute<String>("texture", FLAGS_FILENAME, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrTexture, "comment", "Filename that points to a texture .exr or .tx file (must be mip-mapped and tiled with maketx).");
ProjectPlanarNormalMap_attr::attrWrapAround = sceneClass.declareAttribute<Bool>("wrap_around", true, FLAGS_NONE, INTERFACE_GENERIC, {"wrap around"});
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrWrapAround, "label", "wrap around");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrWrapAround, "comment", "Controls whether to repeat (true) or clamp (false) the texture");
ProjectPlanarNormalMap_attr::attrNormalEncoding = sceneClass.declareAttribute<Int>("normal_encoding", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {"normal encoding"});
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrNormalEncoding, 0, "[0,1]");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrNormalEncoding, 1, "[-1,1]");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrNormalEncoding, "label", "normal encoding");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrNormalEncoding, "comment", "Most normal maps are encoded [0,1].   Only certain rare floating point normal maps are encoded [-1,1]");
ProjectPlanarNormalMap_attr::attrProjectionMode = sceneClass.declareAttribute<Int>("projection_mode", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrProjectionMode, 0, "projector");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrProjectionMode, 1, "projection_matrix");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrProjectionMode, 2, "TRS");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrProjectionMode, "comment", "Source parameters to use for projection transform");
ProjectPlanarNormalMap_attr::attrProjector = sceneClass.declareAttribute<SceneObject*>("projector", FLAGS_NONE, INTERFACE_NODE, {});
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrProjector, "enable if", "OrderedDict({'projection_mode': 'projector'})");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrProjector, "comment", "The object whose transform to use for projection when 'projection_mode' is set to 'projector'");
ProjectPlanarNormalMap_attr::attrProjectionMatrix = sceneClass.declareAttribute<Mat4d>("projection_matrix", Mat4d(1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrProjectionMatrix, "label", "projection matrix");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrProjectionMatrix, "enable if", "OrderedDict({'projection_mode': 'projection_matrix'})");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrProjectionMatrix, "comment", "The transform to use for projection when 'projection_mode' is set to 'projection_matrix'");
ProjectPlanarNormalMap_attr::attrTRSOrder = sceneClass.declareAttribute<Int>("TRS_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrTRSOrder, 0, "Scale Rot Trans");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrTRSOrder, 1, "Scale Trans Rot");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrTRSOrder, 2, "Rot Scale Trans");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrTRSOrder, 3, "Rot Trans Scale");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrTRSOrder, 4, "Trans Scale Rot");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrTRSOrder, 5, "Trans Rot Scale");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrTRSOrder, "label", "TRS order");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrTRSOrder, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrTRSOrder, "comment", "Order in which to apply transformations when 'projection_mode' is set to 'TRS'");
ProjectPlanarNormalMap_attr::attrRotationOrder = sceneClass.declareAttribute<Int>("rotation_order", 0, FLAGS_ENUMERABLE, INTERFACE_GENERIC, {});
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrRotationOrder, 0, "xyz");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrRotationOrder, 1, "xzy");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrRotationOrder, 2, "yxz");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrRotationOrder, 3, "yzx");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrRotationOrder, 4, "zxy");
sceneClass.setEnumValue(ProjectPlanarNormalMap_attr::attrRotationOrder, 5, "zyx");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrRotationOrder, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrRotationOrder, "comment", "Order in which to apply rotation transformations when 'projection_mode' is set to 'TRS'");
ProjectPlanarNormalMap_attr::attrTranslate = sceneClass.declareAttribute<Vec3d>("translate", Vec3d(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrTranslate, "label", "translate");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrTranslate, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrTranslate, "comment", "Translation of the projection transform when 'projection_mode' is set to 'TRS'");
ProjectPlanarNormalMap_attr::attrRotate = sceneClass.declareAttribute<Vec3d>("rotate", Vec3d(0.0f, 0.0f, 0.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrRotate, "label", "rotate");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrRotate, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrRotate, "comment", "Rotation of the projection transform when 'projection_mode' is set to 'TRS'");
ProjectPlanarNormalMap_attr::attrScale = sceneClass.declareAttribute<Vec3d>("scale", Vec3d(1.0f, 1.0f, 1.0f), FLAGS_NONE, INTERFACE_GENERIC, {});
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrScale, "label", "scale");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrScale, "enable if", "OrderedDict({'projection_mode': 'TRS'})");
sceneClass.setMetadata(ProjectPlanarNormalMap_attr::attrScale, "comment", "Scale of the projection transform when 'projection_mode' is set to 'TRS'");
RDL2_DSO_ATTR_END
using namespace ProjectPlanarNormalMap_attr;
